AirBuff = function(sourceEntity)
   local teamNumber = objc.get_team_number(sourceEntity)
   local enemyNumber = objc.get_enemy_team_number(sourceEntity)

   --Buff friendly flying units
   for _, ally in pairs(objc.list_entities(teamNumber)) do
      if objc.is_normal_unit(ally) and 
         (objc.is_air_unit(ally) or objc.is_air_ground_unit(ally)) then
         local currentDamageForBonus = objc.get_entity_value(ally, 'aiComponent.damageComponent.attackDamage')
         local damageBonus = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_DAMAGE_BUFF)
         currentDamageForBonus = math.ceil(currentDamageForBonus * 0.3)
         objc.set_entity_value_for_key(ally, ENTITY_VALUE_KEY_DAMAGE_BUFF, damageBonus + currentDamageForBonus)
         -- for debugging: objc.set_combat_text(ally, '' .. currentDamageForBonus)
      end
   end

   --Buff enemy flying units
   for _, enemy in pairs(objc.list_entities(enemyNumber)) do
      if objc.is_normal_unit(enemy) and 
         (objc.is_air_unit(enemy) or objc.is_air_ground_unit(enemy)) then
         local currentDamageForBonus = objc.get_entity_value(enemy, 'aiComponent.damageComponent.attackDamage')
         local damageBonus = objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_DAMAGE_BUFF)
         currentDamageForBonus = math.ceil(currentDamageForBonus * 0.3)
         objc.set_entity_value_for_key(enemy, ENTITY_VALUE_KEY_DAMAGE_BUFF, damageBonus + currentDamageForBonus)
         -- for debugging: objc.set_combat_text(enemy, '' .. currentDamageForBonus)
      end
   end


end
