local PRIMARY_TARGET_KEY = 'primaryTargetKey'
local SHIELD_VFX = 'imp_B_Shield.lvl'

B_ArmoredAirship_spawnTrigger = function(entity)
    objc.set_local_value(entity, PRIMARY_TARGET_KEY, 0)
end

B_ArmoredAirship_onAttackTrigger = function(sourceEntity, targetEntity)
    objc.set_local_value(sourceEntity, PRIMARY_TARGET_KEY, 0)
end

B_ArmoredAirship_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    local armorAmount = objc.get_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_ARMOR)
    local flashCutoff = objc.divide_with_floor(armorAmount * 10, 4)
    local originalDamage = damage + armorAmount
    if originalDamage <= flashCutoff then
        objc.play_vfx(targetEntity, SHIELD_VFX, NODE_IMPACT)
    end
    return damage
end