local HEALTH_TICK_KEY = 'healthTickAmountKey'
local DURATION_ROUNDS = 450

local SPAWN_UNIT_IDENTIFIER = 'B_Rifleman'
local NUM_UNITS_TO_SPAWN = 1
local SPAWN_OFFSET = 200
local SPAWN_TIME_ROUNDS = 60

B_Factory_spawnTrigger = function(entity)
    local maxHealth = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_HEALTH)
    local healthTickAmount = objc.divide_with_floor(maxHealth, DURATION_ROUNDS)
    objc.set_local_value(entity, HEALTH_TICK_KEY, healthTickAmount)
end

B_Factory_tickTrigger = function(entity)
    local healthTick = objc.get_local_value(entity, HEALTH_TICK_KEY)
    objc.inflict_direct_damage(entity, entity, healthTick)

    local spawnTick = objc.tick_timer(entity, 'spawnTickTimerKey', SPAWN_TIME_ROUNDS)
    if spawnTick == 0 then
        local entityPos = objc.get_entity_position(entity)
        local playerNumber = objc.get_player_number(entity)
        local xDir = 1
        if playerNumber == 2 or playerNumber == 4 then
            xDir = -1
        end
        objc.spawn_at_point(SPAWN_UNIT_IDENTIFIER, 1, playerNumber, entityPos[1] + (SPAWN_OFFSET * xDir), entityPos[2], xDir, 0)
    end
end