local HAS_UNFROZEN = 'hasUnFrozenKey'
local CARD_FREEZE_ROUNDS = 80
local ORIGINAL_CARD_DRAW_SPEED = 'originalCardDrawSpeed'
local TECH_IDLE_ANIMATION_STATE = 'techIdle'
local TECH_START_ANIMATION_NAME = 'WM_LegionBase_Prototype_Activate_01'
local FRAMES_IN_TECH_START_ANIMATION = 240
local TECH_FINISH_ANIMATION_NAME = 'WM_LegionBase_Prototype_Deactivate_01'
local FRAMES_IN_TECH_FINISH_ANIMATION = 30

B_ResearchBot_PowerPlant_spawnTrigger = function(entity)
   local playerNumber = objc.get_player_number(entity)
   objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_INCOME_TIER, 2)
   objc.pause_card_draw(playerNumber)

   local updatedAnimations = {}
   updatedAnimations[ANIMATION_STATE_IDLE] = TECH_IDLE_ANIMATION_STATE
   objc.update_animation_state(entity, updatedAnimations)
end

B_ResearchBot_PowerPlant_tickTrigger = function(entity)
   local hasPlayedStartAnimation = objc.get_local_value(entity, HAS_PLAYED_START_ANIM)
   if hasPlayedStartAnimation == 0 then
      local numberOfSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_TECH_START_ANIMATION)
      objc.play_override_animation(entity, TECH_START_ANIMATION_NAME, objc.subrounds_to_milliseconds(numberOfSubrounds))
      objc.set_local_value(entity, HAS_PLAYED_START_ANIM, 1)
   end

   local hasUnFrozen = objc.get_local_value(entity, HAS_UNFROZEN)
   if hasUnFrozen == 0 then
      local unFreezeTimer = objc.tick_timer(entity, 'cardFreezeTimerKey', CARD_FREEZE_ROUNDS)
      if unFreezeTimer == 0 then
         local playerNumber = objc.get_player_number(entity)
         local numberOfSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_TECH_FINISH_ANIMATION)
         objc.play_override_animation(entity, TECH_FINISH_ANIMATION_NAME, objc.subrounds_to_milliseconds(numberOfSubrounds))
         objc.add_research(playerNumber, 1)
         objc.resume_card_draw(playerNumber)
         objc.set_local_value(entity, HAS_UNFROZEN, 1)
      end
   end
end
