local AMMO_COUNT_KEY = 'ammoCountKey'
local RELOAD_TIMER_KEY = 'reloadTimerKey'
local IS_RELOADING_KEY = 'isReloadingKey'

B_RocketTrooper_spawnTrigger = function(entity)
    objc.set_local_value(entity, AMMO_COUNT_KEY, 4)
end

B_RocketTrooper_onAttackTrigger = function(sourceEntity, targetEntity)
    local ammoCount = objc.get_local_value(sourceEntity, AMMO_COUNT_KEY)
    objc.set_local_value(sourceEntity, AMMO_COUNT_KEY, ammoCount - 1)
end

B_RocketTrooper_tickTrigger = function(entity)
    local ammoCount = objc.get_local_value(entity, AMMO_COUNT_KEY)
    if ammoCount <= 0 then
	    local reloadDuration = objc.get_combat_entity_custom_stat(entity, CUSTOM_ENTITY_STAT_KEY_RELOAD_DURATION)
	    local isReloading = objc.get_local_value(entity, IS_RELOADING_KEY)
    	if isReloading == 0 then
	        objc.idle_entity_indefinitely(entity)
	        objc.set_local_value(entity, IS_RELOADING_KEY, 1)
            objc.add_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'B_RocketTrooper.lua', 'B_RocketTrooper_delayOverrideAnimationTrigger')
		else
	    	local reloadTimer = objc.tick_timer(entity, RELOAD_TIMER_KEY, objc.milliseconds_to_rounds(reloadDuration) + 1)
	    	if reloadTimer <= 0 then
                objc.unidle_entity(entity)
        		objc.set_local_value(entity, AMMO_COUNT_KEY, 4)
		        objc.set_local_value(entity, IS_RELOADING_KEY, 0)
        	end
        end
    end
end

B_RocketTrooper_delayOverrideAnimationTrigger = function(entity)
    local animationTriggerDelay = objc.tick_timer(entity, 'animationDelayTimer', 6)
    if animationTriggerDelay == 0 then
        local reloadDuration = objc.get_combat_entity_custom_stat(entity, CUSTOM_ENTITY_STAT_KEY_RELOAD_DURATION)
        objc.play_override_animation(entity, 'B_RocketTrooper_Attack_Reload_01', reloadDuration)
        objc.remove_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'B_RocketTrooper_delayOverrideAnimationTrigger')
    end
end
