local SHOCK_VFX_ENTITY = 'shockEffectEntity'
local SHOCK_IMPACT_VFX = 'spell_B_stinger_impact.lvl'
local BOOM_ANIMATION_NAME = 'B_LegionGrenade_Boom'
local FRAMES_IN_BOOM_ANIMATION = 30
local WAIT_FOR_DAMAGE_TIME = 0

B_Shock_spawnTrigger = function(entity)
   local numberOfSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_BOOM_ANIMATION)
   objc.play_override_animation(entity, BOOM_ANIMATION_NAME, objc.subrounds_to_milliseconds(numberOfSubrounds))
   objc.add_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'B_Shock.lua', 'B_Shock_waitForDamageTrigger')
   objc.set_targetable(entity, false)
   objc.idle_entity(entity, 3000) --Prevent the unit from "attacking" something outside its spell damage
end

B_Shock_waitForDamageTrigger = function(entity)
   local waitForAnimation = objc.tick_timer(entity, 'waitForDamageTimeKey', WAIT_FOR_DAMAGE_TIME)
   if waitForAnimation == 0 then
      local shock_radius = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_SPELL_RADIUS)
      local teamNumber = objc.get_team_number(entity)
      local enemyNumber = objc.get_enemy_team_number(entity)
      local enemiesInRadius = objc.list_entities_in_radius(entity, shock_radius, enemyNumber)
      for _, enemy in pairs(enemiesInRadius) do
         if (objc.is_building_unit(enemy) or objc.is_normal_unit(enemy) or objc.is_commander(enemy) or objc.is_base(enemy) or objc.is_barricade(enemy) or (objc.is_boss_unit(enemy) == 1)) and (objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_IS_BEING_PROTECTED) == 0) then
            local attackDamage = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_DAMAGE)
            objc.inflict_normal_damage(entity, enemy, attackDamage)
            objc.play_vfx(enemy, SHOCK_IMPACT_VFX, NODE_IMPACT)
            objc.flash_entity_for_damage(enemy, 250)
         end
      end

      local entityPos = objc.get_entity_position(entity)
      local playerNumber = objc.get_player_number(entity)
      objc.remove_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'B_Shock_waitForDamageTrigger')
   end
end
