local SHOCK_DISTANCE = 1100
local NUM_ADDITIONAL_SHOCKS = 3
local CURRENT_SHOCKS = 'currentShocksKey'
local HAS_BEEN_SHOCKED = 'hasBeenShockedKey'
local SHOCKED_UNITS_ARRAY = 'shockedUnitsArray'

B_ShockTrooper_damageTrigger = function(damage, targetEntity, sourceEntity)
    local shockTrooper = sourceEntity
    local sourceID = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_IDENTIFIER)
    --Get source unit if sourceEntity is a bullet
    if sourceID ~= 'B_ShockTrooper'then
        shockTrooper = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_SOURCE_ENTITY)
    end
    local currentShocks = objc.get_local_value(shockTrooper, CURRENT_SHOCKS)
    local shockedUnitsArray = objc.get_local_value(shockTrooper, SHOCKED_UNITS_ARRAY)
    if shockedUnitsArray == 0 then
        shockedUnitsArray = {}
    end

    objc.set_local_value(targetEntity, HAS_BEEN_SHOCKED, 1)
    table.insert(shockedUnitsArray, targetEntity)
    objc.set_local_value(shockTrooper, SHOCKED_UNITS_ARRAY, shockedUnitsArray)

    if currentShocks < NUM_ADDITIONAL_SHOCKS then
        local enemyNumber = objc.get_team_number(targetEntity)
        local nearbyEnemies = objc.list_entities_in_radius(targetEntity, SHOCK_DISTANCE, enemyNumber)
        local closestEnemy = targetEntity
        local closestDistance = 9999999
        for _, enemy in pairs(nearbyEnemies) do
            local hasBeenShocked = objc.get_local_value(enemy, HAS_BEEN_SHOCKED)
            if hasBeenShocked == 0 then
                local thisDistance = objc.quick_unit_distance_square(targetEntity, enemy)
                if thisDistance < closestDistance then
                    closestDistance = thisDistance
                    closestEnemy = enemy
                end
            end
        end

        if closestEnemy ~= targetEntity then
            local attackDamage = objc.get_entity_value_for_key(shockTrooper, ENTITY_VALUE_KEY_ATTACK_DAMAGE)
            objc.set_local_value(shockTrooper, CURRENT_SHOCKS, currentShocks + 1)
            objc.inflict_normal_damage(shockTrooper, closestEnemy, attackDamage)
            objc.flash_entity_for_damage(closestEnemy, 250)
        end
    else
        local shockedUnitsArray = objc.get_local_value(shockTrooper, SHOCKED_UNITS_ARRAY)
        for _,shockedUnit in pairs(shockedUnitsArray) do
            objc.set_local_value(shockedUnit, HAS_BEEN_SHOCKED, 0)
        end
        objc.set_local_value(shockTrooper, SHOCKED_UNITS_ARRAY, 0)
        objc.set_local_value(shockTrooper, CURRENT_SHOCKS, 0)
    end

    objc.play_vfx(targetEntity, 'ptl_Asc_blink_teleport.lvl', NODE_ORIGIN)
    return damage
end
