local SWAP_SEARCH_RANGE = 4000

B_SwapBlaster_damageTrigger = function(damage, targetEntity, sourceEntity)
    local enemyTeamNumber = objc.get_team_number(targetEntity)
    local enemiesInRange = objc.list_entities_in_radius(targetEntity, SWAP_SEARCH_RANGE, enemyTeamNumber)
    local targetPos = objc.get_entity_position(targetEntity)
    local farthestEnemy = targetEntity
    local farthestDistance = 0

    for _, enemy in pairs(enemiesInRange) do
        if objc.is_normal_unit(enemy) and not objc.is_miner(enemy) then
            local enemyDistance
            local enemyPos = objc.get_entity_position(enemy)
            if enemyTeamNumber == 1 then
                enemyDistance = enemyPos[1] - targetPos[1]
            else
                enemyDistance = math.abs(enemyPos[1] - targetPos[1])
            end

            if enemyDistance > farthestDistance then
                farthestDistance = enemyDistance
                farthestEnemy = enemy
            end
        end
    end

    if farthestEnemy ~= targetEntity then
        local enemyPos = objc.get_entity_position(farthestEnemy)
        local targetPos = objc.get_entity_position(targetEntity)

        objc.teleport_entity(targetEntity, enemyPos[1], enemyPos[2])
        objc.teleport_entity(farthestEnemy, targetPos[1], targetPos[2])
    end

    return damage
end