local PULL_RADIUS = 2000
local HAS_INIT_KEY = 'HAS_INIT_KEY'
local PULLED_ENTITIES = 'pulledEntitiesKey'
local PULL_VELOCITY = 1000

BlackHolerBlackHole_tickTrigger = function(entity) 
   local hasInit = objc.get_local_value(entity, HAS_INIT_KEY)

   if hasInit == 0 then
      local enemyNumber = objc.get_enemy_team_number(entity)
      local entityPosition = objc.get_entity_position(entity)
      local enemiesToPull = objc.list_entities_in_radius(entity, PULL_RADIUS, enemyNumber)
      objc.set_local_value(entity, PULLED_ENTITIES, enemiesToPull)
      for _, enemy in pairs(enemiesToPull) do
         if objc.is_normal_unit(enemy) and objc.is_ground_unit(enemy) then
            --objc.move_entity_to_entity_with_motion(enemy, entity, MOTION_STATE_LEAP, PULL_VELOCITY)
            objc.move_entity_to_location_with_velocity(enemy, entityPosition[1], entityPosition[2], PULL_VELOCITY, 450)
         end
      end
      
      objc.set_local_value(entity, HAS_INIT_KEY, 1)
   end   
end

BlackHolerBlackHole_deathTrigger = function(entity)
   local pulledEnemies = objc.get_local_value(entity, PULLED_ENTITIES)
   for _,enemy in pairs(pulledEnemies) do
      local velX = objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_VELOCITY_X)
      local velY = objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_VELOCITY_Y)
      local normalVel = objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_MAX_VELOCITY)
      if velX + velY > normalVel then
         local entityPosition = objc.get_entity_position(enemy)
         objc.move_entity_to_location_with_velocity(enemy, entityPosition[1], entityPosition[2], PULL_VELOCITY, 450)
      end
   end
end
