#define SUPPORT_GLSL300
#include "prefix.sh"
#include "hdr_utility.sh"

precision highp float;

uniform sampler2D s_cc3Texture2Ds[1];

VARYING_IN vec2 v_texCoord[1];

uniform float Exposure_bloomThreshold;

void main()
{
    vec3 hdrColor = texture2D(s_cc3Texture2Ds[0], v_texCoord[0]).rgb;

    if (luminance(hdrColor) > Exposure_bloomThreshold) {
        gl_FragColor.rgb = Uncharted2Tonemap(hdrColor);
    } else {
        gl_FragColor.rgb = vec3(0.0);
    }

    gl_FragColor.a = 1.0;
}
