local WAVE_TIMER_KEY = 'waveTimerKey'
local WAVE_DELAY = 300
local WAVE_COUNTER = 'waveCounterKey'

local FIRST_WAVE_SPAWNED = 'firstWaveSpawnedKey'
local FIRST_WAVE_COUNTER = 'firstWaveTimerKey'
local FIRST_WAVE_DELAY = 5

local ASSOCIATED_BOSS = 'associatedBossKey'
local NUM_WAVES = 'numWavesKey'

local TOP_X_POINT = 1200
local BOTTOM_X_POINT = -1100

BossBattleTimingBase_tickTrigger = function(entity)
    local firstWaveSpawned = objc.get_local_value(entity, FIRST_WAVE_SPAWNED)
    if firstWaveSpawned == 0 then
        local firstWaveTimer = objc.tick_timer(entity, FIRST_WAVE_COUNTER, FIRST_WAVE_DELAY)
        if firstWaveTimer == 0 then
            local waveCounter = objc.get_local_value(entity, WAVE_COUNTER)
            waveCounter = waveCounter + 1
            BossBattleTimingBase_spawnWave(entity, waveCounter)
            objc.set_local_value(entity, WAVE_COUNTER, waveCounter)
            objc.set_local_value(entity, FIRST_WAVE_SPAWNED, 1)
        end
    else
        local waveCounter = objc.get_local_value(entity, WAVE_COUNTER)
        local numWaves = objc.get_local_value(entity, NUM_WAVES)
        if waveCounter < numWaves then
            local waveTimer = objc.tick_timer(entity, WAVE_TIMER_KEY, WAVE_DELAY)
            if waveTimer == 0 then
                waveCounter = waveCounter + 1
                BossBattleTimingBase_spawnWave(entity, waveCounter)
                objc.set_local_value(entity, WAVE_COUNTER, waveCounter)
            end
        else
            objc.sacrifice_entity(entity)
        end
    end
end

BossBattleTimingBase_spawnWave = function(entity, waveNumber)
    local associatedBoss = objc.get_local_value(entity, ASSOCIATED_BOSS)
    local bossID = objc.get_entity_value_for_key(associatedBoss, ENTITY_VALUE_KEY_IDENTIFIER)
    objc.add_trigger(associatedBoss, TRIGGER_NAME_TICK_TRIGGER, bossID .. '.lua', bossID .. '_Wave_' .. waveNumber)
end