attribute vec4 a_position;
attribute vec2 a_texCoord;
attribute vec4 a_color;
uniform mat4 u_MVPMatrix;

uniform float sampleDistance;
uniform vec2 direction;

varying vec2 v_texCoord;
varying vec4 v_fragmentColor;
varying vec2 v_blurTexCoords[7];

void main() {
    gl_Position = u_MVPMatrix * a_position;
    v_fragmentColor = a_color;
    v_texCoord = a_texCoord;
    
    v_blurTexCoords[0] = v_texCoord + -3.0 * direction * sampleDistance;
    v_blurTexCoords[1] = v_texCoord + -2.0 * direction * sampleDistance;
    v_blurTexCoords[2] = v_texCoord + -1.0 * direction * sampleDistance;
    v_blurTexCoords[3] = v_texCoord +  0.0 * direction * sampleDistance;
    v_blurTexCoords[4] = v_texCoord +  1.0 * direction * sampleDistance;
    v_blurTexCoords[5] = v_texCoord +  2.0 * direction * sampleDistance;
    v_blurTexCoords[6] = v_texCoord +  3.0 * direction * sampleDistance;
}
