precision mediump float;
precision highp sampler2D;

uniform sampler2D u_texture;
uniform vec2 u_texelSize;
uniform vec2 u_direction;

varying vec2 v_texCoord;
varying vec4 v_fragmentColor;

vec4 blur5(sampler2D image, vec2 uv, vec2 texelSize, vec2 direction)
{
    vec4 color = vec4(0.0);
    vec2 off1 = vec2(1.3333333333333333) * direction;
    color += texture2D(image, uv) * 0.29411764705882354;
    color += texture2D(image, uv + (off1 * texelSize)) * 0.35294117647058826;
    color += texture2D(image, uv - (off1 * texelSize)) * 0.35294117647058826;
    return color;
}

vec4 blur9(sampler2D image, vec2 uv, vec2 texelSize, vec2 direction)
{
    vec4 color = vec4(0.0);
    vec2 off1 = vec2(1.3846153846) * direction;
    vec2 off2 = vec2(3.2307692308) * direction;
    color += texture2D(image, uv) * 0.2270270270;
    color += texture2D(image, uv + (off1 * texelSize)) * 0.3162162162;
    color += texture2D(image, uv - (off1 * texelSize)) * 0.3162162162;
    color += texture2D(image, uv + (off2 * texelSize)) * 0.0702702703;
    color += texture2D(image, uv - (off2 * texelSize)) * 0.0702702703;
    return color;
}

vec4 blur13(sampler2D image, vec2 uv, vec2 texelSize, vec2 direction)
{
    vec4 color = vec4(0.0);
    vec2 off1 = vec2(1.411764705882353) * direction;
    vec2 off2 = vec2(3.2941176470588234) * direction;
    vec2 off3 = vec2(5.176470588235294) * direction;
    color += texture2D(image, uv) * 0.1964825501511404;
    color += texture2D(image, uv + (off1 * texelSize)) * 0.2969069646728344;
    color += texture2D(image, uv - (off1 * texelSize)) * 0.2969069646728344;
    color += texture2D(image, uv + (off2 * texelSize)) * 0.09447039785044732;
    color += texture2D(image, uv - (off2 * texelSize)) * 0.09447039785044732;
    color += texture2D(image, uv + (off3 * texelSize)) * 0.010381362401148057;
    color += texture2D(image, uv - (off3 * texelSize)) * 0.010381362401148057;
    return color;
}

#define BLUR_FUNC blur13

void main()
{
    gl_FragColor = BLUR_FUNC(u_texture, v_texCoord, u_texelSize, u_direction);
}
