local DEFAULT_MAX_MINERS = 1
local MAX_MINERS_KEY = 'maxMinersKey'
local NUM_MINERS_KEY = 'numMinersKey'
local DEFAULT_MAX_CRYSTALS = 9999
local CURRENT_CRYSTALS_KEY = 'currentCrystalsKey'
local MINER_LIST = 'minerListKey'
local TARGET_MINE = 'targetMineKey'

CrystalMineWorkerObjective_spawnTrigger = function(entity)
    objc.set_local_value(entity, MAX_MINERS_KEY, DEFAULT_MAX_MINERS)
    objc.set_local_value(entity, NUM_MINERS_KEY, 0)
    objc.set_local_value(entity, CURRENT_CRYSTALS_KEY, DEFAULT_MAX_CRYSTALS)
    objc.set_targetable(entity, false)
    objc.set_solid(entity, false)
end

CrystalMineWorkerObjective_tickTrigger = function(entity)
    local currentCrystals = objc.get_local_value(entity, CURRENT_CRYSTALS_KEY)
    if currentCrystals < 1 then
        local minerList = objc.get_local_value(entity, MINER_LIST)
        if minerList ~= 0 then
            for minerIndex = 1, #minerList do
                objc.set_local_value(minerList[minerIndex], TARGET_MINE, nil)
            end
        end
        objc.sacrifice_entity(entity)
    end

    local gameTime = objc.get_elapsed_game_time_in_seconds()
    if gameTime > GAME_LENTGH then
        objc.sacrifice_entity(entity)
    end
end
