local DAMAGE_CLOUD_IDENTIFIER = 'damageGasCloudScriptEntity'
local NUM_CLOUDS = 4
local MAX_DISTANCE_FORWARD = 0 --in terms of player 1
local MIN_DISTANCE_BACKWARD = 5000

GasClouds = function(sourceEntity)
	local teamNumber = objc.get_team_number(sourceEntity)
    local playerNumber = objc.get_player_number(sourceEntity)
	local halfBattlefieldWidth = objc.divide_with_floor(objc.get_map_size()[2], 2)
	local halfBattlefieldHeight = objc.divide_with_floor(objc.get_map_size()[1], 2)

	local maxX = MAX_DISTANCE_FORWARD
	local battleFieldXLimit = -halfBattlefieldWidth + MIN_DISTANCE_BACKWARD
	if teamNumber == 2 then
		maxX = -MAX_DISTANCE_FORWARD
		battleFieldXLimit = halfBattlefieldWidth - MIN_DISTANCE_BACKWARD
	end

	for i=1, NUM_CLOUDS do
		local thisX = objc.roll_number(battleFieldXLimit, maxX)
		local thisY = objc.roll_number(-halfBattlefieldHeight, halfBattlefieldHeight)

		objc.spawn_at_point(DAMAGE_CLOUD_IDENTIFIER, 1, playerNumber, thisX, thisY, 0, 0)
	end
end
