local DAMAGE_KEY = 'damageAmountKey'
local RADIUS_KEY = 'radiusKey'
local TIMER_KEY = 'timerKey'
local TARGET_AIR_KEY = 'targetAirKey'
local TARGET_GROUND_KEY = 'targetGroundKey'

Generic_ExplosionDelayScriptEntity_tickTrigger = function(entity)
    local timer = objc.tick_timer(entity, 'timer', objc.get_local_value(entity, TIMER_KEY))
    if timer == 0 then
        local enemyNumber = objc.get_enemy_team_number(entity)
        local damageAmount = objc.get_local_value(entity, DAMAGE_KEY)
        local radius = objc.get_local_value(entity, RADIUS_KEY)
        local targetAir = objc.get_local_value(entity, TARGET_AIR_KEY)
        local targetGround = objc.get_local_value(entity, TARGET_GROUND_KEY)
        for _, enemy in pairs(objc.list_entities_in_radius(entity, radius, enemyNumber)) do
            if(not objc.is_dummy_unit(enemy)) then
                if (objc.is_ground_unit(enemy) and targetGround == 1) or (objc.is_air_unit(enemy) and targetAir == 1) then
                    objc.inflict_normal_damage(entity, enemy, damageAmount)
                    objc.flash_entity_for_damage(enemy, 250)
                end
            end
        end
        objc.sacrifice_entity(entity)
    end
end
