local BIG_HALLUCINATED_TITAN_UNIT_NAME = 'bigHallucinatedTitanUnit'

--[[
The Hallucination hero script spawns a BIG_HALLUCINATED_TITAN_UNIT_NAME in the
game. It goes through and sees all of the Hallucinations the current player has
on the field, and uses that to offset where this new Hallucination will be
spawned.
--]]
Hallucination = function(sourceEntity)
   local teamNumber = objc.get_team_number(sourceEntity)
   local positionX = 0
   local facingX = 0

   if teamNumber == 1 then
      positionX = -4000
      facingX = 1
   elseif teamNumber == 2 then
      positionX = 4000
      facingX = -1
   else
      objc.scripting_error('Encountered unknown player number ' .. teamNumber)
   end
   
   local allies = objc.list_entities(teamNumber)
   local hallucinationCount = 0

   for _, ally in pairs(allies) do
      if objc.get_entity_value(ally, 'identityComponent.identifier') == BIG_HALLUCINATED_TITAN_UNIT_NAME then
         hallucinationCount = hallucinationCount + 1
      end
   end

   local playerNumber = objc.get_player_number(sourceEntity)

   local hallucinationUnitArray = objc.spawn_at_point(BIG_HALLUCINATED_TITAN_UNIT_NAME, 1, playerNumber, positionX + (hallucinationCount * 1000 * facingX), 0, facingX, 0)
   objc.play_vfx(hallucinationUnitArray[1], 'CommanderHallucination.lvl', 'root')
   objc.play_vfx(hallucinationUnitArray[1], 'CommanderHallucinationEnd.lvl', 'root')
   objc.play_vfx(hallucinationUnitArray[1], 'CommanderHallucinationDust.lvl', 'root')
   objc.play_vfx(hallucinationUnitArray[1], 'ComHalluArmStar.lvl', 'LeftFX')
   objc.play_vfx(hallucinationUnitArray[1], 'ComHalluArmStar.lvl', 'RightFX')

   --THE BELOW IS A HACK FOR PROTOTYPING THE TOMBSTONE UNIT BUT DOES NOTHING WITHOUT THAT UNIT PRESENT ON THE BATTLEFIELD.
   --REMOVE THIS LINE WHEN TESTING ON TOMBSTONES IS DONE
   UnitAbility_activateTombstones(playerNumber, teamNumber)
end
