local TAUNT_TICK = 3
local TAUNT_RADIUS = 2000
local TAUNT_KEY = 'tauntTickKey'

local HEALTH_TICK_KEY = 'healthTickAmountKey'
local DURATION_ROUNDS = 120
local TAUNT_STATE = 'TauntState'
local END_MOVE_NAME = 'HallucinationDummyUnit_endForceMoveTrigger'
local MOTION_STATE_DICT = 'MotionStateDictKey'

HallucinationDummyUnit_spawnTrigger = function(entity)
    local maxHealth = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_HEALTH)
    local healthTickAmount = objc.divide_with_floor(maxHealth, DURATION_ROUNDS)
    objc.set_local_value(entity, HEALTH_TICK_KEY, healthTickAmount)
    objc.set_solid(entity, false)
end

HallucinationDummyUnit_tickTrigger = function(entity)
    local healthTick = objc.get_local_value(entity, HEALTH_TICK_KEY)
    objc.inflict_direct_damage(entity, entity, healthTick)
end

HallucinationDummyUnit_canTargetTrigger = function(entity, targetEntity)
    return NO
end