local BIG_HALLUCINATED_TITAN_UNIT_NAME = 'hallucinationTauntUnit'
local HALLUCINATION_DUMMY_UNIT = 'HallucinationDummyUnit'
local HALLUCINATIONT_DUMMY_UNIT_KEY = 'hallucinationDummyUnitKey'


--[[
The Hallucination hero script spawns a BIG_HALLUCINATED_TITAN_UNIT_NAME in the
game. It goes through and sees all of the Hallucinations the current player has
on the field, and uses that to offset where this new Hallucination will be
spawned.
--]]
HallucinationTargeted = function(sourceEntity, targetPositionX, targetPositionY)
   local teamNumber = objc.get_team_number(sourceEntity)
   local facingX = 0

   if teamNumber == 1 then
      facingX = 1
   elseif teamNumber == 2 then
      facingX = -1
   else
      objc.scripting_error('Encountered unknown player number ' .. teamNumber)
   end

   local playerNumber = objc.get_player_number(sourceEntity)

   local hallucinationUnitArray = objc.spawn_at_point(BIG_HALLUCINATED_TITAN_UNIT_NAME, 1, playerNumber, targetPositionX, targetPositionY, facingX, 0)
   local dummyUnitArray = objc.spawn_at_point(HALLUCINATION_DUMMY_UNIT, 1, playerNumber, targetPositionX, targetPositionY, facingX, 0)
   objc.set_local_value(hallucinationUnitArray[1], HALLUCINATIONT_DUMMY_UNIT_KEY, dummyUnitArray[1])
   objc.play_vfx(hallucinationUnitArray[1], 'CommanderHallucination.lvl', NODE_ORIGIN)
end
