local SOUL_VFX = 'W_harvester_soul.lvl'
local SOUL_TIMER = 10
local SOURCE_HARVESTER_KEY = 'sourceHarvesterKey'
local IS_MOVING = 'isMovingKey'

HarvesterSoulEntity_tickTrigger = function(entity)  
    local isMoving = objc.get_local_value(entity, IS_MOVING)
    if isMoving == 0 then
        objc.set_local_value(entity, IS_MOVING, 1)
    elseif isMoving == 1 then
        local sourceHarvester = objc.get_local_value(entity, SOURCE_HARVESTER_KEY)
        if sourceHarvester ~= 0 then
            objc.play_vfx(entity, SOUL_VFX, NODE_STATUS)
            objc.move_entity_to_entity_with_motion(entity, sourceHarvester, MOTION_STATE_WALK, 350)
            objc.set_local_value(entity, IS_MOVING, 2)
        end
    end
end

HarvesterSoulEntity_onOverrideTargetingCompletionTrigger = function(sourceEntity, targetEntity, targetingFailed)
    local isMoving = objc.get_local_value(sourceEntity, IS_MOVING)
    if isMoving == 2 then
        local teamNumber = objc.get_team_number(targetEntity)
        objc.add_crystal(teamNumber, 1)
        objc.sacrifice_entity(sourceEntity)
    end
end