local checkInterval = 5
local gameTimeKey = 'gameTimeKey'
local LINE_ENTITY_TYPE_KEY = 'lineEntityTypeKey'

IncomeLineEntityNeutral_tickTrigger = function(entity)
   local teamNumber = objc.get_team_number(entity)
   local enemyNumber = objc.get_enemy_team_number(entity)
   local timer = objc.tick_timer(entity, 'timer', checkInterval)
   local gameTime = objc.get_global_value(gameTimeKey)
   local entityPos = objc.get_entity_position(entity)
   local yModifier = 1

   if entityPos[2] < 0 then
      yModifier = -1
   end
   objc.set_global_value(gameTimeKey, gameTime + 1)

   if timer == 0 then
      local shouldSwapOwnership = IncomeLineEntityNeutral_controlCheck(entity, teamNumber, enemyNumber)

      local ownershipPlayerNumbers = objc.get_player_numbers_for_team_number(shouldSwapOwnership)

      if shouldSwapOwnership == 0 then
         return 0
      elseif shouldSwapOwnership == teamNumber then
         objc.kill_entity(entity)
         local spawned = objc.spawn_at_point('IncomeLineEntityLeft', 1, ownershipPlayerNumbers[1], 0, 1000 * yModifier, 0, 0)
         local lineEntityType = objc.get_local_value(entity, LINE_ENTITY_TYPE_KEY)
         objc.set_local_value(spawned[1], LINE_ENTITY_TYPE_KEY, lineEntityType)
      elseif shouldSwapOwnership == enemyNumber then
         objc.kill_entity(entity)
         local spawned = objc.spawn_at_point('IncomeLineEntityRight', 1, ownershipPlayerNumbers[1], 0, 1000 * yModifier, 0, 0)
         local lineEntityType = objc.get_local_value(entity, LINE_ENTITY_TYPE_KEY)
         objc.set_local_value(spawned[1], LINE_ENTITY_TYPE_KEY, lineEntityType)
      end
   end

   return 0
end

IncomeLineEntityNeutral_controlCheck = function(entity, teamNumber, enemyNumber)
   local allies = objc.list_entities(teamNumber)
   local thisPos = objc.get_entity_position(entity)
   local sideModifier = 1
   local yModifier = 1

   if teamNumber == 1 then
      sideModifier = 1
   elseif teamNumber == 2 then
      sideModifier = -1
   else
      objc.scripting_error('invalid player number found for income line')
   end

   if thisPos[2] < 0 then
      yModifier = -1
   end

   for _, ally in pairs(allies) do
      if objc.is_normal_unit(ally) then
         local allyPosition = objc.get_entity_position(ally)
         if allyPosition[1] * sideModifier > 0 and (allyPosition[2] * yModifier) > 0 then
            return teamNumber
         end
      end
   end

   local enemies = objc.list_entities(enemyNumber)

   if teamNumber == 1 then
      sideModifier = -1
   elseif teamNumber == 2 then
      sideModifier = 1
   else
      objc.scripting_error('invalid player number found for income line')
   end

   for _, enemy in pairs(enemies) do
      if objc.is_normal_unit(enemy) then
         local enemyPosition = objc.get_entity_position(enemy)
         if enemyPosition[1] * sideModifier > 0 and (enemyPosition[2] * yModifier) > 0 then
            return enemyNumber
         end
      end
   end

   return 0

end
