--[[
This file sets up all of the global constants used by the LUA scripcs.
--]]

-- TOW Code component constants
NUMBER_OF_SUBROUNDS_IN_ROUND = 100
GAME_LENTGH = 180

-- TOW Common Entity Constants
ENTITY_IDENTIFIER_BASE = 'base'
ENTITY_IDENTIFIER_BARRICADE = 'Barricade'

-- TOW Skinned Entity Spawn Lookup Key
SKINNED_ENTITY_KEY_CRYSTAL_MINE = 'crystalMine'
SKINNED_ENTITY_KEY_CENTRAL_OBJECTIVE = 'centralObjective'
SKINNED_ENTITY_KEY_CENTRAL_OBJECTIVE_TOP = 'centralObjectiveTop'
SKINNED_ENTITY_KEY_CENTRAL_OBJECTIVE_BOTTOM = 'centralObjectiveBottom'

-- TOW LUA key constants
IS_DEBUFF_IMMUNE_KEY = 'isDebuffImmune'
YES = 1
NO = 0

-- TOW Faction Constants
FACTION_RED = 'red'
FACTION_GREEN = 'green'
FACTION_BLUE = 'blue'
FACTION_NEUTRAL = 'neutral'

-- TOW Art node name constants
NODE_STATUS = 'node_status'
NODE_IMPACT = 'node_impact'
NODE_ORIGIN = 'node_origin'
NODE_FIRE = 'node_fire'

-- TOW LUA OBJ-C constants

-- Easing types
EASE_NONE = 'EaseNone'
EASE_IN = 'EaseIn'
EASE_IN_OUT = 'EaseInOut'
EASE_OUT = 'EaseOut'

-- Plane of Existence
PLANE_OF_EXISTENCE_AIR = 'air'
PLANE_OF_EXISTENCE_AIR_GROUND = 'air-ground'
PLANE_OF_EXISTENCE_GROUND = 'ground'
PLANE_OF_EXISTENCE_NONE = 'none'

-- Entity Air Height Alignment
AIR_HEIGHT_ALIGN_BOTTOM = 'Bottom'
AIR_HEIGHT_ALIGN_TOP = 'Top'

-- Numerical Planes of Existence
NUM_PLANE_OF_EXISTENCE_NONE = 0
NUM_PLANE_OF_EXISTENCE_GROUND = 1
NUM_PLANE_OF_EXISTENCE_AIR = 2
NUM_PLANE_OF_EXISTENCE_BOTH = 3

-- Motion State
MOTION_STATE_LEAP = 'leap'
MOTION_STATE_WALK = 'walk'

-- Animation States
ANIMATION_STATE_ATTACK_AIR_START = 'attackAirStart'
ANIMATION_STATE_ATTACK_AIR = 'attackAir'
ANIMATION_STATE_ATTACK_AIR_END = 'attackAirEnd'

ANIMATION_STATE_ATTACK_GROUND_START = 'attackGroundStart'
ANIMATION_STATE_ATTACK_GROUND = 'attackGround'
ANIMATION_STATE_ATTACK_GROUND_END = 'attackGroundEnd'

ANIMATION_STATE_MOVE_START = 'moveStart'
ANIMATION_STATE_MOVE = 'move'

ANIMATION_STATE_DEATH = 'death'
ANIMATION_STATE_IDLE = 'idle'
ANIMATION_STATE_SPAWN = 'spawn'
ANIMATION_STATE_STUNNED = 'stunned'

-- Commander Animation States
COMMANDER_ANIMATION_STATE_IDLE = 'idle'
COMMANDER_ANIMATION_STATE_URGENT_IDLE = 'urgentIdle'
COMMANDER_ANIMATION_STATE_WAVE = 'wave'
COMMANDER_ANIMATION_STATE_ABILITY = 'ability'
COMMANDER_ANIMATION_STATE_SPAWN = 'spawn'
COMMANDER_ANIMATION_STATE_DEATH = 'death'

-- Entity Value Keys
ENTITY_VALUE_KEY_ARMOR = 'armor'
ENTITY_VALUE_KEY_ATTACK_DAMAGE = 'attackDamage'
ENTITY_VALUE_KEY_ATTACK_RANGE = 'attackRange'
ENTITY_VALUE_KEY_ATTACK_RATE = 'attackRate'
ENTITY_VALUE_KEY_SPLASH_RANGE = 'splashRange'
ENTITY_VALUE_KEY_ATTRIBUTES = 'attributes'
ENTITY_VALUE_KEY_BUILD_COST = 'buildCost'
ENTITY_VALUE_KEY_CURRENT_HEALTH = 'currentHealth'
ENTITY_VALUE_KEY_DAMAGE_BUFF = 'damageBuff'
ENTITY_VALUE_KEY_DAMAGE_TYPE = 'damageType'
ENTITY_VALUE_KEY_DESCRIPTION = 'description'
ENTITY_VALUE_KEY_FACTION = 'faction'
ENTITY_VALUE_KEY_HOLD_POSITION_COUNT_FOR_SPAWNING = 'holdPositionCountForSpawning'
ENTITY_VALUE_KEY_IDENTIFIER = 'identifier'
ENTITY_VALUE_KEY_IMPACT_PARTICLE_NAME = 'impactParticleName'
ENTITY_VALUE_KEY_IMPULSE_TIME = 'impulseTime'
ENTITY_VALUE_KEY_MAX_HEALTH = 'maxHealth'
ENTITY_VALUE_KEY_MAX_VELOCITY = 'maxVelocity'
ENTITY_VALUE_KEY_OVERRIDE_PLAYER_NUMBER = 'overridePlayerNumber'
ENTITY_VALUE_KEY_PLANE_OF_EXISTENCE = 'planeOfExistence'
ENTITY_VALUE_KEY_SPLASH_IMPACT_PARTICLE_NAME = 'splashImpactParticleName'
ENTITY_VALUE_KEY_PLAYER_NUMBER = 'teamNumber'
ENTITY_VALUE_KEY_POSITION_X = 'positionX'
ENTITY_VALUE_KEY_POSITION_Y = 'positionY'
ENTITY_VALUE_KEY_RARITY = 'rarity'
ENTITY_VALUE_KEY_SOURCE_ENTITY = 'sourceEntity'
ENTITY_VALUE_KEY_SPAWN_COUNT = 'spawnCount'
ENTITY_VALUE_KEY_TIER = 'tier'
ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER = 'baseTierIdentifier'
ENTITY_VALUE_KEY_VELOCITY_X = 'velocityX'
ENTITY_VALUE_KEY_VELOCITY_Y = 'velocityY'
ENTITY_VALUE_KEY_INCOME_TIER = 'incomeTier'
ENTITY_VALUE_KEY_IS_BEING_PROTECTED = 'isBeingProtected'
ENTITY_VALUE_KEY_CAN_ATTACK_PROTECTED_ENTITIES = 'canAttackProtectedEntities'
ENTITY_VALUE_KEY_SHOULD_IGNORE_PROTECTION = 'shouldIgnoreProtection'
ENTITY_VALUE_KEY_SPELL_RADIUS = 'spellRadius'
ENTITY_VALUE_KEY_REQUIRED_RESEARCH = 'requiredResearch'
ENTITY_VALUE_KEY_SIZE = 'size'
ENTITY_VALUE_KEY_DIRECTION_X = 'directionX'
ENTITY_VALUE_KEY_DIRECTION_Y = 'directionY'

-- Entity Custom Stats Keys
CUSTOM_ENTITY_STAT_KEY_DURATION = 'duration'
CUSTOM_ENTITY_STAT_KEY_AURA_DAMAGE_BONUS = 'auraDamageBonus'
CUSTOM_ENTITY_STAT_KEY_SHOT_DAMAGE_BONUS = 'shotDamageBonus'
CUSTOM_ENTITY_STAT_KEY_AURA_SPEED_INCREASE = 'auraSpeedIncrease'
CUSTOM_ENTITY_STAT_KEY_REDUCTION_CUTOFF = 'reductionCutoff'
CUSTOM_ENTITY_STAT_KEY_REPAIR_AMOUNT = 'repairAmount'
CUSTOM_ENTITY_STAT_KEY_DASH_DAMAGE = 'dashDamage'
CUSTOM_ENTITY_STAT_KEY_HEAL = 'heal'
CUSTOM_ENTITY_STAT_KEY_SHOTS_BLOCKED = 'shotsBlocked'
CUSTOM_ENTITY_STAT_KEY_HEALTH_BONUS = 'healthBonus'
CUSTOM_ENTITY_STAT_KEY_DAMAGE_BONUS = 'damageBonus'
CUSTOM_ENTITY_STAT_KEY_IMPACT_DAMAGE = 'impactDamage'
CUSTOM_ENTITY_STAT_KEY_EXPLOSION_DAMAGE = 'explosionDamage'
CUSTOM_ENTITY_STAT_KEY_PISTOL_DAMAGE = 'pistolDamage'
CUSTOM_ENTITY_STAT_KEY_PISTOL_COOLDOWN = 'pistolCooldown'
CUSTOM_ENTITY_STAT_KEY_RELOAD_DURATION = 'reloadDuration'

-- Trigger Keys
TRIGGER_NAME_DAMAGE_TRIGGER = 'damageTrigger'
TRIGGER_NAME_ON_DAMAGE_TRIGGER = 'onDamageTrigger'
TRIGGER_NAME_TICK_TRIGGER = 'tickTrigger'
TRIGGER_NAME_REACHED_OVERTIME_TRIGGER = 'reachedOvertimeTrigger'
TRIGGER_NAME_SPAWN_TRIGGER = 'spawnTrigger'
TRIGGER_NAME_DEATH_TRIGGER = 'deathTrigger'
TRIGGER_NAME_CAN_TARGET_TRIGGER = 'canTargetTrigger'
TRIGGER_NAME_CHECK_TARGET_SCORE_TRIGGER = 'checkTargetScoreTrigger'
TRIGGER_NAME_ON_TARGET_TRIGGER = 'onTargetTrigger'
TRIGGER_NAME_ON_MOVEMENT_TRIGGER = 'onMovementTrigger'
TRIGGER_NAME_ON_ATTACK_TRIGGER = 'onAttackTrigger'
TRIGGER_NAME_ON_KILL_TRIGGER = 'onKillTrigger'
TRIGGER_NAME_ON_OVERRIDE_TARGETING_COMPLETION_TRIGGER = 'onOverrideTargetingCompletionTrigger'
TRIGGER_NAME_ACTION_SYSTEM_LOOP_START_TRIGGER = 'actionSystemLoopStartTrigger'
TRIGGER_NAME_ACTION_SYSTEM_LOOP_END_TRIGGER = 'actionSystemLoopEndTrigger'

-- Tactic and Merc region keys
-- Make sure this key below matches kBattlePlacementManagerInitialRegion in BattlePlacementManager
PLACEMENT_REGION_KEY_INITIAL = 'Initial'
PLACEMENT_REGION_X = 'x'
PLACEMENT_REGION_Y = 'y'
PLACEMENT_REGION_WIDTH = 'width'
PLACEMENT_REGION_LENGTH = 'length'

-- Custom keys used in Lua only
LUA_KEY_TAG = 'tag'
IS_TWO_LANE_MAP_GLOBAL_KEY = "isTwoLaneMapGlobalKey"
