local SOUL_VFX = 'W_Dragon_Boss_Healing.lvl'
local LEVEL_UP_VFX = 'crystalGainEffect.lvl'
local BUFF_VFX = 'C_Ai_Buff.lvl'
local MOVE_TARGET_KEY = 'buffEntityMoveTargetKey'
local IS_MOVING = 'isMovingKey'
local HEALTH_PROP_DENOMINATOR = 50

KyrieCultistBuffEntity_tickTrigger = function(entity)  
    local isMoving = objc.get_local_value(entity, IS_MOVING)
    if isMoving == 0 then
        objc.set_local_value(entity, IS_MOVING, 1)
    elseif isMoving == 1 then
        local moveTarget = objc.get_local_value(entity, MOVE_TARGET_KEY)
        if moveTarget ~= 0 then
            objc.play_vfx(entity, SOUL_VFX, NODE_STATUS)
            objc.move_entity_to_entity_with_motion(entity, moveTarget, MOTION_STATE_WALK, 350)
            objc.set_local_value(entity, IS_MOVING, 2)
        end
    end
end

KyrieCultistBuffEntity_onOverrideTargetingCompletionTrigger = function(sourceEntity, targetEntity, targetingFailed)
    local isMoving = objc.get_local_value(sourceEntity, IS_MOVING)
    if isMoving == 2 then
        local teamNumber = objc.get_team_number(targetEntity)
        local allyMaxHealth = objc.get_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_MAX_HEALTH)
        local allyCurrentHealth = objc.get_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_CURRENT_HEALTH)
        local healthTick = objc.divide_with_floor(allyMaxHealth, HEALTH_PROP_DENOMINATOR)

        local healthToSet = allyCurrentHealth + healthTick
        if healthToSet > allyMaxHealth then
            healthToSet = allyMaxHealth
        end

        objc.set_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_CURRENT_HEALTH, healthToSet)

        local kyrieBase = objc.get_base_entity(teamNumber)
        objc.set_entity_value_for_key(kyrieBase, ENTITY_VALUE_KEY_MAX_HEALTH, allyMaxHealth)
        objc.set_entity_value_for_key(kyrieBase, ENTITY_VALUE_KEY_CURRENT_HEALTH, healthToSet)

        objc.sacrifice_entity(sourceEntity)
    end
end