local ORIGINAL_RANGE = 'originalRangeKey'
local RANGE_ON_SPAWN = 10000
local OTHER_BOSS_ALIVE = 'isOtherBossAlive'
local UNINTERRUPTED_DEATH_TIME_IN_SUBROUNDS = 240000

N_ObjectiveBoss_spawnTrigger = function(entity)
    local originalRange = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_RANGE)
    objc.set_local_value(entity, ORIGINAL_RANGE, originalRange)
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_RANGE, RANGE_ON_SPAWN)

    objc.set_local_value(entity, OTHER_BOSS_ALIVE, 1)
end

N_ObjectiveBoss_canTargetTrigger = function(entity, targetEntity)
    local isOtherBossAlive = objc.get_local_value(entity, OTHER_BOSS_ALIVE)
    if isOtherBossAlive ~= 0 then
        local targetId = objc.get_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_IDENTIFIER)
        if targetId == 'N_ObjectiveBoss' then
            return YES
        else
            return NO
        end
    else
        return YES
    end
end

N_ObjectiveBoss_deathTrigger = function(entity)
    local isOtherBossAlive = objc.get_local_value(entity, OTHER_BOSS_ALIVE)
    if isOtherBossAlive == 1 then
        local enemyNumber = objc.get_enemy_team_number(entity)
        local enemies = objc.list_entities(enemyNumber)
        for _,enemy in pairs(enemies) do
            local targetId = objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_IDENTIFIER)
            if targetId == 'N_ObjectiveBoss' then
                local originalRange = objc.get_local_value(enemy, ORIGINAL_RANGE)
                objc.set_entity_value_for_key(enemy, ENTITY_VALUE_KEY_ATTACK_RANGE, originalRange)
                objc.set_local_value(enemy, OTHER_BOSS_ALIVE, 0)

                local maxHealth = objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_MAX_HEALTH)
                objc.set_entity_value_for_key(enemy, ENTITY_VALUE_KEY_CURRENT_HEALTH, maxHealth)
            end
        end
    else
        objc.spawn('objectiveBossDeathTimerEntity', 1, 1)
    end
end

N_ObjectiveBoss_damageTrigger = function(damage, targetEntity, sourceEntity)
    local targetId = objc.get_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_IDENTIFIER)
    if targetId == "N_ObjectiveBoss" then
        local maxHealth = objc.get_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_MAX_HEALTH)
        local attackRate = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_ATTACK_RATE)
        local numAttacksToUninterruptedDeath = objc.divide_with_floor(UNINTERRUPTED_DEATH_TIME_IN_SUBROUNDS, attackRate)
        local damageTick = objc.divide_with_floor(maxHealth, numAttacksToUninterruptedDeath)        
        return damageTick
    else
        return damage
    end
end