local PULSE_ANIMATION_NAME = 'PULSE'
local SHOULD_START_PULSE_COUNTDOWN = 'shouldStartPulseCountdown'
local FRAMES_IN_PULSE_ANIM = 30

local HAS_PLAYED_SPAWN_ANIMATION = 'hasPlayedSpawnAnimKey'
local SPAWN_ANIMATION_NAME = 'SPAWN'
local FRAMES_IN_SPAWN_ANIM = 30

local SHOULD_KILL_CABLE = 'shouldKillCableKey'
local DEATH_ANIMATION_NAME = 'DEATH'
local FRAMES_IN_DEATH_ANIM = 30

local VISIBILITY_DELAY_ROUNDS = 3
local VISIBILITY_DELAY_KEY = 'visibilityDelayTimer'

--THESE ARE LISTED SO THEY MADE IT INTO THE WHITELIST
local B_CABLE_01 = 'B_Cable_Objective_SL.lvl'
local B_CABLE_02 = 'B_Cable_Objective_SL_02.lvl'
local B_CABLE_01_P2 = 'B_Cable_Objective_SL_P2.lvl'
local B_CABLE_02_P2 = 'B_Cable_Objective_SL_02_P2.lvl'
local R_CABLE_01 = 'R_Cable_Objective_SL.lvl'
local R_CABLE_02 = 'R_Cable_Objective_SL_02.lvl'
local R_CABLE_01_P2 = 'R_Cable_Objective_SL_P2.lvl'
local R_CABLE_02_P2 = 'R_Cable_Objective_SL_02_P2.lvl'
local W_CABLE_01 = 'W_Cable_Objective_SL.lvl'
local W_CABLE_02 = 'W_Cable_Objective_SL_02.lvl'
local W_CABLE_01_P2 = 'W_Cable_Objective_SL_P2.lvl'
local W_CABLE_02_P2 = 'W_Cable_Objective_SL_02_P2.lvl'

local B_CABLE_TL_01 = 'B_Cable_Objective_TL.lvl'
local B_CABLE_TL_02 = 'B_Cable_Objective_TL_02.lvl'
local B_CABLE_TL_01_P2 = 'B_Cable_Objective_TL_P2.lvl'
local B_CABLE_TL_02_P2 = 'B_Cable_Objective_TL_02_P2.lvl'
local R_CABLE_TL_01 = 'R_Cable_Objective_TL.lvl'
local R_CABLE_TL_02 = 'R_Cable_Objective_TL_02.lvl'
local R_CABLE_TL_01_P2 = 'R_Cable_Objective_TL_P2.lvl'
local R_CABLE_TL_02_P2 = 'R_Cable_Objective_TL_02_P2.lvl'
local W_CABLE_TL_01 = 'W_Cable_Objective_TL.lvl'
local W_CABLE_TL_02 = 'W_Cable_Objective_TL_02.lvl'
local W_CABLE_TL_01_P2 = 'W_Cable_Objective_TL_P2.lvl'
local W_CABLE_TL_02_P2 = 'W_Cable_Objective_TL_02_P2.lvl'

PowerPlantCable_tickTrigger = function(entity)
    local visibilityDelay = objc.tick_timer(entity, VISIBILITY_DELAY_KEY, VISIBILITY_DELAY_ROUNDS)
    if visibilityDelay == 0 then
        objc.set_entity_visibility(entity, true)
    end

    local hasPlayedSpawnAnim = objc.get_local_value(entity, HAS_PLAYED_SPAWN_ANIMATION)
    if hasPlayedSpawnAnim == 0 then
        local numSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_SPAWN_ANIM)
        objc.play_override_animation(entity, SPAWN_ANIMATION_NAME, numSubrounds)
        objc.set_local_value(entity, HAS_PLAYED_SPAWN_ANIMATION, 1)
    end

    local shouldStartPulseCountdown = objc.get_local_value(entity, SHOULD_START_PULSE_COUNTDOWN)
    if shouldStartPulseCountdown == 1 then
        local numSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_PULSE_ANIM)
        objc.play_override_animation(entity, PULSE_ANIMATION_NAME, numSubrounds)
        objc.set_local_value(entity, SHOULD_START_PULSE_COUNTDOWN, 0)
    end

    local shouldKillCableKey = objc.get_local_value(entity, SHOULD_KILL_CABLE)
    if shouldKillCableKey == 1 then
        local numSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_DEATH_ANIM)
        objc.play_override_animation(entity, DEATH_ANIMATION_NAME, numSubrounds)
        objc.add_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'PowerPlantCable.lua', 'PowerPlantCable_deathAfterAnimationTrigger')
        objc.set_local_value(entity, SHOULD_KILL_CABLE, 0)
    end
end

PowerPlantCable_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    return 0
end

PowerPlantCable_deathAfterAnimationTrigger = function(entity)
    local numRounds = objc.convert_frames_to_rounds(FRAMES_IN_DEATH_ANIM)
    local deathTick = objc.tick_timer(entity, 'deathTickTimerKey', numRounds)
    if deathTick == 0 then
        objc.sacrifice_entity(entity)
    end
end
