local PULSE_ANIMATION_NAME = 'SparkFollowsSpline'
local SHOULD_START_PULSE_COUNTDOWN = 'shouldStartPulseCountdown'
local FRAMES_IN_PULSE_ANIM = 60



PowerPlantCable_01_TutorialSpark_tickTrigger = function(entity)
    local shouldStartPulseCountdown = objc.get_local_value(entity, SHOULD_START_PULSE_COUNTDOWN)
    if shouldStartPulseCountdown == 0 then
        local numSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_PULSE_ANIM)
        objc.play_override_animation(entity, PULSE_ANIMATION_NAME, numSubrounds)
        objc.set_local_value(entity, SHOULD_START_PULSE_COUNTDOWN, 1)
    end

    local deathTimer = objc.tick_timer(entity, 'deathTimer', objc.convert_frames_to_subrounds(FRAMES_IN_PULSE_ANIM))
    if deathTimer == 0 then
        objc.sacrifice_entity(entity)
    end
end

PowerPlantCable_TutorialSpark_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    return 0
end
