local SPARK_KEY = 'sparkKey'
local PULSE_ANIMATION_NAME = 'PULSE'
local SHOULD_START_PULSE_COUNTDOWN = 'shouldStartPulseCountdown'
local FRAMES_IN_PULSE_ANIM = 60

local HAS_PLAYED_SPAWN_ANIMATION = 'hasPlayedSpawnAnimKey'
local SPAWN_ANIMATION_NAME = 'SPAWN'
local FRAMES_IN_SPAWN_ANIM = 30

local VISIBILITY_DELAY_ROUNDS = 3
local VISIBILITY_DELAY_KEY = 'visibilityDelayTimer'

local HAS_INIT = 'hasInit'

PowerPlantCable_Tutorial_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        objc.set_entity_visibility(entity, false)
        objc.set_local_value(entity, HAS_INIT, 1)
    end

    local visibilityDelay = objc.tick_timer(entity, VISIBILITY_DELAY_KEY, VISIBILITY_DELAY_ROUNDS)
    if visibilityDelay == 0 then
        objc.set_entity_visibility(entity, true)
    end

    local hasPlayedSpawnAnim = objc.get_local_value(entity, HAS_PLAYED_SPAWN_ANIMATION)
    if hasPlayedSpawnAnim == 0 then
        local numSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_SPAWN_ANIM)
        objc.play_override_animation(entity, SPAWN_ANIMATION_NAME, numSubrounds)
        objc.set_local_value(entity, HAS_PLAYED_SPAWN_ANIMATION, 1)
    end

    local shouldStartPulseCountdown = objc.get_local_value(entity, SHOULD_START_PULSE_COUNTDOWN)
    if shouldStartPulseCountdown == 1 then
        local numSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_PULSE_ANIM)
        objc.play_override_animation(entity, PULSE_ANIMATION_NAME, numSubrounds)
        local spark = objc.get_local_value(entity, SPARK_KEY)
        objc.set_local_value(spark, SHOULD_START_PULSE_COUNTDOWN, 1)
        objc.set_local_value(entity, SHOULD_START_PULSE_COUNTDOWN, 0)
    end
end

PowerPlantCable_Tutorial_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    return 0
end
