local PULSE_ANIMATION_NAME = 'SparkFollowsSpline'
local SHOULD_START_PULSE_COUNTDOWN = 'shouldStartPulseCountdown'
local FRAMES_IN_PULSE_ANIM = 60

local VISIBILITY_DELAY_ROUNDS = 3
local VISIBILITY_DELAY_KEY = 'visibilityDelayTimer'

local DEATH_TIMER = 40

PowerPlantCable_TutorialSpark_tickTrigger = function(entity)
    local visibilityDelay = objc.tick_timer(entity, VISIBILITY_DELAY_KEY, VISIBILITY_DELAY_ROUNDS)
    if visibilityDelay == 0 then
        objc.set_entity_visibility(entity, true)
    end

    local shouldStartPulseCountdown = objc.get_local_value(entity, SHOULD_START_PULSE_COUNTDOWN)
    if shouldStartPulseCountdown == 1 then
        local numSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_PULSE_ANIM)
        objc.play_override_animation(entity, PULSE_ANIMATION_NAME, numSubrounds)
        objc.set_local_value(entity, SHOULD_START_PULSE_COUNTDOWN, 0)
    end

    local deathTimer = objc.tick_timer(entity, "deathTimerKey", DEATH_TIMER)
    if deathTimer == 0 then
        objc.sacrifice_entity(entity)
    end
end

PowerPlantCable_TutorialSpark_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    return 0
end
