local PUSH_DISTANCE = 10000

--[[
The push ability sends back all enemies a set distance and reduces their health by half
--]]
Push = function(sourceEntity)
   local teamNumber = objc.get_team_number(sourceEntity)
   local playerNumber = objc.get_player_number(sourceEntity)
   local enemyNumber = objc.get_enemy_team_number(sourceEntity)
   local sideModifierX = 1

   if teamNumber == 1 then
      --
   elseif teamNumber == 2 then
      sideModifierX = -1
   else
      objc.scripting_error('invalid player number found: ' .. teamNumber)
   end

   objc.reveal_fog_duration(sourceEntity, 22000, 3)

   for _, enemy in pairs(objc.list_entities(enemyNumber)) do
      if objc.is_normal_unit(enemy) then
         local enemyPosition = objc.get_entity_position(enemy)
         local enemyDestination = enemyPosition[1] + PUSH_DISTANCE * sideModifierX

         if math.abs(enemyDestination) > 9500 then
            enemyDestination = 9500 * sideModifierX
         end

         objc.inflict_direct_damage(sourceEntity, enemy, objc.divide_with_floor(objc.get_entity_value(enemy, 'healthDefenseComponent.health'), 2))

         objc.teleport_entity(enemy, enemyDestination, enemyPosition[2])
      end
   end

   UnitAbility_activateTombstones(playerNumber, teamNumber)
end
