local MOVE_ANIMATION_NAME = 'normalMoveAnimationName'
local HAS_INIT = 'hasInitKey'
local MISSILE_TARGET = 'missileTargetKey'
local SPAWN_ANIM_NAME = 'spawnAnimationName'


R_AliciaAntiAirSeekerMissile_spawnTrigger = function(entity)
    local updatedAnimations = {}
    updatedAnimations[ANIMATION_STATE_MOVE] = MOVE_ANIMATION_NAME
    --updatedAnimations[ANIMATION_STATE_IDLE] = SPAWN_ANIM_NAME
    objc.update_animation_state(entity, updatedAnimations)
    objc.set_targetable(entity, false)
end

R_AliciaAntiAirSeekerMissile_tickTrigger = function(entity)
    --We have to use this pattern because we can't call move_entity_to_entity_with_motion in a unit's spawn trigger
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        local missileTarget = objc.get_local_value(entity, MISSILE_TARGET)
        if missileTarget ~= 0 then
            objc.move_entity_to_entity_with_motion(entity, missileTarget, MOTION_STATE_WALK, 100)
        else
            objc.sacrifice_entity(entity)
        end
        objc.set_local_value(entity, HAS_INIT, 1)
    end
end

R_AliciaAntiAirSeekerMissile_onOverrideTargetingCompletionTrigger = function(sourceEntity, targetEntity, targetingFailed)
    objc.kill_entity(targetEntity)
    objc.sacrifice_entity(sourceEntity)
end