local DURATION = 1000 --in game rounds
local HEALTH_TICK_INTERVAL = 10 --in game rounds
local HEALTH_INTERVAL_TIMER = 'healthIntervalTimerKey'
local STAGE_UPDATED_KEY = 'stageUpdatedKey'

R_AliciasTurret_tickTrigger = function(entity)
	local healthTick = objc.tick_timer(entity, HEALTH_INTERVAL_TIMER, HEALTH_TICK_INTERVAL)
	if healthTick == 0 then
		local maxHealth = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_HEALTH)
		local durationProp = objc.divide_with_ceiling(DURATION, HEALTH_TICK_INTERVAL)
		local healthToLose = objc.divide_with_ceiling(maxHealth, durationProp)
		objc.inflict_normal_damage(entity, entity, healthToLose)

        local currentHealth = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_CURRENT_HEALTH)
        local healthProp = objc.divide_with_ceiling(currentHealth * 5, maxHealth)
        local stageUpdated = objc.get_local_value(entity, STAGE_UPDATED_KEY)

        if healthProp > 4 and stageUpdated < 1 then
            local updatedAnimations = {}
            updatedAnimations[ANIMATION_STATE_IDLE] = 'idleStage1'
            updatedAnimations[ANIMATION_STATE_ATTACK_GROUND] = 'fireStage1'
            updatedAnimations[ANIMATION_STATE_ATTACK_AIR] = 'fireStage1'
            objc.update_animation_state(entity, updatedAnimations)
            objc.set_local_value(entity, STAGE_UPDATED_KEY, 1)
        elseif healthProp < 4 and healthProp > 2 and stageUpdated < 2 then
            local updatedAnimations = {}
            updatedAnimations[ANIMATION_STATE_IDLE] = 'idleStage2'
            updatedAnimations[ANIMATION_STATE_ATTACK_GROUND] = 'fireStage3'
            updatedAnimations[ANIMATION_STATE_ATTACK_AIR] = 'fireStage3'
            objc.update_animation_state(entity, updatedAnimations)
            objc.set_local_value(entity, STAGE_UPDATED_KEY, 2)
        elseif healthProp < 2 and stageUpdated < 3 then
            local updatedAnimations = {}
            updatedAnimations[ANIMATION_STATE_IDLE] = 'idleStage3'
            updatedAnimations[ANIMATION_STATE_ATTACK_GROUND] = 'fireStage3'
            updatedAnimations[ANIMATION_STATE_ATTACK_AIR] = 'fireStage3'
            objc.update_animation_state(entity, updatedAnimations)
            objc.set_local_value(entity, STAGE_UPDATED_KEY, 3)
        end
	end
end
