local DURATION = 100 --in game rounds
local HEALTH_TICK_INTERVAL = 2
local HEALTH_INTERVAL_TIMER = 'healthIntervalTimerKey'
local STAGE_UPDATED_KEY = 'stageUpdatedKey'

local SPAWN_ANIMATION_STATE = 'spawnAnimName'
local SPAWN_ANIMATION_COUNT = 15
local SPAWN_FINISHED = 0


R_Battery_PowerPlant_spawnTrigger = function(entity)
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_INCOME_TIER, 1)
    BuildingAbility_setNotSolidIfNextToTwoBoundaries(entity)

    local updatedAnimations = {}
    updatedAnimations[ANIMATION_STATE_IDLE] = SPAWN_ANIMATION_STATE
    objc.update_animation_state(entity, updatedAnimations)
    objc.idle_entity(entity, 999999)
end

R_Battery_PowerPlant_tickTrigger = function(entity)
    local spawnInTimer = objc.tick_timer(entity, 'spawnInTimer', SPAWN_ANIMATION_COUNT)
    if spawnInTimer == 0 or SPAWN_FINISHED == 1 then
        SPAWN_FINISHED = 1
        local healthTick = objc.tick_timer(entity, HEALTH_INTERVAL_TIMER, HEALTH_TICK_INTERVAL)
        if healthTick == 0 then
            local maxHealth = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_HEALTH)
            local currentHealth = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_CURRENT_HEALTH)
            local durationProp = objc.divide_with_ceiling(DURATION, HEALTH_TICK_INTERVAL + 1)
            local healthToLose = objc.divide_with_ceiling(maxHealth, durationProp)
            objc.inflict_direct_damage(entity, entity, healthToLose)

            local currentHealth = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_CURRENT_HEALTH)
            local healthProp = objc.divide_with_ceiling(currentHealth * 10, maxHealth)
            local stageUpdated = objc.get_local_value(entity, STAGE_UPDATED_KEY)

            if healthProp > 7 and stageUpdated < 1 then
                local updatedAnimations = {}
                updatedAnimations[ANIMATION_STATE_IDLE] = 'powerPlantAbilityIdle01'
                objc.update_animation_state(entity, updatedAnimations)
                objc.set_local_value(entity, STAGE_UPDATED_KEY, 1)
            elseif healthProp < 7 and healthProp > 3 and stageUpdated < 2 then
                local updatedAnimations = {}
                updatedAnimations[ANIMATION_STATE_IDLE] = 'powerPlantAbilityIdle02'
                objc.update_animation_state(entity, updatedAnimations)
                objc.set_local_value(entity, STAGE_UPDATED_KEY, 2)
            elseif healthProp < 4 and stageUpdated < 3 then
                local updatedAnimations = {}
                updatedAnimations[ANIMATION_STATE_IDLE] = 'powerPlantAbilityIdle03'
                objc.update_animation_state(entity, updatedAnimations)
                objc.set_local_value(entity, STAGE_UPDATED_KEY, 3)
            end
        end
    end
end

R_Battery_PowerPlant_reachedOvertimeTrigger = function(entity)
    objc.sacrifice_entity(entity)
end
