local IS_WRECKED = 'isWreckedKey'
local WRECK_IDLE_STATE ='wreckIdleAnimationName'
local WRECK_DEATH_STATE = 'wreckDieAnimationName'
local WRECK_SPAWN_STATE = 'wreckSpawnAnimationName'

local SHIELD_VFX = 'imp_R_ShieldSmall.lvl'

R_BigTank_spawnTrigger = function(entity)
    objc.set_local_value(entity, IS_WRECKED, 0)
end

R_BigTank_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    local armorAmount = objc.get_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_ARMOR)
    local flashCutoff = objc.divide_with_floor(armorAmount * 10, 4)
    local originalDamage = damage + armorAmount
    if originalDamage <= flashCutoff then
        objc.play_vfx(targetEntity, SHIELD_VFX, NODE_IMPACT)
    end
    local currentHealth = objc.get_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_CURRENT_HEALTH)
    local isWrecked =  objc.get_local_value(targetEntity, IS_WRECKED)
    if damage > currentHealth and isWrecked == 0 then
        --R_BigTank_getWrecked(targetEntity)
        --return 0
    end
    return damage
end


R_BigTank_getWrecked = function(entity)
    objc.set_local_value(entity, IS_WRECKED, 1)
    local wreckedAnimations = {}
    wreckedAnimations[ANIMATION_STATE_DEATH] = WRECK_DEATH_STATE
    wreckedAnimations[ANIMATION_STATE_IDLE] = WRECK_IDLE_STATE
    objc.update_animation_state(entity, wreckedAnimations)

    objc.set_entity_value_for_key(entity,ENTITY_VALUE_KEY_ATTACK_RANGE,0)

    objc.idle_entity(entity, 999999999) 
    objc.play_override_animation(entity, 'R_Tank_Barricade_Spawn_01', 1000)
    
    local maxHealth = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_HEALTH)
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_CURRENT_HEALTH, maxHealth - 1)
end

