local STAGE_UPDATED_KEY = 'stageUpdatedKey'
local SHIELD_VFX = 'imp_R_ShieldSmall.lvl'

R_Bunker_spawnTrigger = function(entity)
    objc.immobilize_entity(entity, 1000000)
    BuildingAbility_setNotSolidIfNextToTwoBoundaries(entity)
end

R_Bunker_reachedOvertimeTrigger = function(entity)
    objc.add_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'UnitAbilities.lua', 'UnitAbility_tickDownHealthTrigger')
end

R_Bunker_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    local armorAmount = objc.get_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_ARMOR)
    local flashCutoff = objc.divide_with_floor(armorAmount * 10, 4)
    local originalDamage = damage + armorAmount
    if originalDamage <= flashCutoff then
        objc.play_vfx(targetEntity, SHIELD_VFX, NODE_IMPACT)
    end
    return damage
end