local STARTING_SPEED_KEY = 'startingSpeedKey'
local SPEED_INCREASE_PER_TICK = 1
local MAX_VELOCITY_FACTOR = 3.0

R_Charger_spawnTrigger = function(entity)
    local originalSpeed = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY)
    objc.set_local_value(entity, STARTING_SPEED_KEY, originalSpeed)
end

R_Charger_tickTrigger = function(entity)
    local currentVelocity = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY)
    local originalSpeed = objc.get_local_value(entity, STARTING_SPEED_KEY)
    if currentVelocity <= (originalSpeed * MAX_VELOCITY_FACTOR) then
        objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, currentVelocity + SPEED_INCREASE_PER_TICK)
    else
        objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, math.floor(originalSpeed * MAX_VELOCITY_FACTOR))
    end
end

R_Charger_damageTrigger = function(damage, targetEntity, sourceEntity)
    local charger = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_SOURCE_ENTITY)
    local currentVelocity = objc.get_entity_value_for_key(charger, ENTITY_VALUE_KEY_MAX_VELOCITY)
    local originalSpeed = objc.get_local_value(charger, STARTING_SPEED_KEY)
    local damageFactor = objc.divide_with_floor(currentVelocity * 10, originalSpeed)
    objc.set_entity_value_for_key(charger, ENTITY_VALUE_KEY_MAX_VELOCITY, originalSpeed)
    return objc.divide_with_floor(damage * damageFactor, 10)
end