local DAMAGE_TIMER_KEY = 'damageTimerKey'
local HAS_BEEN_KNOCKED = 'hasBeenKnockedKey'
local DAMAGE_TICK_TIME = 5
local DAMAGE_ON_KNOCKBACK = 5
local DAMAGE_RADIUS = 400
local KNOCKBACK_DISTANCE = 650
local FRONT_BUFFER = 200

R_ChooChoo_tickTrigger = function(entity)
    local damageTick = objc.tick_timer(entity, DAMAGE_TIMER_KEY, DAMAGE_TICK_TIME)
    if damageTick == 0 then
        local enemyNumber = objc.get_enemy_team_number(entity)
        local enemies = objc.list_entities_in_radius(entity, DAMAGE_RADIUS, enemyNumber)
        R_ChooChoo_damageEntities(entity, enemies, DAMAGE_ON_KNOCKBACK)
    end
end


R_ChooChoo_damageEntities = function(choochoo, entityList, damage)
    local myPosX = objc.get_entity_value_for_key(choochoo, ENTITY_VALUE_KEY_POSITION_X)
    local myPosY = objc.get_entity_value_for_key(choochoo, ENTITY_VALUE_KEY_POSITION_Y)

    for _,target in pairs(entityList) do
        local hasBeenKnocked = objc.get_local_value(target, HAS_BEEN_KNOCKED)
        if objc.is_normal_unit(target) and hasBeenKnocked == 0 then
            local playerNumber = objc.get_player_number(choochoo)
            local targetPosX = objc.get_entity_value_for_key(target, ENTITY_VALUE_KEY_POSITION_X)
            local targetPosY = objc.get_entity_value_for_key(target, ENTITY_VALUE_KEY_POSITION_Y)
            local targetRange = objc.get_entity_value_for_key(target, ENTITY_VALUE_KEY_ATTACK_RANGE)

            objc.inflict_normal_damage(choochoo, target, damage)
            objc.flash_entity_for_damage(target, 250)
            local knockbackOffset = KNOCKBACK_DISTANCE + targetRange
            if targetPosY < myPosY then
                knockbackOffset = -KNOCKBACK_DISTANCE - targetRange
            end

            local moveToEntity = objc.spawn_at_point('chooChooTargetEntity', 1, playerNumber, targetPosX, targetPosY + knockbackOffset, 0, 0)
            objc.move_entity_to_entity_with_motion(target, moveToEntity[1], MOTION_STATE_LEAP, 600)
        end
    end
end
