local HAS_INIT = 'hasInitKey'
local HAS_GIVEN_CURRENCY = 'hasGivenCurrencyKey'
local IDLE_ANIM_STATE = 'combatMinerDig'
local CURRENCY_AMOUNT = 4
local IDLE_AMOUNT = 50
local IS_MINING = 'isMiningKey'
local INTERRUPT_ANIMATION_NAME = 'R_CombatMiner_Dig_Interrupt'

R_CombatMiner_spawnTrigger = function(entity)
    local updatedAnimations = {}
    updatedAnimations[ANIMATION_STATE_IDLE] = IDLE_ANIM_STATE
    objc.update_animation_state(entity, updatedAnimations)
    objc.set_local_value(entity, IS_MINING, 1)
end

R_CombatMiner_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        objc.idle_entity(entity, IDLE_AMOUNT * 100)
        objc.set_local_value(entity, HAS_INIT, 1)
    end

    local hasGivenCurrency = objc.get_local_value(entity, HAS_GIVEN_CURRENCY)
    local isMining = objc.get_local_value(entity, IS_MINING)
    if hasGivenCurrency == 0 and isMining == 1 then
        local idleTimer = objc.tick_timer(entity, 'idleTimerKey', IDLE_AMOUNT)
        if idleTimer == 0 then
            objc.set_local_value(entity, IS_MINING, 0)

            local playerNumber = objc.get_player_number(entity)
            objc.add_crystal(playerNumber, CURRENCY_AMOUNT)
            objc.idle_entity(entity, 2000)
            objc.play_override_animation(entity, 'R_CombatMiner_Celebrate', 3000)
            objc.set_local_value(entity, HAS_GIVEN_CURRENCY, 1)
        end
    end
end

R_CombatMiner_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    local isMining = objc.get_local_value(targetEntity, IS_MINING)
    if isMining == 1 then
        objc.set_local_value(targetEntity, IS_MINING, 0)
        objc.unidle_entity(targetEntity)
        objc.idle_entity(targetEntity, 750)
        objc.play_override_animation(targetEntity, INTERRUPT_ANIMATION_NAME, 750)
    end
    return damage
end
