local IS_PLAYING_ANIMATION = 'isPlayingAnimationKey'
local ATTACK_ANIMATION_NAME = 'R_Jackal_Attack_01'
local FRAMES_IN_ATTACK_ANIMATION = 60
local ANIMATION_TIMING_TRIGGER = 'R_Jackal_timeAnimationTrigger'

R_Jackal_onAttackTrigger = function(sourceEntity, targetEntity)
    local isPlayingAnimation = objc.get_local_value(sourceEntity, IS_PLAYING_ANIMATION)
    if isPlayingAnimation == 0 then
        objc.set_local_value(sourceEntity, IS_PLAYING_ANIMATION, 1)
        local numberOfSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_ATTACK_ANIMATION)
        objc.play_override_animation(sourceEntity, ATTACK_ANIMATION_NAME, numberOfSubrounds)
        objc.add_trigger(sourceEntity, TRIGGER_NAME_TICK_TRIGGER, 'R_Jackal.lua', ANIMATION_TIMING_TRIGGER)
    end
end

R_Jackal_timeAnimationTrigger = function(entity)
    local roundsInAttackAnim = objc.convert_frames_to_rounds(FRAMES_IN_ATTACK_ANIMATION)
    local animationTimer = objc.tick_timer(entity, 'animationTickKey', roundsInAttackAnim)
    if animationTimer == 0 then
        objc.set_local_value(entity, IS_PLAYING_ANIMATION, 0)
        objc.remove_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, ANIMATION_TIMING_TRIGGER)
    end
end