local OUT_OF_BASE_BUFFER = 4000
local ENGAGE_RANGE = 10000
local MAX_RANGE = 30000
local UPPER_X = 6000
local UPPER_Y = 2000
local LOWER_X = 500
local LOWER_Y = -2000
local HAS_SPAWNED_PROXY = 'hasSpawnedProxyKey'

R_MortarLauncher_spawnTrigger = function(entity)
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_RANGE, ENGAGE_RANGE)
end

R_MortarLauncher_actionSystemLoopStartTrigger = function(sourceEntity, targetEntity)
    R_MortarLauncher_spawnProxyIfNecessary(sourceEntity, targetEntity)
end

R_MortarLauncher_onAttackTrigger = function(sourceEntity, targetEntity)
    R_MortarLauncher_spawnProxyIfNecessary(sourceEntity, targetEntity)
end

R_MortarLauncher_damageTrigger = function(damage, targetEntity, sourceEntity)
    local mortarLauncher = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_SOURCE_ENTITY)
    objc.set_entity_value_for_key(mortarLauncher, ENTITY_VALUE_KEY_ATTACK_RANGE, MAX_RANGE)
    objc.set_local_value(mortarLauncher, HAS_SPAWNED_PROXY, 0)

    local targetId = objc.get_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_IDENTIFIER)
    if targetId == 'R_MortarLauncherProxy' then
        objc.sacrifice_entity(targetEntity)
    end
    return damage
end

R_MortarLauncher_spawnProxyIfNecessary = function(sourceEntity, targetEntity)
    local hasSpawnedProxy = objc.get_local_value(sourceEntity, HAS_SPAWNED_PROXY)
    if hasSpawnedProxy == 0 then
        local teamNumber = objc.get_team_number(sourceEntity)
        local enemyNumber = objc.get_player_number(targetEntity)
        local randomX = objc.roll_number(LOWER_X, UPPER_X)
        local randomY = objc.roll_number(LOWER_Y, UPPER_Y)
        local xDir = 1
        if teamNumber == 2 then
            xDir = -1
        end
        local proxyArray = objc.spawn_at_point('R_MortarLauncherProxy', 1, enemyNumber, randomX * xDir, randomY, 0, 0)
        objc.set_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_ATTACK_RANGE, MAX_RANGE)
        objc.set_targeting(sourceEntity, proxyArray[1])
        objc.set_local_value(sourceEntity, HAS_SPAWNED_PROXY, 1)
    end
end