local OFFSET_DISTANCE = 3000
local AOE_RADIUS = 250
local AOE_DAMAGE = 100
local AOE_VFX = 'scoutFlierKillEntityGround'

--[[
	THIS ONATTACKTRIGGER GIVES NAPALM FANATIC THE ABILITY TO
	DAMAGE UNITS BEHIND ITS CURRENT TARGET IN AN AOE
]]--

R_NapalmFanatic_onAttackTrigger = function (sourceEntity, targetEntity)
	local teamNumber = objc.get_team_number(sourceEntity)
	local entityPosition = objc.get_entity_position(sourceEntity)
	local targetPosition = objc.get_entity_position(targetEntity)
	local directionX = 0
    local playerNumber = objc.get_player_number(sourceEntity)

	if entityPosition[1] <= targetPosition[1] then
		directionX = 1
	else
		directionX = -1
	end
	
	local offset = directionX * OFFSET_DISTANCE
	local enemyListAtPoint = objc.list_enemies_in_radius_of_point(entityPosition[1] + offset, entityPosition[2], AOE_RADIUS, teamNumber)

	objc.spawn_at_point(AOE_VFX, 1, playerNumber, entityPosition[1] + offset, entityPosition[2], directionX, 0)

	for _, enemy in pairs(enemyListAtPoint) do
		if objc.is_ground_unit(enemy) and objc.is_normal_unit(enemy) then
			objc.inflict_normal_damage(sourceEntity, enemy, AOE_DAMAGE)
			objc.flash_entity_for_damage(enemy, 250)
		end
	end
end
