-- Keys
local NEXT_ATTACK_IS_DOUBLE_DAMAGE = 'overchargerDamageKey'
local SUPER_ATTACK_STATE = 'attackSuper'
local ATTACK_STATE = 'attackAnimationName'
local SUPER_CHARGED_VFX = 'idle_fireLoop.lvl'
local MUZZLE_NODE = 'VFX_muz'
local CHARGE_DURATION = 1000

R_Overcharger_spawnTrigger = function(entity)
   	objc.set_local_value(entity, NEXT_ATTACK_IS_DOUBLE_DAMAGE, 1)
    local superAttackAnims = {}
    superAttackAnims[ANIMATION_STATE_ATTACK_AIR] = SUPER_ATTACK_STATE
    superAttackAnims[ANIMATION_STATE_ATTACK_GROUND] = SUPER_ATTACK_STATE
    objc.update_animation_state(entity, superAttackAnims)
    objc.play_override_animation(entity, 'R_Overcharger_Super_Reload_01', CHARGE_DURATION)
    objc.idle_entity(entity, CHARGE_DURATION)
    objc.play_vfx(entity, SUPER_CHARGED_VFX, MUZZLE_NODE)
end

R_Overcharger_damageTrigger = function(damage, targetEntity, sourceEntity)
   local bulletSource = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_SOURCE_ENTITY)
   if objc.get_local_value(bulletSource, NEXT_ATTACK_IS_DOUBLE_DAMAGE) == 1 then
      objc.set_local_value(bulletSource, NEXT_ATTACK_IS_DOUBLE_DAMAGE, 0)
      local attackAnims = {}
  	  attackAnims[ANIMATION_STATE_ATTACK_AIR] = ATTACK_STATE
  	  attackAnims[ANIMATION_STATE_ATTACK_GROUND] = ATTACK_STATE
  	  objc.update_animation_state(bulletSource, attackAnims)
      return damage * 2
   end
   return damage
end

R_Overcharger_onAttackTrigger = function(sourceEntity, targetEntity)
    local bulletSource = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_SOURCE_ENTITY)
    if objc.get_local_value(bulletSource, NEXT_ATTACK_IS_DOUBLE_DAMAGE) == 1 then
      objc.stop_vfx(bulletSource, SUPER_CHARGED_VFX, MUZZLE_NODE, false)
   end
end