local PRIMARY_TARGET_KEY = 'primaryTargetKey'
local SPLASH_DISTANCE = 4000
local SPLASH_ANGLE = 45

R_PyroTutorial_spawnTrigger = function(entity)
    objc.set_local_value(entity, PRIMARY_TARGET_KEY, 0)
end

R_PyroTutorial_onAttackTrigger = function(sourceEntity, targetEntity)
    objc.set_local_value(sourceEntity, PRIMARY_TARGET_KEY, 0)
end

R_PyroTutorial_damageTrigger = function(damage, targetEntity, sourceEntity)
    local pyro = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_SOURCE_ENTITY)
    local primaryTarget = objc.get_local_value(pyro, PRIMARY_TARGET_KEY)

    local pyroPosition = objc.get_entity_position(pyro)
    local targetPosition = objc.get_entity_position(targetEntity)

    local trianglePoints = objc.get_triangle_points(pyroPosition[1], pyroPosition[2], targetPosition[1] - pyroPosition[1], targetPosition[2] - pyroPosition[2], SPLASH_DISTANCE, SPLASH_ANGLE)

    if primaryTarget == 0 then
        objc.set_local_value(pyro, PRIMARY_TARGET_KEY, targetEntity)
        local targetNumber = objc.get_team_number(targetEntity)
        local enemies = objc.list_entities_in_triangle(pyroPosition[1], pyroPosition[2], trianglePoints[1], trianglePoints[2], trianglePoints[3], trianglePoints[4], targetNumber)

        for _,enemy in pairs(enemies) do
            local enemyPos = objc.get_entity_position(enemy)
            if enemy ~= targetEntity and objc.is_ground_unit(enemy) then
                if objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_IS_BEING_PROTECTED) == 0 then
                    objc.inflict_normal_damage_no_armor(sourceEntity, enemy, damage)
                    objc.play_impact_vfx(sourceEntity, enemy)
                    objc.flash_entity_for_damage(enemy, 250)
                end
            end
        end
    end
    return damage
end


