local NUM_MISSILES = 3
local HAS_BEEN_TARGETED = 'hasBeenSeekerTargetedKey'
local DAMAGE_TARGET = 'damageTargetKey'
local DAMAGE_AMOUNT = 'damageAmountKey'
local SOURCE_SPELL_TIER = 'sourceSpellTierKey'
local HAS_INIT = 'hasInitKey'
local MISSILE_SPAWN_Y_OFFSET = 0
local MISSILE_SPAWN_X_OFFSET = 750


R_SeekerMissiles_spawnTrigger = function(entity)
   objc.set_entity_visibility(entity, false)

   local seek_radius = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_SPELL_RADIUS)
   local playerNumber = objc.get_player_number(entity)
   local teamNumber = objc.get_team_number(entity)
   local enemyNumber = objc.get_enemy_team_number(entity)
   local enemiesInRadius = objc.list_entities_in_radius(entity, seek_radius, enemyNumber)
   local descriptor = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_DESCRIPTION)
   local targetArray = {}
   --I know this is expensive but I don't know how to sort a list in lua
   for i = 1, NUM_MISSILES do
      local highestHealth = 1
      local healthiestEntity = entity
      for _, enemy in pairs(enemiesInRadius) do
         local hasBeenTargeted = objc.get_local_value(enemy, HAS_BEEN_TARGETED)
         if ((objc.is_building_unit(enemy) or objc.is_normal_unit(enemy) or objc.is_commander(enemy) or objc.is_base(enemy) or objc.is_barricade(enemy) or (objc.is_boss_unit(enemy) == 1)) and (objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_IS_BEING_PROTECTED) == 0)) and hasBeenTargeted == 0 then
            local currentHealth = objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_CURRENT_HEALTH)
            if currentHealth > highestHealth then
               highestHealth = currentHealth
               healthiestEntity = enemy
            end
         end
      end

      local sourceTier = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_TIER)
      local entityPos = objc.get_entity_position(entity)
      local xDir = 1
      if teamNumber == 2 then
         xDir = -1
      end


      if healthiestEntity ~= entity then
         local myTeamNumber = objc.get_team_number(entity)
         local myBase = objc.get_base_entity(myTeamNumber)
         local basePosition = objc.get_entity_position(myBase)

         local singleMissileArray = objc.spawn_at_point_with_source_entity('R_SingleSeekerMissile', 1, playerNumber, basePosition[1] + (MISSILE_SPAWN_X_OFFSET * xDir), basePosition[2] + MISSILE_SPAWN_Y_OFFSET, 1, 0, entity)
         objc.play_vfx(healthiestEntity, 'idle_target.lvl', NODE_STATUS)
         --local singleMissileArray = objc.spawn_at_point_with_source_entity('R_SingleSeekerMissile', 1, playerNumber, entityPos[1] + (MISSILE_SPAWN_X_OFFSET * xDir), entityPos[2] + (MISSILE_SPAWN_Y_OFFSET * (i - 1)), 1, 0, entity)
         objc.set_entity_visibility(singleMissileArray[1], false)
         local damageAmount = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_DAMAGE)
         objc.set_local_value(singleMissileArray[1], DAMAGE_TARGET, healthiestEntity)
         objc.set_local_value(singleMissileArray[1], DAMAGE_AMOUNT, damageAmount)
         objc.set_local_value(healthiestEntity, HAS_BEEN_TARGETED, 1)
         targetArray[i] = healthiestEntity
      end
   end

   for _, enemy in pairs(targetArray) do
      objc.set_local_value(enemy, HAS_BEEN_TARGETED, 0)
   end

   objc.sacrifice_entity(entity)
end
