local MOVE_SPEED_BONUS = 100
local ROADSTER_SPEED_KEY = 'roadsterSpeedBuff'
local BUFF_VFX = 'CommanderPowerUpText.lvl'


R_SniperRoadster_spawnTrigger = function(entity)
    R_SniperRoadster_buffUnit(entity)
end


R_SniperRoadster_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    if objc.get_local_value(targetEntity, ROADSTER_SPEED_KEY) == 1 then
        R_SniperRoadster_removeBuff(targetEntity)
    end
    return damage
end

R_SniperRoadster_onAttackTrigger = function(sourceEntity, targetEntity)
    if objc.get_local_value(sourceEntity, ROADSTER_SPEED_KEY) == 1 then
        R_SniperRoadster_removeBuff(sourceEntity)
    end
end

R_SniperRoadster_buffUnit = function(entity)
    local thisSpeed = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY)
    local buffToGive = objc.divide_with_floor(MOVE_SPEED_BONUS * thisSpeed, 100)
    --print('RAGE ADDING thisSpeed: ' .. thisSpeed .. ' buffToGive: ' .. buffToGive)
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, thisSpeed + buffToGive)
    --print("NEW SPEED: " .. objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY))

    objc.play_vfx(entity, BUFF_VFX, NODE_STATUS)

    objc.set_local_value(entity, ROADSTER_SPEED_KEY, 1)
end

R_SniperRoadster_removeBuff = function(entity)
    local thisSpeed = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY)
    local buffRemovalMultiplier = 100 - objc.divide_with_ceiling(10000, MOVE_SPEED_BONUS + 100)
    local buffToRemove = objc.divide_with_ceiling(buffRemovalMultiplier * thisSpeed, 100)


    --print('RAGE REMOVING thisSpeed: ' .. thisSpeed .. ' buffToRemove: ' .. buffToRemove)
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, thisSpeed - buffToRemove)
    --print("NEW SPEED: " .. objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY))

    objc.stop_vfx(entity, BUFF_VFX, NODE_STATUS, false)

    objc.set_local_value(entity, ROADSTER_SPEED_KEY, 0)
end
