local TRIGGER_DISTANCE = 150
local IS_EXPLODING = 'isExplodingKey'
local DAMAGE_KEY = 'damageAmountKey'

--[[
This OnAttackTrigger kills the Banezing and deals a set amount of damage to all
ground enemy units around it within a set radius.
--]]
R_SpiderBomb_onAttackTrigger = function(sourceEntity, targetEntity)
    local blinkParams = {} 
    blinkParams['red'] = 255
    blinkParams['green'] = 0
    blinkParams['blue'] = 0
    blinkParams['alpha'] = 60
    blinkParams['initialBlinkFrequency'] = 30
    blinkParams['finalBlinkFrequency'] = 30
    blinkParams['initialBlinkIntensity'] = 16
    blinkParams['finalBlinkIntensity'] = 16
    blinkParams['animationDurationInDeciseconds'] = 0
    blinkParams['animationAcceleration'] = 50
    blinkParams['easingType'] = EASE_OUT
    objc.start_blinking(sourceEntity, blinkParams)

    objc.sacrifice_entity(sourceEntity)
end

R_SpiderBomb_deathTrigger = function(entity)
    local delayEntity = objc.spawn_at_entity('R_SpiderBomb_ExplosionDelayScriptEntity', 1, entity)
    local damageAmount = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_DAMAGE)
    objc.set_local_value(delayEntity[1], DAMAGE_KEY, damageAmount)
end

R_SpiderBomb_damageTrigger = function(damage, targetEntity, sourceEntity)
    local isExploding = objc.get_local_value(sourceEntity, IS_EXPLODING)
    if isExploding == 1 then
        return damage
    end
    return 0
end

R_SpiderBomb_spawnTrigger = function(entity)
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_RANGE, TRIGGER_DISTANCE)
end
