local TRIGGER_DISTANCE = 150
local IS_EXPLODING = 'isExplodingKey'
local IS_ARMED = 'isArmedKey'
local ARMING_TIME = 1
local DAMAGE_AMOUNT_KEY = 'damageAmountKey'

local ALIVE_TIME = 100

R_SpiderBombMine_onAttackTrigger = function(sourceEntity, targetEntity)
    objc.sacrifice_entity(sourceEntity)
end

R_SpiderBombMine_deathTrigger = function(entity)
    local attackDamage = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_DAMAGE)
    local scriptEntity = objc.spawn_at_entity('R_SpiderBombMine_ExplosionDelayScriptEntity', 1, entity)
    objc.set_local_value(scriptEntity[1], DAMAGE_AMOUNT_KEY, attackDamage)
end

R_SpiderBombMine_damageTrigger = function(damage, targetEntity, sourceEntity)
    local isExploding = objc.get_local_value(sourceEntity, IS_EXPLODING)
    if isExploding == 1 then
        return damage
    end
    return 0
end

R_SpiderBombMine_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    return 0
end

R_SpiderBombMine_spawnTrigger = function(entity)
    objc.play_override_animation(entity, 'R_SpiderBomb_Mine_Spawn_01', objc.convert_frames_to_subrounds(30))
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_RANGE, TRIGGER_DISTANCE)
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
    objc.idle_entity(entity, ARMING_TIME * 100)
    objc.set_targetable(entity, false)
    objc.set_solid(entity, false)
end

R_SpiderBombMine_tickTrigger = function(entity)
    local isArmed = objc.get_local_value(entity, IS_ARMED)
    if isArmed == 0 then
        local armingTimer = objc.tick_timer(entity, 'armingTickTimerKey', ARMING_TIME)
        if armingTimer == 0 then
            objc.set_local_value(entity, IS_ARMED, 1)
            objc.set_targetable(entity, false)

            local blinkParams = {}
            blinkParams['red'] = 255
            blinkParams['green'] = 0
            blinkParams['blue'] = 0
            blinkParams['alpha'] = 60
            blinkParams['initialBlinkFrequency'] = 30
            blinkParams['finalBlinkFrequency'] = 30
            blinkParams['initialBlinkIntensity'] = 16
            blinkParams['finalBlinkIntensity'] = 16
            blinkParams['animationDurationInDeciseconds'] = 0
            blinkParams['animationAcceleration'] = 50
            blinkParams['easingType'] = EASE_OUT
            objc.start_blinking(entity, blinkParams)
        end
    end

    local aliveTimer = objc.tick_timer(entity, 'lifetimeTickTimer', ALIVE_TIME)
    if aliveTimer == 0 then
        objc.sacrifice_entity(entity)
    end
end
