local IS_EXPLODING = 'isExplodingKey'
local DAMAGE_KEY = 'damageAmountKey'

--[[
This TickTrigger waits a few ticks and then spawns a bunch of mines.
--]]
R_SpiderBomb_ExplosionDelayScriptEntity_tickTrigger = function(entity)
    local timer = objc.tick_timer(entity, 'timer', 5)

    if timer == 0 then
        objc.set_local_value(entity, IS_EXPLODING, 1)
        local enemyNumber = objc.get_enemy_team_number(entity)
        local damageAmount = objc.get_local_value(entity, DAMAGE_KEY)
        for _, enemy in pairs(objc.list_entities_in_radius(entity, 1100, enemyNumber)) do
            if objc.is_ground_unit(enemy) then
                objc.inflict_normal_damage(entity, enemy, damageAmount)
            end
        end
        objc.sacrifice_entity(entity)
    end
end
