local SPAWN_IDENTIFIER = 'R_DropBomb'
local LAST_X_KEY = 'lastXKey'
local AMOUNT_TRAVELED_KEY = 'amountTraveledKey'
local SPAWN_DISTANCE = 1000

R_TroopCarrier_spawnTrigger = function(entity)
    local thisX = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_POSITION_X)
    objc.set_local_value(entity, LAST_X_KEY, thisX)
end

R_TroopCarrier_tickTrigger = function(entity)
    local lastX = objc.get_local_value(entity, LAST_X_KEY)
    local thisX = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_POSITION_X)
    local amountTraveled = objc.get_local_value(entity, AMOUNT_TRAVELED_KEY)
    local thisTraveledDistance = math.abs(thisX - lastX)
    if amountTraveled + thisTraveledDistance >= SPAWN_DISTANCE then
        objc.spawn_at_entity(SPAWN_IDENTIFIER, 1, entity)
        objc.set_local_value(entity, AMOUNT_TRAVELED_KEY, 0)
    else
        objc.set_local_value(entity, AMOUNT_TRAVELED_KEY, amountTraveled + thisTraveledDistance)
    end

    objc.set_local_value(entity, LAST_X_KEY, thisX)
end

