local NEARBY_CHECK_TIMER = 5
local NEARBY_CHECK_KEY = 'nearbyCheckTimerKey'
local NEARBY_RADIUS = 600
local MOVING_VELOCITY = 60

R_WheeledWall_spawnTrigger = function(entity)
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
end

R_WheeledWall_tickTrigger = function(entity)
    local nearbyCheckTimer = objc.tick_timer(entity, NEARBY_CHECK_KEY, NEARBY_CHECK_TIMER)
    if nearbyCheckTimer == 0 then
        local teamNumber = objc.get_team_number(entity)
        local wallXPos = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_POSITION_X)

        local xDir = -1
        if teamNumber == 2 then
            xDir = 1
        end

        local shouldBeMoving = false

        local allies = objc.list_entities_in_radius(entity, NEARBY_RADIUS, teamNumber)
        for _,ally in pairs(allies) do
            local allyXPos = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_POSITION_X)
            local difference = (allyXPos - wallXPos) * xDir
            if difference > 0 and objc.is_normal_unit(ally) 
            	and ally ~= entity and objc.is_ground_unit(ally) then
                shouldBeMoving = true
            end
        end

        if shouldBeMoving == true then
            objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, MOVING_VELOCITY)
        else
            objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
        end
    end
end
