local DAMAGE_KEY = 'damageAmountKey'
local RADIUS_KEY = 'radiusKey'
local TIMER_KEY = 'timerKey'
local TARGET_AIR_KEY = 'targetAirKey'
local TARGET_GROUND_KEY = 'targetGroundKey'


R_Zeppelin_deathTrigger = function(entity)
    local blinkParams = {} 
    blinkParams['red'] = 128
    blinkParams['green'] = 0
    blinkParams['blue'] = 0
    blinkParams['alpha'] = 64
    blinkParams['initialBlinkFrequency'] = 30
    blinkParams['finalBlinkFrequency'] = 30
    blinkParams['initialBlinkIntensity'] = 4
    blinkParams['finalBlinkIntensity'] = 4
    blinkParams['animationDurationInDeciseconds'] = 0
    blinkParams['animationAcceleration'] = 50
    blinkParams['easingType'] = EASE_NONE
    objc.start_blinking(entity, blinkParams)

    local delayEntity = objc.spawn_at_entity('Generic_ExplosionDelayScriptEntity', 1, entity)
    local damageAmount = objc.get_combat_entity_custom_stat(entity, CUSTOM_ENTITY_STAT_KEY_EXPLOSION_DAMAGE)
    objc.set_local_value(delayEntity[1], DAMAGE_KEY, damageAmount)
    local radius = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_SPELL_RADIUS)
    objc.set_local_value(delayEntity[1], RADIUS_KEY, radius)
    objc.set_local_value(delayEntity[1], TIMER_KEY, 27)
    objc.set_local_value(delayEntity[1], TARGET_AIR_KEY, 0)
    objc.set_local_value(delayEntity[1], TARGET_GROUND_KEY, 1)
end
