InsertIdentifierNameHere_spawnTrigger = function(factory, spawnedEntity)
   --This gets the player number
   playerNumber = objc.get_player_number(spawnedEntity)

   --This sets the key for getting and setting the number of units being spawned into a global variable
   key = 'spawnNumber' .. objc.get_entity_value(factory, 'description')

   --This looks at how many units were spawned in the previous wave and enters the number into the spawnCount variable.  If this is the first time the unit is spawned it will default to 0
   previousSpawnCount = objc.get_global_value(key)

   --This gets how many units are now being spawned in the current wave
   currentFactorySpawnCount = objc.get_entity_value(factory, 'spawnQuantity')

   --Setting the default value for battleCryMultiplier so that if no new units were built it will default to not doing anything
   battleCryMultiplier = 0

   --Check to see if the current number of units being spawned is higher than in the previous wave.  This tells us how many new units there are and therefore how many battlecry effects should happen
   if currentFactorySpawnCount > previousSpawnCount then
      --battleCryMultiplier is being set to the number of new units there are in the new wave.  This value can be used for determining how many BattleCry effects to trigger
      battleCryMultiplier =  currentFactorySpawnCount - previousSpawnCount
   end

   --Here's an example of a Battle Cry effect.  If the below line is uncommented, the game will spawn a rifleman for each new battlecry unit that was built in the last wave.
   objc.spawn('B_ShieldTrooper', battleCryMultiplier, playerNumber)

   --Here we set the current number of units spawned to the global value so we can check it again next wave.  This should always be at the bottom of the script
   objc.set_global_value(key, currentFactorySpawnCount)
   return 0
end



