local HAS_INIT = 'bossInit'

local UNIT_LUA = 'TwovE_SurvivalBoss.lua'

local UNIT_HAS_SPAWNED = 'unitHasSpawned'
local IDLE_TIMER_KEY = 'idleTimerKey'

local CHECK_TICK = 5
local CHECK_KEY = 'checkKey'

TwovE_SurvivalBoss_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'N_Tank' then
                if objc.get_local_value(unit, HAS_INIT) == 0 then
                    if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'N_Tank' then
                        objc.set_entity_scale_percentage(unit, 140)
                    elseif objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'N_Tank3' then
                        objc.set_entity_scale_percentage(unit, 160)
                        local newMaxHP = 2 * objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH)
                        objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                        objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
                    elseif objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'N_Tank6' then
                        objc.set_entity_scale_percentage(unit, 180)
                        local newMaxHP = 2 * objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH)
                        objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                        objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
                    elseif objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'N_Tank9' then
                        objc.set_entity_scale_percentage(unit, 200)
                        local newMaxHP = 2 * objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH)
                        objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                        objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
                        objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_DAMAGE))
                    end
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, UNIT_LUA, 'Boss_idleTrigger')
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_RANGE, 3000)
                    objc.move_entity_to_location_with_velocity(unit, 5000, 0, 40, 70)
                    objc.set_local_value(unit, HAS_INIT, 1)
                end
            end
        end
    end
end

Boss_idleTrigger = function(entity)
    local hasSpawned = objc.get_local_value(entity, UNIT_HAS_SPAWNED)
    local idleTimer = objc.tick_timer(entity, IDLE_TIMER_KEY, 20)
    if idleTimer == 0 and hasSpawned == 0 then
        objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
        objc.set_local_value(entity, UNIT_HAS_SPAWNED, 1)
    end
end