local GAME_HAS_INIT = 'gameHasInit'
local UNIT_HAS_SPAWMED = 'unitHasSpawned'

local CHECK_TICK = 100
local CHECK_KEY = "checkKey"

local IDLE_TIME = 20000000

local LUA_ID = 'W1CampaignArcher.lua'



W1CampaignArcher_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if HasInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'W_Archer1' then
                objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'W1Region1Archer_ImmobilizeTrigger')
                objc.set_entity_scale_percentage(unit, 180)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_RANGE, 5000)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, 400)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, 400)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ARMOR, 30)
                objc.set_entity_display_name(unit, 'Kana')
                objc.set_entity_unit_description(unit, 'Purge the unworthy!')
            elseif objc.is_barricade(unit) then
                objc.kill_entity(unit)
            end
        end
        objc.set_local_value(entity, GAME_HAS_INIT, 1)
    end
end

W1CampaignArcher_ImmobilizeTrigger = function(entity)
    local hasSpawned = objc.get_local_value(entity, UNIT_HAS_SPAWMED)
    if hasSpawned == 0 then
        objc.immobilize_entity(entity, IDLE_TIME)
        objc.set_local_value(entity, UNIT_HAS_SPAWMED, 1)
    end
end
