local HAS_INIT = 'hasInit'
local LONGSHOT_INIT = 'longshotInit'
local ROCKET_INIT = 'rocketInit'

local CHECK_TICK = 10
local CHECK_KEY = "checkKey"
local LUA_FILE = 'W1CampaignBasicBoss.lua'

W1CampaignBasicBoss_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, HAS_INIT)
    if HasInit == 0 then
        local base = objc.get_base_entity(2)
        objc.add_trigger(base, TRIGGER_NAME_ON_DAMAGE_TRIGGER, LUA_FILE, 'base_invulnerable')
        objc.set_targetable(base, false)

        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            -- Assume the first Rifleman of the game is the opponent boss
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_Rifleman' then
                objc.idle_entity_indefinitely(unit)

                objc.set_entity_scale_percentage(unit, 180)
                local newMaxHP = 3000
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
                local damageBuff = 160
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, damageBuff)

                objc.add_trigger(unit, TRIGGER_NAME_ON_DAMAGE_TRIGGER, LUA_FILE, 'W1CampaignBasicBoss_spellResistant')

                objc.set_local_value(entity, HAS_INIT, 1)
                break
            end
        end
    elseif HasInit == 1 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_Rifleman' then
                objc.set_entity_facing_direction(unit, -1, 0)
                objc.set_local_value(entity, HAS_INIT, 2)
                break
            end
        end
    end

    local longshotInit = objc.get_local_value(entity, LONGSHOT_INIT)
    if longshotInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'B_Longshot2' then
                objc.set_entity_scale_percentage(unit, 130)
                local newMaxHP = 2 * objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
                local damageDebuff = objc.divide_with_ceiling(objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_DAMAGE), 2)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, -1 * damageDebuff)

                objc.set_local_value(entity, LONGSHOT_INIT, 1)
                break
            end
        end
    end

    local rocketInit = objc.get_local_value(entity, ROCKET_INIT)
    if rocketInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'B_RocketTrooper2' then
                objc.set_entity_scale_percentage(unit, 130)
                local newMaxHP = 2 * objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
                local damageDebuff = objc.divide_with_ceiling(2 * objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_DAMAGE), 3)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, -1 * damageDebuff)

                objc.set_local_value(entity, ROCKET_INIT, 1)
                break
            end
        end
    end
end

-- OnDamageTrigger
W1CampaignBasicBoss_spellResistant = function(damage, targetEntity, sourceEntity)
    local source = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_SOURCE_ENTITY)
    local sourceIdentifier = objc.get_entity_value_for_key(source, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER)
    if sourceIdentifier == 'W_Blast' or sourceIdentifier == 'W_Fog' then
        return objc.divide_with_ceiling(damage, 3)
    end
    return damage
end

base_invulnerable = function(entity)
    return 0
end