local HAS_INIT = 'hasInit'

local CHECK_TICK = 10
local CHECK_KEY = "checkKey"
local ACTIVATE_SHOT = 'activateShot'
local SECOND_COUNTER = 'secondCounter'
local FIRST_COUNTER = 'firstCounter'
local ACTIVATE_BOSS = 'activateBoss'
local MOVE_TO_TARGET_TIME_ROUNDS = 7
local AIR_MOVE_ANIMATION_NAME = 'normalMoveAnimationName'
local GROUND_MOVE_ANIMATION_NAME = 'groundMoveAnimationName'
local EFFECT_IS_PLAYING = 'effectIsPlaying'
local EXPLOSION_ENTITY = 'CallowayTargetEntity'
local HAS_PLAYED = 'hasPlayed'

local LUA_FILE = 'W1CampaignCalloway.lua'

W1CampaignCalloway_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, HAS_INIT)
    if HasInit == 0 then
        local base = objc.get_base_entity(2)
        objc.add_trigger(base, TRIGGER_NAME_ON_DAMAGE_TRIGGER, LUA_FILE, 'base_invulnerable')
        objc.set_targetable(base, false)

        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_RocketTrooperCampaign' then
                objc.idle_entity_indefinitely(unit)
                objc.set_entity_scale_percentage(unit, 140)
                local newMaxHP = 6000
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
  --[[              local damageDebuff = 1600
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, -1 * damageDebuff)
--]]
                objc.add_trigger(unit, TRIGGER_NAME_ON_DAMAGE_TRIGGER, 'W1CampaignCalloway.lua', 'W1CampaignCalloway_spellResistant')
                objc.set_local_value(entity, HAS_INIT, 1)
                break
            end
        end
    elseif HasInit == 1 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_RocketTrooperCampaign' then
                objc.set_entity_facing_direction(unit, -1, 0)
                objc.set_local_value(entity, HAS_INIT, 2)
                break
            end
        end
    end



    local activateShot = objc.get_global_value(ACTIVATE_SHOT)
    -- triggered in .json
    if activateShot == 1 then
        local firstTimer = objc.tick_timer(entity, "firstTimerKey", 10)
        --increments each second until it reaches 15 and resets
        if firstTimer == 0 then
            local firstCounter = objc.get_local_value(entity, FIRST_COUNTER)
            if firstCounter >= 20 then
                local slowShot = objc.spawn_at_point('B_BallLightningCampaign', 1, 2, 5000, 0, -1, 0)
                objc.set_solid(slowShot[1], false)
                objc.set_targetable(slowShot[1], false)
                objc.set_entity_scale_percentage(slowShot[1], 85)
                objc.move_entity_to_location_with_velocity(slowShot[1], -5000, 0, 70, 70)
                objc.set_entity_air_height_alignment(slowShot[1], AIR_HEIGHT_ALIGN_BOTTOM)
                objc.set_local_value(entity, FIRST_COUNTER,0)
                local updatedAnimations = {}
                updatedAnimations[ANIMATION_STATE_IDLE] = ''
                updatedAnimations[ANIMATION_STATE_MOVE] = AIR_MOVE_ANIMATION_NAME
                objc.update_animation_state(slowShot[1], updatedAnimations)
                objc.move_entity_to_vertical_height(slowShot[1], 0, MOVE_TO_TARGET_TIME_ROUNDS * 100, EASE_NONE, 20)
            elseif firstCounter == 18 then
                local slowShot = objc.spawn_at_point('B_BallLightningCampaign', 1, 2, 5000, 0, -1, 0)
                objc.set_solid(slowShot[1], false)
                objc.set_targetable(slowShot[1], false)
                objc.set_entity_scale_percentage(slowShot[1], 85)
                objc.move_entity_to_location_with_velocity(slowShot[1], -5000, 0, 70, 70)
                objc.set_entity_air_height_alignment(slowShot[1], AIR_HEIGHT_ALIGN_BOTTOM)
                objc.set_local_value(entity, FIRST_COUNTER, firstCounter +1)
                local updatedAnimations = {}
                updatedAnimations[ANIMATION_STATE_IDLE] = ''
                updatedAnimations[ANIMATION_STATE_MOVE] = AIR_MOVE_ANIMATION_NAME
                objc.update_animation_state(slowShot[1], updatedAnimations)
                objc.move_entity_to_vertical_height(slowShot[1], 0, MOVE_TO_TARGET_TIME_ROUNDS * 100, EASE_NONE, 0)
            elseif firstCounter == 16 then
                local slowShot = objc.spawn_at_point('B_BallLightningCampaign', 1, 2, 5000, 0, -1, 0)
                objc.set_solid(slowShot[1], false)
                objc.set_targetable(slowShot[1], false)
                objc.set_entity_scale_percentage(slowShot[1], 85)
                objc.move_entity_to_location_with_velocity(slowShot[1], -5000, 0, 70, 70)
                objc.set_entity_air_height_alignment(slowShot[1], AIR_HEIGHT_ALIGN_BOTTOM)
                objc.set_local_value(entity, FIRST_COUNTER, firstCounter +1)
                local updatedAnimations = {}
                updatedAnimations[ANIMATION_STATE_IDLE] = ''
                updatedAnimations[ANIMATION_STATE_MOVE] = AIR_MOVE_ANIMATION_NAME
                objc.update_animation_state(slowShot[1], updatedAnimations)
                objc.move_entity_to_vertical_height(slowShot[1], 0, MOVE_TO_TARGET_TIME_ROUNDS * 100, EASE_NONE, 20)
            elseif (firstCounter == 15 or firstCounter == 17 or firstCounter == 19) then

                objc.add_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'W1CampaignCalloway.lua', 'W1CampaignCalloway_playAnimation')
                objc.set_local_value(entity, FIRST_COUNTER, firstCounter +1)
            else
                objc.set_local_value(entity, FIRST_COUNTER, firstCounter +1)
            end
        end

        if objc.get_local_value(entity, EFFECT_IS_PLAYING) == 0 then
            local team2Entities = objc.list_entities(2)
            for _,unit in pairs(team2Entities) do
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_BallLightningCampaign' then
                    objc.spawn_at_point(EXPLOSION_ENTITY, 1, 2, 4000, 0, -1, 0)
                    objc.set_local_value(entity, EFFECT_IS_PLAYING, 1)
                    break
                end
            end
        else
            -- if the effect is playing, check to make sure there are still living shots
            local team2Entities = objc.list_entities(2)
            local shotsPlaying = 0
            for _, unit in pairs(team2Entities) do
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_BallLightningCampaign' then
                    shotsPlaying = 1
                    break
                end
            end
            -- if not, kill the fx
            if shotsPlaying == 0 then
                local team2Entities = objc.list_entities(2)
                for _, unit in pairs(team2Entities) do
                    if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'CallowayTargetEntity' then
                        objc.sacrifice_entity(unit)
                        objc.set_local_value(entity, EFFECT_IS_PLAYING, 0)
                        break
                    end
                end
            end
        end

    elseif activateShot == 2 then
        --increments each second until it reaches 15 and resets
        local secondTimer = objc.tick_timer(entity, "secondTimerKey", 10)
        if secondTimer == 0 then
            local secondCounter = objc.get_local_value(entity, SECOND_COUNTER)
            if secondCounter >= 5 then
                local slowShot = objc.spawn_at_point('B_BallLightningCampaign', 1, 2, 5000, 0, -1, 0)
                objc.set_solid(slowShot[1], false)
                objc.set_targetable(slowShot[1], false)
                objc.set_entity_scale_percentage(slowShot[1], 85)
                objc.move_entity_to_location_with_velocity(slowShot[1], -5000, 0, 70, 70)
                objc.set_entity_air_height_alignment(slowShot[1], AIR_HEIGHT_ALIGN_BOTTOM)
                objc.set_local_value(entity, SECOND_COUNTER,0)
                local updatedAnimations = {}
                updatedAnimations[ANIMATION_STATE_IDLE] = ''
                updatedAnimations[ANIMATION_STATE_MOVE] = AIR_MOVE_ANIMATION_NAME
                objc.update_animation_state(slowShot[1], updatedAnimations)
                objc.move_entity_to_vertical_height(slowShot[1], -300, MOVE_TO_TARGET_TIME_ROUNDS * 100, EASE_NONE, 20)
                objc.set_global_value(ACTIVATE_SHOT, 1)
            elseif secondCounter == 3 then
                local slowShot = objc.spawn_at_point('B_BallLightningCampaign', 1, 2, 5000, 0, -1, 0)
                objc.set_solid(slowShot[1], false)
                objc.set_targetable(slowShot[1], false)
                objc.set_entity_scale_percentage(slowShot[1], 85)
                objc.move_entity_to_location_with_velocity(slowShot[1], -5000, 0, 70, 70)
                objc.set_entity_air_height_alignment(slowShot[1], AIR_HEIGHT_ALIGN_BOTTOM)
                objc.set_local_value(entity, SECOND_COUNTER, secondCounter +1)
                local updatedAnimations = {}
                updatedAnimations[ANIMATION_STATE_IDLE] = ''
                updatedAnimations[ANIMATION_STATE_MOVE] = AIR_MOVE_ANIMATION_NAME
                objc.update_animation_state(slowShot[1], updatedAnimations)
                objc.move_entity_to_vertical_height(slowShot[1], -200, MOVE_TO_TARGET_TIME_ROUNDS * 100, EASE_NONE, 20)
            elseif secondCounter == 1 then
                local slowShot = objc.spawn_at_point('B_BallLightningCampaign', 1, 2, 5000, 0, -1, 0)
                objc.set_solid(slowShot[1], false)
                objc.set_targetable(slowShot[1], false)
                objc.set_entity_scale_percentage(slowShot[1], 85)
                objc.move_entity_to_location_with_velocity(slowShot[1], -5000, 0, 70, 70)
                objc.set_entity_air_height_alignment(slowShot[1], AIR_HEIGHT_ALIGN_BOTTOM)
                objc.set_local_value(entity, SECOND_COUNTER, secondCounter +1)
                local updatedAnimations = {}
                updatedAnimations[ANIMATION_STATE_IDLE] = ''
                updatedAnimations[ANIMATION_STATE_MOVE] = AIR_MOVE_ANIMATION_NAME
                objc.update_animation_state(slowShot[1], updatedAnimations)
                objc.move_entity_to_vertical_height(slowShot[1], -100, MOVE_TO_TARGET_TIME_ROUNDS * 100, EASE_NONE, 20)
                --play the attack animation
            elseif (secondCounter == 0 or secondCounter == 2 or secondCounter == 4) then
                objc.add_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'W1CampaignCalloway.lua', 'W1CampaignCalloway_playAnimation')
                objc.set_local_value(entity, SECOND_COUNTER, secondCounter +1)
            else
                objc.set_local_value(entity, SECOND_COUNTER, secondCounter +1)
            end
        end


        if objc.get_local_value(entity, EFFECT_IS_PLAYING) == 0 then
            local team2Entities = objc.list_entities(2)
            for _,unit in pairs(team2Entities) do
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_BallLightningCampaign' then
                    objc.spawn_at_point(EXPLOSION_ENTITY, 1, 2, 4000, 0, -1, 0)
                    objc.set_local_value(entity, EFFECT_IS_PLAYING, 1)
                    break
                end
            end
        else
            -- if the effect is playing, check to make sure there are still living shots
            local team2Entities = objc.list_entities(2)
            local shotsPlaying = 0
            for _, unit in pairs(team2Entities) do
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_BallLightningCampaign' then
                    shotsPlaying = 1
                    break
                end
            end
            -- if not, kill the fx
            if shotsPlaying == 0 then
                local team2Entities = objc.list_entities(2)
                for _, unit in pairs(team2Entities) do
                    if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'CallowayTargetEntity' then
                        objc.sacrifice_entity(unit)
                        objc.set_local_value(entity, EFFECT_IS_PLAYING, 0)
                        break
                    end
                end
            end
        end


    end
    local activateBoss = objc.get_global_value(ACTIVATE_BOSS)
    if activateBoss > 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_RocketTrooperCampaign' then
                objc.unidle_entity(unit)
                objc.set_flow_field_enabled_for_entity(unit, false)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
                break
            end
        end
    end

end

-- OnDamageTrigger
W1CampaignCalloway_spellResistant = function(damage, targetEntity, sourceEntity)
    local source = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_SOURCE_ENTITY)
    local sourceIdentifier = objc.get_entity_value_for_key(source, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER)
    if sourceIdentifier == 'W_Blast' or sourceIdentifier == 'W_Fog' then
        return objc.divide_with_ceiling(damage, 3)
    end
    return damage
end

W1CampaignCalloway_playAnimation = function(entity)
    local hasPlayed = objc.get_local_value(entity, HAS_PLAYED)
    local windUpTimer = objc.tick_timer(entity, 'windupTimerKey', 4)
    local attackTimer = objc.tick_timer(entity, 'attackTimerKey', 7)
    local totalTimer = objc.tick_timer(entity, 'totalTimerKey', 10)
    if hasPlayed == 0 then
        objc.reset_tick_timer(entity, 'windupTimerKey')
        objc.reset_tick_timer(entity, 'attackTimerKey')
        objc.reset_tick_timer(entity, 'totalTimerKey')
        objc.set_local_value(entity, HAS_PLAYED, 1)

    elseif hasPlayed == 1 and windUpTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _, unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_RocketTrooperCampaign' then
                objc.play_override_animation_key(unit, "attackWindUpAnimationName", objc.convert_frames_to_subrounds(15))
                objc.set_local_value(entity, HAS_PLAYED, 2)
                break
            end
        end

    elseif hasPlayed == 2 and attackTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _, unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_RocketTrooperCampaign' then
               objc.play_override_animation_key(unit, "attackAnimationName", objc.convert_frames_to_subrounds(20))
               objc.set_local_value(entity, HAS_PLAYED, 3)
               break
            end
        end
    elseif hasPlayed == 3 and totalTimer == 0 then
        objc.set_local_value(entity, HAS_PLAYED, 0)
        objc.remove_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'W1CampaignCalloway_playAnimation')
    end
end

base_invulnerable = function(entity)
    return 0
end