local GAME_HAS_INIT = 'gameHasInit'
local UNIT_HAS_SPAWMED = 'unitHasSpawned'
local HOLOGRAM_SHADER = 'skinned_toon_hologram'
local HAS_BARRICADE = 'BarricadeIsAlive'

local CHECK_TICK = 100
local CHECK_KEY = "checkKey"

local IDLE_TIME = 20000000

local LUA_ID = 'W1CampaignChuckie.lua'



W1CampaignChuckie_tickTrigger = function(entity)

    local HasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if HasInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.is_normal_unit(unit) then
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'W_ShieldedUnit4' then
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'W1CampaignChuckie_ImmobilizeTrigger')
                   -- objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'W1Region5Chuckie_killTrigger')
                    objc.set_entity_scale_percentage(unit, 150)
                    objc.set_entity_display_name(unit, 'Trigger')
                    objc.set_entity_unit_description(unit, 'A BEEFY VANGURAD TANK DIES WITH THE BARRICADE')
                elseif objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'W_Archer4' then
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'W1CampaignChuckie_ImmobilizeTrigger')
                    --objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'W1Region5Chuckie_killTrigger')
                    objc.set_entity_scale_percentage(unit, 180)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_RANGE, 4000)
                    objc.set_entity_display_name(unit, 'Trigger')
                    objc.set_entity_unit_description(unit, 'A LONG RANGED ARCHER DIES WITH THE BARRICADE')
                end
            end
        end
    end

end

W1CampaignChuckie_ImmobilizeTrigger = function(entity)
    local hasSpawned = objc.get_local_value(entity, UNIT_HAS_SPAWMED)
    if hasSpawned == 0 then
        objc.immobilize_entity(entity, IDLE_TIME)
        objc.set_local_value(entity, UNIT_HAS_SPAWMED, 1)
    end
end

--[[W1CampaignChuckie_killTrigger = function(entity)
    local team2Entities = objc.list_entities(2)
    for _,unit in pairs(team2Entities) do
        if objc.is_barricade(unit) then
            objc.kill_entity(unit)
        end
    end
end
]]
--[[
W1CampaignChuckie_killTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        objc.set_local_value(entity, HAS_BARRICADE, 0)
        for _,unit in pairs(team2Entities) do
            if objc.is_barricade(unit) then
                objc.set_local_value(entity, HAS_BARRICADE, 1)
            end
        end
    end
    if HasBarricade == 0 then
        objc.kill_entity(entity)
    end
end
]]
