local GAME_HAS_INIT = 'gameHasInit'
local UNIT_HAS_SPAWMED = 'unitHasSpawned'

local CHECK_TICK = 100
local CHECK_KEY = "checkKey"
local CHECK_RADIUS = 5000

local IDLE_TIME = 20000000
local LUA_ID = 'W1CampaignDeathReaver.lua'
local MOVESPEED_INCREASE = 70

local ORIGINAL_MOVESPEED_KEY = 'originalMoveSpeedKey'

local KILL_CHECK_TICK = 10
local KILL_CHECK_KEY = "killCheckKey"



W1CampaignDeathReaver_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if HasInit == 0 then
        local team2Entities = objc.list_entities(2)
        local waitTime = objc.get_elapsed_game_time_in_seconds()
        if waitTime > 0.5 then
            for _,unit in pairs(team2Entities) do
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'R_TroopCarrier' then
                    objc.idle_entity(unit, IDLE_TIME)
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'Unit_ActivateTrigger')
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'Unit_KillTrigger')
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, 300)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, 300)
                    objc.set_entity_scale_percentage(unit, 150)
                    objc.set_entity_display_name(unit, 'Death Reaver')
                    objc.set_entity_unit_description(unit, 'BOOM!')
                elseif objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'R_TroopCarrier1' then
                    objc.set_local_value(entity, ORIGINAL_MOVESPEED_KEY, objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY))
                    objc.idle_entity(unit, IDLE_TIME)
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'Unit_ActivateTrigger1')
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'Unit_KillTrigger')
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, 300)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, 300)
                    objc.set_entity_scale_percentage(unit, 150)
                    objc.set_entity_display_name(unit, 'Death Reaver')
                    objc.set_entity_unit_description(unit, 'BOOM!')
                end
            end
            objc.set_local_value(entity, GAME_HAS_INIT, 1)
        end
    end
end

Unit_ActivateTrigger = function(entity)
    if objc.is_entity_idle(entity) then
        local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
        if checkTimer == 0 then
            local enemyTeamNumber = objc.get_enemy_team_number(entity)
            local enemies = objc.list_entities_in_radius(entity, CHECK_RADIUS, enemyTeamNumber)
            for _, enemy in pairs(enemies) do
                if objc.is_normal_unit(enemy) then
                objc.unidle_entity(entity)
                end
            end
        end
    end
end

Unit_ActivateTrigger1 = function(entity)
    if objc.is_entity_idle(entity) then
        local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
        if checkTimer == 0 then
            local enemyTeamNumber = objc.get_enemy_team_number(entity)
            local enemies = objc.list_entities_in_radius(entity, CHECK_RADIUS, enemyTeamNumber)
            for _, enemy in pairs(enemies) do
                if objc.is_normal_unit(enemy) then
                objc.unidle_entity(entity)
                local originalMoveSpeed = objc.get_local_value(entity, ORIGINAL_MOVESPEED_KEY)
                objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, originalMoveSpeed + MOVESPEED_INCREASE)
                end
            end
        end
    end
end

Unit_KillTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, KILL_CHECK_KEY, KILL_CHECK_TICK)
    if checkTimer == 0 then
        if objc.get_entity_position(entity)[1] < -5000 then
            objc.sacrifice_entity(entity)
        end
    end
end
