local GAME_HAS_INIT = 'gameHasInit'
local SNEAKY_INIT = 'sneakyInit'

local LUA_FILE = 'W1CampaignFliers.lua'

W1CampaignFliers_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if HasInit == 0 then
        local base = objc.get_base_entity(2)
        objc.set_targetable(base, false)
        objc.add_trigger(base, TRIGGER_NAME_ON_DAMAGE_TRIGGER, LUA_FILE, 'base_invulnerable')
        objc.set_local_value(entity, GAME_HAS_INIT, 1)
    end

    local sneakyInit = objc.get_local_value(entity, SNEAKY_INIT)
    if sneakyInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'W_SneakyCampaign' then
                objc.set_entity_scale_percentage(unit, 170)
                objc.idle_entity_indefinitely(unit)
                objc.set_entity_facing_direction(unit, -1, 0)
                local newMaxHP = 3000
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)

                objc.add_trigger(unit, TRIGGER_NAME_ON_DAMAGE_TRIGGER, 'W1CampaignFliers.lua', 'W1CampaignFliers_spellResistant')

                objc.set_local_value(entity, SNEAKY_INIT, 1)
                break
            end
        end
    end
end

-- OnDamageTrigger
W1CampaignFliers_spellResistant = function(damage, targetEntity, sourceEntity)
    local source = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_SOURCE_ENTITY)
    local sourceIdentifier = objc.get_entity_value_for_key(source, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER)
    if sourceIdentifier == 'W_Blast' or sourceIdentifier == 'W_Fog' then
        return objc.divide_with_ceiling(damage, 3)
    end
    return damage
end

base_invulnerable = function(entity)
    return 0
end