local GAME_HAS_INIT = 'gameHasInit'

local ORIGINAL_VELOCITY_KEY = 'originalVelocityKey'
local ORIGINAL_VELOCITY_KEY1 = 'originalVelocityKey1'

local UNIT_LUA = 'W1CampaignKuroFight.lua'


W1CampaignKuroFight_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if HasInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.is_barricade(unit) then
                objc.kill_entity(unit)
            end
        end
        local waitTime = objc.get_elapsed_game_time_in_milliseconds()
        if waitTime > 500 then
            for _,unit in pairs(team2Entities) do
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'W_Sneaky' then
                    objc.set_local_value(unit, ORIGINAL_VELOCITY_KEY1, objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY))
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, UNIT_LUA, 'Unit_MobilizeTrigger')
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, 50)
                elseif objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'W_ShieldedUnit4' then
                    objc.set_local_value(unit, ORIGINAL_VELOCITY_KEY, objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY))
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
                    objc.set_entity_scale_percentage(unit, 60)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ARMOR, 8)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, 1700)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, 1700)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, -380)
                    objc.add_trigger(unit, TRIGGER_NAME_ON_DAMAGE_TRIGGER, UNIT_LUA, 'Unit_onDamageTrigger')
                end
            end
            objc.set_local_value(entity, GAME_HAS_INIT, 1)
        end
    end
end

Unit_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    objc.set_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_MAX_VELOCITY, objc.get_local_value(targetEntity, ORIGINAL_VELOCITY_KEY))
    local scalePercentage = objc.get_entity_scale_percentage(targetEntity)
        if scalePercentage < 180 then
            objc.set_entity_scale_percentage(targetEntity, scalePercentage + 10)
            objc.set_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_DAMAGE_BUFF, 20)
        end
    return damage
end

Unit_MobilizeTrigger = function(entity)
    if objc.is_targetable_enemy_in_radius(entity, 2500) then
        objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, objc.get_local_value(entity, ORIGINAL_VELOCITY_KEY1))
    end
end