local GAME_HAS_INIT = 'gameHasInit'
local DESTROY_BARRICADE_INIT = 'destroyBarricadeInit'

-- Make sure the game has a way to end if we reach fight it out
local FIGHT_IT_OUT_INIT = 'fightItOutInit'
local ORIGINAL_VELOCITY_MEDIVAC = 'originalVelocityMedivac'
local ORIGINAL_VELOCITY_TRANSPORTER = 'originalVelocityTransporter'
local GAME_TIME_UNTIL_DEATH = 180

W1CampaignR5Rage_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if HasInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'B_Medivac' then
                objc.set_local_value(entity, ORIGINAL_VELOCITY_MEDIVAC, objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY))
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
                --objc.set_entity_scale_percentage(unit, 150)
            elseif objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_TroopTransporter' then
                objc.set_entity_scale_percentage(unit, 120)
                objc.set_local_value(entity, ORIGINAL_VELOCITY_TRANSPORTER, objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY))
                local newMaxHP = 2 * objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
                --objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_RANGE, 2000)
            end
        end
        objc.set_local_value(entity, GAME_HAS_INIT, 1)
    end

    local destroyBarricadeInit = objc.get_local_value(entity, DESTROY_BARRICADE_INIT)
    if destroyBarricadeInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.is_barricade(unit) then
                objc.kill_entity(unit)
                objc.set_local_value(entity, DESTROY_BARRICADE_INIT, 1)
            end
        end
    end

    if objc.get_elapsed_game_time_in_seconds() > GAME_TIME_UNTIL_DEATH and objc.get_local_value(entity, FIGHT_IT_OUT_INIT) == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'B_Medivac' then
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, objc.get_local_value(entity, ORIGINAL_VELOCITY_MEDIVAC))
            elseif objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_TroopTransporter' then
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, objc.get_local_value(entity, ORIGINAL_VELOCITY_TRANSPORTER))
            end
        end
        objc.set_local_value(entity, FIGHT_IT_OUT_INIT, 1)
    end
end
