local HAS_INIT = 'shieldDroneInit'

local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'

local UNIT_LUA = 'W1CampaignShieldDrone.lua'

local ACTIVATE_LONGSHOT = 'activateLongShot'


W1CampaignShieldDrone_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, HAS_INIT)
    if HasInit == 0 then
        local base = objc.get_base_entity(2)
        objc.add_trigger(base, TRIGGER_NAME_ON_DAMAGE_TRIGGER, UNIT_LUA, 'base_invulnerable')
        objc.set_targetable(base, false)
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
        -- Assume the first Rifleman of the game is the opponent boss
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_Rifleman' then
                objc.idle_entity_indefinitely(unit)
                objc.set_entity_scale_percentage(unit, 180)
                local newMaxHP = 6000
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
                local damageBuff = 320
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, damageBuff)

                objc.add_trigger(unit, TRIGGER_NAME_ON_DAMAGE_TRIGGER, 'W1CampaignShieldDrone.lua', 'W1CampaignShieldDrone_spellResistant')

                objc.set_local_value(entity, HAS_INIT, 1)
                break
            end
        end
    elseif HasInit == 1 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_Rifleman' then
                objc.set_entity_facing_direction(unit, -1, 0)
                objc.set_local_value(entity, HAS_INIT, 2)
                break
            end
        end
    end

    local activateLongShot = objc.get_global_value(ACTIVATE_LONGSHOT)
    if activateLongShot > 0 then
        local longShot1 = objc.spawn_at_point('B_Longshot3', 1, 2, 3000, -1000, -1, 0)
        objc.set_entity_scale_percentage(longShot1[1], 130)
        local newMaxHP = 2 * objc.get_entity_value_for_key(longShot1[1], ENTITY_VALUE_KEY_MAX_HEALTH)
        objc.set_entity_value_for_key(longShot1[1], ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
        objc.set_entity_value_for_key(longShot1[1], ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
        local damageDebuff = objc.divide_with_ceiling(objc.get_entity_value_for_key(longShot1[1], ENTITY_VALUE_KEY_ATTACK_DAMAGE), 2)
        objc.set_entity_value_for_key(longShot1[1], ENTITY_VALUE_KEY_DAMAGE_BUFF, -1 * damageDebuff)
        local longShot2 = objc.spawn_at_point('B_Longshot3', 1, 2, 3000, 1000, -1, 0)
        objc.set_entity_scale_percentage(longShot2[1], 130)
        objc.set_entity_value_for_key(longShot2[1], ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
        objc.set_entity_value_for_key(longShot2[1], ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
        objc.set_entity_value_for_key(longShot2[1], ENTITY_VALUE_KEY_DAMAGE_BUFF, -1 * damageDebuff)


        objc.set_global_value(ACTIVATE_LONGSHOT, 0)
    end

    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'B_ShieldTrooper6' then
                if objc.get_local_value(unit, HAS_INIT) == 0 then
                    objc.set_entity_scale_percentage(unit, 230)
                    objc.set_entity_unit_description(unit, 'Pyle\'s strongest shield drone. Has a powerful shield.')
                    local newMaxHP = objc.divide_with_floor(4 * objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH), 2)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ARMOR, 20)
                    objc.add_trigger(unit, TRIGGER_NAME_ON_DAMAGE_TRIGGER, UNIT_LUA, 'LimitDamage_onDamageTrigger')
                    objc.set_local_value(unit, HAS_INIT, 1)
                end
            end
        end
    end
end

LimitDamage_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    if damage > 40 then
        damage = 40
    end
    return damage
end

W1CampaignShieldDrone_spellResistant = function(damage, targetEntity, sourceEntity)
    local source = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_SOURCE_ENTITY)
    local sourceIdentifier = objc.get_entity_value_for_key(source, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER)
    if sourceIdentifier == 'W_Blast' or sourceIdentifier == 'W_Fog' then
        return objc.divide_with_ceiling(damage, 3)
    end
    return damage
end

base_invulnerable = function(entity)
    return 0
end