local HAS_INIT = 'hasInit'

local ROLLOVER_ANIMATION_NAME = 'R_Pancake_Attack_01'
local ROLLOVER_ANIMATION_FRAMES = 45
local IS_ROLLOVER_PLAYING_KEY = 'isRolloverPlayingKey'

W1CampaignSteamroller_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, HAS_INIT)
    if HasInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'R_Steamroller' then
                objc.set_entity_scale_percentage(unit, 165)
                local newMaxHP = 1200
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)

                objc.set_local_value(entity, HAS_INIT, 1)
                break
            end
        end
    end

    local checkTimer = objc.tick_timer(entity, 'checkTimer', 5)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'R_Steamroller' then
                local enemyNumber = objc.get_enemy_team_number(unit)
                local enemies = objc.list_entities_in_radius(unit, 1200, enemyNumber)
                W1CampaignSteamroller_damageEntities(unit, enemies, 9999)
                break
            end
        end
    end
end

W1CampaignSteamroller_damageEntities = function(steamroller, entityList, damage)
    local myHealth = objc.get_entity_value_for_key(steamroller, ENTITY_VALUE_KEY_MAX_HEALTH)

    local damageTypes = {'building', 'base'}
    objc.set_entity_value_for_key(steamroller, ENTITY_VALUE_KEY_DAMAGE_TYPE, damageTypes)

    for _,target in pairs(entityList) do
        local thisHealth = objc.get_entity_value_for_key(target, ENTITY_VALUE_KEY_MAX_HEALTH)
        if objc.is_ground_unit(target) and objc.is_normal_unit(target) then
            if myHealth > thisHealth then
                local rolloverSubrounds = objc.convert_frames_to_subrounds(ROLLOVER_ANIMATION_FRAMES)
                objc.kill_entity(target)

                local isRolloverPlaying = objc.get_local_value(steamroller, IS_ROLLOVER_PLAYING_KEY)
                if isRolloverPlaying == 0 then
                    objc.play_passive_animation(steamroller, ROLLOVER_ANIMATION_NAME, 0, rolloverSubrounds)
                    objc.set_local_value(steamroller, IS_ROLLOVER_PLAYING_KEY, 1)
                end
            end
        end
    end
end