local GAME_HAS_INIT = 'gameHasInit'
local UNIT_HAS_SPAWMED = 'unitHasSpawned'

local CHECK_TICK = 100
local CHECK_KEY = "checkKey"
local CHECK_RADIUS = 7500

local IDLE_TIME = 20000000
local LUA_ID = 'W1CampaignTori.lua'
local ORIGINAL_VELOCITY_KEY = 'originalVelocityKey'



W1CampaignTori_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if HasInit == 0 then
        local team2Entities = objc.list_entities(2)
        local waitTime = objc.get_elapsed_game_time_in_milliseconds()
        if waitTime > 500 then
            for _,unit in pairs(team2Entities) do
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'W_Sneaky' then
                    objc.set_local_value(unit, ORIGINAL_VELOCITY_KEY, objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY))
                    objc.set_entity_scale_percentage(unit, 180)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
                    objc.set_entity_display_name(unit, 'Tori')
                    objc.set_entity_unit_description(unit, 'Tremble in the shadow of my fliers!')
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'Unit_MobilizeTrigger')
                elseif objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'W_Fighter2' then
                    objc.idle_entity(unit, IDLE_TIME)
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'Unit_ActivateTrigger')
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ARMOR, 30)
                    objc.set_entity_scale_percentage(unit, 150)
                    objc.set_entity_display_name(unit, 'Kestrel Trigger')
                end
            end
            objc.set_local_value(entity, GAME_HAS_INIT, 1)
        end
    end
end

Unit_ActivateTrigger = function(entity)
    if objc.is_entity_idle(entity) then
        local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
        if checkTimer == 0 then
            local enemies = objc.list_entities_in_radius(entity, CHECK_RADIUS, 1)
            for _, enemy in pairs(enemies) do
                if objc.is_normal_unit(enemy) then
                objc.unidle_entity(entity)
                end
            end
        end
    end
end

Unit_MobilizeTrigger = function(entity)
    if objc.is_targetable_enemy_in_radius(entity, 1000) then
        objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, objc.get_local_value(entity, ORIGINAL_VELOCITY_KEY))
    end
end