local HAS_INIT = 'hasInit'
local IDLE_INIT = 'idleInit'
local EXTEND_PLACEMENT = 'extendPlacement'
local ACTIVATE_WAVES = 'activateWaves'
local KURO_NO_WALK = 'kuroNoWalk'
local BARRICADE_NUMERATOR = 4
local BARRICADE_DENOMINATOR = 2
local SPEED_DECREASE = 18
local SPEED_INCREASE = 0
local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'
local SLOW_UNIT_INIT = 'slowUnitInit'
local HAS_GROUP_SPAWNED = 'hasGroupSpawned'
local VICTORY = 'victory'
-- copied from defaultBattleField.lua

local MINER_WAYPOINT = 'MinerWaypoint'
local MINER_PLACEMENT_BUFFER = -100
local MINE_POINT_X = 'minePointXKey'
local MINE_POINT_Y = 'minePointYKey'
local MINER_LIST = 'minerListKey'
local IS_PRE_PLACED = 'isPrePlacedKey'
local MINE_INDEX_KEY = 'mineIndexKey'

-- copied from spawnOneBarricade.lua
local BLUE_SPAWN_ANIMATION_NAME = 'Barricade_Ascension_Spawn'
local GREEN_SPAWN_ANIMATION_NAME = 'Barricade_Legion_Spawn'
local RED_SPAWN_ANIMATION_NAME = 'Barricade_Rogue_Spawn'
local TEAM_ONE_ANIMATION_NAME = '_BlueTeam'
local TEAM_TWO_ANIMATION_NAME = '_RedTeam'
local NUMBER_OF_FRAMES_IN_SPAWN_ANIMATION = 90

--THESE ARE LISTED SO THEY MADE IT INTO THE WHITELIST
local ascensionShipBarricade = 'Barricade_Ascension_Ship.lvl'
local rogueShipBarricade = 'Barricade_Rogue_Ship.lvl'
local legionShipBarricade = 'Barricade_Legion_Ship.lvl'



W1R2Z1_defense_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, HAS_INIT)
    if HasInit == 0 then
        local base = objc.get_base_entity(1)
        objc.set_targetable(base, false)
        objc.set_placement_transition_lerp_visibility(false)
        local prevRegion = objc.get_mercenary_placement_region(2, PLACEMENT_REGION_KEY_INITIAL)
        objc.set_mercenary_placement_region(2, PLACEMENT_REGION_KEY_INITIAL, 3000, prevRegion[PLACEMENT_REGION_Y], 14400, prevRegion[PLACEMENT_REGION_WIDTH])
        objc.set_placement_transition_lerp_visibility(true)
        spawnBarricade(-6500, 0, 1, 1, "ShipBarricadeOne")
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'W_Swordsman3' then
                local newMaxHP = objc.divide_with_ceiling(4 * objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH), 5)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
                objc.idle_entity_indefinitely(unit)
                objc.set_targetable(unit, false)
            end
        end
    objc.set_local_value(entity, HAS_INIT, 1)

    elseif HasInit == 1 then
        local player1Entities = objc.list_entities(1)
        for _, player1Entity in pairs(player1Entities) do
            if objc.is_barricade(player1Entity) or objc.is_base(player1Entity) then
                local barricadeHealth = objc.get_entity_value_for_key(player1Entity, ENTITY_VALUE_KEY_MAX_HEALTH)
                barricadeHealth = objc.divide_with_floor(barricadeHealth * BARRICADE_NUMERATOR, BARRICADE_DENOMINATOR)
                objc.set_entity_value_for_key(player1Entity, ENTITY_VALUE_KEY_MAX_HEALTH, barricadeHealth)
                objc.set_entity_value_for_key(player1Entity, ENTITY_VALUE_KEY_CURRENT_HEALTH, barricadeHealth)
            elseif objc.get_entity_value_for_key(player1Entity, ENTITY_VALUE_KEY_IDENTIFIER) == 'C_Ascension2Tutorial' then
                objc.play_override_animation(player1Entity, "W_Kuro_Battle_Combat_StoryTutorial_Spawn_01", objc.convert_frames_to_subrounds(100))
                local currentRange = objc.get_entity_value_for_key(player1Entity, ENTITY_VALUE_KEY_ATTACK_RANGE)
                local newRange = currentRange * 2
                local newMaxHP = 10000
                objc.set_entity_value_for_key(player1Entity, ENTITY_VALUE_KEY_ATTACK_RANGE, newRange)
                objc.set_entity_value_for_key(player1Entity, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                objc.set_entity_value_for_key(player1Entity, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
         
            end
        end
        objc.set_local_value(entity, HAS_INIT, 2)
    end

    local team1Entities = objc.list_entities(1)
    for _,unit in pairs(team1Entities) do
        if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'C_Ascension2Tutorial' then
            objc.immobilize_entity(unit, 10)
        end
    end

   

    local player2Entities = objc.list_entities(2)
    for _, unit in pairs(player2Entities) do
        if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'W_Spearbot1' or objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'W_IceAcolyte' then
            if objc.get_local_value(unit, HAS_GROUP_SPAWNED) == 0 then
                local posX = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_POSITION_X)
                local posY = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_POSITION_Y)
                local spawnedRifleman = objc.spawn_at_point('W_Spearbot1', 1, 2, posX + 100, posY + 100, -1, 0)
                objc.set_local_value(spawnedRifleman[1], HAS_GROUP_SPAWNED, 1)
                objc.set_local_value(unit, HAS_GROUP_SPAWNED, 1)
            end
        end
    end

    local victory = objc.get_global_value(VICTORY)
    if victory > 0 then
        local player1Entities = objc.list_entities(1)
        for _, unit in pairs(player1Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'C_Ascension2Tutorial' then
                objc.play_override_animation(unit, "W_Kuro_Wave_Timer_01", objc.convert_frames_to_subrounds(60))
                break
            end
        end
    end




    
end

-- copied from SpawnOneBarricade.lua

spawnBarricade = function(xPos, yPos, side, facing, tag)
    local faction = objc.get_commander_factions(side)
    local commanderID = objc.get_commander_id(side)
    local barrierID = objc.get_object_info("Commander",commanderID,"barricadeUnitIdentifier")
    local numberOfSubrounds = objc.convert_frames_to_subrounds(NUMBER_OF_FRAMES_IN_SPAWN_ANIMATION)
    local animation_name

    if faction[1] == FACTION_BLUE then
        animation_name = BLUE_SPAWN_ANIMATION_NAME
    elseif faction[1] == FACTION_GREEN then
        animation_name = GREEN_SPAWN_ANIMATION_NAME
    elseif faction[1] == FACTION_RED then
        animation_name = RED_SPAWN_ANIMATION_NAME
    else
        barrierID = "R_Barricade"
        animation_name = RED_SPAWN_ANIMATION_NAME
        scripting_error("No valid Barricade found for this Commander")
    end

    if side == 1 then
        animation_name = animation_name .. TEAM_ONE_ANIMATION_NAME
    elseif side == 2 then
        animation_name = animation_name .. TEAM_TWO_ANIMATION_NAME
    else
        animation_name = animation_name .. TEAM_ONE_ANIMATION_NAME
        scripting_error("No valid barrier animation found for this side")
    end

    local entities = objc.spawn_at_point(barrierID, 1, side, xPos, yPos, facing, 0)
    objc.set_local_value(entities[1], LUA_KEY_TAG, tag)
    objc.update_team_barricade_health(entities[1])
    objc.play_override_animation(entities[1], animation_name, objc.subrounds_to_milliseconds(numberOfSubrounds))
end


