local GAME_HAS_INIT = 'gameHasInit'
local DESTROY_BARRICADE_INIT = 'destroyBarricadeInit'
local UNIT_HAS_SPAWNED = 'unitHasSpawned'

local IDLE_TIME = 20000000

local LUA_ID = 'W2CampaignAsha.lua'


W2CampaignAsha_tickTrigger = function(entity)
    local W2Region6AshaHasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if W2Region6AshaHasInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'B_AnnieWalker2' or objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'B_ConfronterTank2' then
                objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'W2CampaignAsha_ImmobilizeTrigger')
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_RANGE, 2300)
                objc.set_local_value(entity, GAME_HAS_INIT, 1)
            end
        end
    elseif W2Region6AshaHasInit == 1 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'R_WrenchMech1' or objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'B_Medivac4' then
                objc.set_entity_scale_percentage(unit, 150)
                objc.set_local_value(entity, GAME_HAS_INIT, 2)
            end
        end
    end

    local destroyBarricadeInit = objc.get_local_value(entity, DESTROY_BARRICADE_INIT)
    if destroyBarricadeInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.is_barricade(unit) then
                objc.kill_entity(unit)
                objc.set_local_value(entity, DESTROY_BARRICADE_INIT, 1)
            end
        end
    end
end

W2CampaignAsha_ImmobilizeTrigger = function(entity)
    local hasSpawned = objc.get_local_value(entity, UNIT_HAS_SPAWNED)
    if hasSpawned == 0 then
        objc.immobilize_entity(entity, IDLE_TIME)
        objc.set_local_value(entity, UNIT_HAS_SPAWNED, 1)
    end
end

W2CampaignAsha_killBarricadeTrigger = function(entity)
    local hasSpawned = objc.get_local_value(entity, UNIT_HAS_SPAWNED)
    if hasSpawned == 0 then
        objc.kill_entity(entity)
    end
end