local GAME_HAS_INIT = 'gameHasInit'
local UNIT_HAS_SPAWMED = 'unitHasSpawned'

local CHECK_TICK = 3
local CHECK_RADIUS = 3500
local CHECK_KEY = "checkKey"
local IDLE_TIME = 20000000

local UNIT_LUA = 'W2CampaignFortressMech.lua'

W2CampaignFortressMech_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if HasInit == 0 then
        local team1Entities = objc.list_entities(1)
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'B_FortressMech4' then
                objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, UNIT_LUA, 'W2CampaignFortressMech_IdleTrigger')
                objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, UNIT_LUA, 'W2CampaignFortressMech_ActivateTrigger')
                objc.set_entity_scale_percentage(unit, 160)
                objc.set_entity_display_name(unit, 'SUPER BARRICADE')
                objc.set_entity_unit_description(unit, 'A SUPER BARRICADE THAT CAN TRANSFORM TO A MECH')
            elseif objc.is_barricade(unit) then
                objc.kill_entity(unit)
            end
        end
        objc.set_local_value(entity, GAME_HAS_INIT, 1)
    end
end

W2CampaignFortressMech_IdleTrigger = function(entity)
    local hasSpawned = objc.get_local_value(entity, UNIT_HAS_SPAWMED)
    if hasSpawned == 0 then
        objc.immobilize_entity(entity, IDLE_TIME)
        objc.set_local_value(entity, UNIT_HAS_SPAWMED, 1)
    end
end

W2CampaignFortressMech_ActivateTrigger = function(entity)
    if objc.is_entity_idle(entity) then
        local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
        if checkTimer == 0 then
            local enemyTeamNumber = objc.get_enemy_team_number(entity)
            local enemies = objc.list_entities_in_radius(entity, CHECK_RADIUS, enemyTeamNumber)
            for _, enemy in pairs(enemies) do
                if objc.is_normal_unit(enemy) then
                objc.unidle_entity(entity)
                end
            end
        end
    end
end

