local HAS_INIT = 'hasInit'
local MECH_INIT = 'mechInit'

local CHECK_TICK = 5
local CHECK_KEY = 'checkKey'

local COUNT_MECHS_KEY = 'countMechsKey'

W3CampaignMechPilotBoss_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, HAS_INIT)
    if HasInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_PilotMech' then
                objc.set_local_value(entity, COUNT_MECHS_KEY, 1)
                objc.set_local_value(unit, MECH_INIT, 1)
                objc.set_local_value(entity, HAS_INIT, 1)
            end
        end
    end

    local mechCount = objc.get_local_value(entity, COUNT_MECHS_KEY)
    if mechCount >= 1 then
        local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
        if checkTimer == 0 then
            local team2Entities = objc.list_entities(2)
            for _,unit in pairs(team2Entities) do
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_PilotMech' then
                    if objc.get_local_value(unit, MECH_INIT) == 0 then
                        local newSize = 100 + 20 * mechCount
                        objc.set_entity_scale_percentage(unit, newSize)
                        local hpIncrease = mechCount * objc.divide_with_ceiling(objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH), 4)
                        local newMaxHP = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH) + hpIncrease
                        objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                        objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)

                        objc.set_local_value(entity, COUNT_MECHS_KEY, mechCount + 1)
                        objc.set_local_value(unit, MECH_INIT, 1)
                    end
                end
        end
        end
    end
end