local GAME_HAS_INIT = 'gameHasInit'
local UNIT_HAS_SPAWMED = 'unitHasSpawned'

local CHECK_TICK = 100
local CHECK_KEY = "checkKey"
local CHECK_RADIUS = 4000

local IDLE_TIME = 20000000
local LUA_ID = 'W3CampaignPunching.lua'



W3CampaignPunching_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if HasInit == 0 then
        local team2Entities = objc.list_entities(2)
        local waitTime = objc.get_elapsed_game_time_in_milliseconds()
        if waitTime > 500 then
            for _,unit in pairs(team2Entities) do
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'R_Punching9' then
                    objc.idle_entity(unit, IDLE_TIME)
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'Unit_ActivateTrigger')
                    objc.set_entity_scale_percentage(unit, 180)
                end
            end
            objc.set_local_value(entity, GAME_HAS_INIT, 1)
        end
    end
end

Unit_ActivateTrigger = function(entity)
    if objc.is_entity_idle(entity) then
        local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
        if checkTimer == 0 then
            local enemyTeamNumber = objc.get_enemy_team_number(entity)
            local enemies = objc.list_entities_in_radius(entity, CHECK_RADIUS, enemyTeamNumber)
            for _, enemy in pairs(enemies) do
                if objc.is_normal_unit(enemy) then
                objc.unidle_entity(entity)
                end
            end
        end
    end
end