local GAME_HAS_INIT = 'gameHasInit'

local ORIGINAL_VELOCITY_KEY = 'originalVelocityKey'

local IDLE_TIME = 20000000
local LUA_ID = 'W3CampaignSpecialMission4.lua'



W3CampaignSpecialMission4_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if HasInit == 0 then
        local team2Entities = objc.list_entities(2)
        local waitTime = objc.get_elapsed_game_time_in_milliseconds()
        if waitTime > 500 then
            for _,unit in pairs(team2Entities) do
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'B_K91' then
                    objc.set_entity_scale_percentage(unit, 180)
                    objc.set_local_value(unit, ORIGINAL_VELOCITY_KEY, objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY))
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ARMOR, 8)
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, LUA_ID, 'Unit_ActivateTrigger2')
                    objc.set_local_value(entity, GAME_HAS_INIT, 1)
                end
            end
        end
    end
end

Unit_ActivateTrigger2 = function(entity)
    if objc.is_targetable_enemy_in_radius(entity, 3000) then
        objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, objc.get_local_value(entity, ORIGINAL_VELOCITY_KEY))
    end
end