local GAME_HAS_INIT = 'gameHasInit'

local IDLE_TIME = 20000000
local LUA_ID = 'W3CampaignSpecialMission5.lua'



W3CampaignSpecialMission5_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if HasInit == 0 then
        local team2Entities = objc.list_entities(2)
        local waitTime = objc.get_elapsed_game_time_in_milliseconds()
        if waitTime > 500 then
            for _,unit in pairs(team2Entities) do
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'B_DroneSwarm7' then
                    for _,object in pairs(team2Entities) do
                        if objc.is_barricade(object) then
                            objc.kill_entity(object)
                        end
                    end
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
                    objc.set_entity_scale_percentage(unit, 320)
                    local newMaxHP = 10 * objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)
                    objc.add_trigger(unit, TRIGGER_NAME_ON_DAMAGE_TRIGGER, LUA_ID, 'Unit_onDamageTrigger')
                    objc.set_local_value(entity, GAME_HAS_INIT, 1)
                end
            end
        end
    end
end

Unit_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    objc.spawn_at_entity('B_DroneSwarm7', 2, targetEntity)
    return damage
end