local HAS_INIT = 'hasInit'
local DESTROY_BARRICADE_INIT = 'destroyBarricadeInit'

local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'
local TENTACLE_INIT_KEY = 'tentacleInitKey'
local TENTACLE_INIT_KEY_2 = 'tentacleInitKey2'
local KOZUCHI_INIT_KEY = 'kozuchiInitKey'
local IS_TARGETABLE_KEY = 'isTargetableKey'
local TENTACLE_TIMER_KEY = 'tentacleTimerKey'

local UNIT_HAS_SPAWNED = 'unitHasSpawned'
local IDLE_TIMER_KEY = "idleTimerKey"
local HAS_ADDED_TRIGGER = 'hasAddedTrigger'

local UNIT_LUA = 'W4CampaignBossPrototype.lua'

local GROW_TIMER_KEY = "growTimerKey"
local GROW_TICK = 1
local SIZE_KEY = "sizeKey"
local GROW_AMOUNT = 3

local DEATH_TIMER_KEY = "deathTimerKey"
local DEATH_TIME = 50

W4CampaignBossPrototype_tickTrigger = function(entity)
    local HasInit = objc.get_local_value(entity, HAS_INIT)
    if HasInit == 0 then
        objc.set_local_value(entity, HAS_INIT, 1)

        local oldTacticRegionTeamOne = objc.get_tactic_placement_region(1, PLACEMENT_REGION_KEY_INITIAL)
        local oldTacticRegionTeamTwo = objc.get_tactic_placement_region(2, PLACEMENT_REGION_KEY_INITIAL)
        local battlefieldLength = objc.get_map_size()[2]
        local halfBattlefieldLength = objc.divide_with_floor(battlefieldLength, 2)
        objc.set_tactic_placement_region(1, PLACEMENT_REGION_KEY_INITIAL, -halfBattlefieldLength, oldTacticRegionTeamOne[PLACEMENT_REGION_Y], battlefieldLength, oldTacticRegionTeamOne[PLACEMENT_REGION_WIDTH])
        objc.set_tactic_placement_region(2, PLACEMENT_REGION_KEY_INITIAL, -halfBattlefieldLength, oldTacticRegionTeamTwo[PLACEMENT_REGION_Y], battlefieldLength, oldTacticRegionTeamTwo[PLACEMENT_REGION_WIDTH])
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'N_KrakenUnit' then
                objc.set_entity_scale_percentage(unit, 50)
                objc.set_entity_display_name(unit, 'Xenogog')
                objc.set_entity_unit_description(unit, 'It\'s time for a galaxy update!')
                objc.set_local_value(entity, HAS_INIT, 1)
            end
        end
    end

    --[[
    local barricadeInit = objc.get_local_value(entity, DESTROY_BARRICADE_INIT)
    if barricadeInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.is_barricade(unit) then
                objc.kill_entity(unit)
                objc.remove_trigger(unit, TRIGGER_NAME_DEATH_TRIGGER, 'R_Barricade_deathTrigger')
                objc.set_local_value(entity, DESTROY_BARRICADE_INIT, 1)
            end
        end
    end
    ]]

    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'R_SniperRoadster6' then
                if objc.get_local_value(unit, TENTACLE_INIT_KEY) == 0 then
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, UNIT_LUA, 'Alicia_IdleTrigger')
                    objc.set_entity_scale_percentage(unit, 180)
                    objc.set_entity_display_name(unit, 'Kraken')
                    objc.set_entity_unit_description(unit, 'No I swear this is a Kraken')
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH) * 20)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH))
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_DAMAGE))
                    objc.move_entity_to_location_with_velocity(unit, 5000, 0, 40, 70)

                    -- Mind control nearby units when R_SR6 spawns
                    objc.spawn_at_point('krakenMindControlAttackEntity', 1, 2, 3000, -1200, -1, 0)
                    objc.spawn_at_point('krakenMindControlAttackEntity', 1, 2, 3000, 1200, -1, 0)
                    objc.set_local_value(unit, TENTACLE_INIT_KEY, 1)
                end
            end

            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'N_KrakenTentacle' then
                if objc.get_local_value(unit, TENTACLE_INIT_KEY) == 0 then
                    objc.set_entity_scale_percentage(unit, 80)
                    objc.set_entity_display_name(unit, 'Tentacle')
                    objc.set_entity_unit_description(unit, 'Pls suspendo disbeliefo')
                    objc.add_trigger(unit, TRIGGER_NAME_DEATH_TRIGGER, UNIT_LUA, 'MindControlTentacleAttack')
                    objc.immobilize_entity(unit, 999999)
                    objc.set_local_value(unit, TENTACLE_INIT_KEY, 1)
                end
            end

            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'N_KrakenTentacle1' then
                if objc.get_local_value(unit, TENTACLE_INIT_KEY_2) == 0 then
                    objc.add_trigger(unit, TRIGGER_NAME_DEATH_TRIGGER, UNIT_LUA, 'RoxieTentacle_deathTrigger')
                    objc.set_local_value(unit, TENTACLE_INIT_KEY_2, 1)
                end
            end

            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'N_KrakenTentacle2' then
                if objc.get_local_value(unit, TENTACLE_INIT_KEY_2) == 0 then
                    objc.add_trigger(unit, TRIGGER_NAME_DEATH_TRIGGER, UNIT_LUA, 'NashTentacle_deathTrigger')
                    objc.set_local_value(unit, TENTACLE_INIT_KEY_2, 1)
                end
            end

            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'C_KnockbackSumo' then
                if objc.get_local_value(unit, KOZUCHI_INIT_KEY) == 0 then
                    local team1Entities = objc.list_entities(1)
                    for _,unit in pairs(team1Entities) do
                        if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'C_Duchess' or objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'C_Ai' then
                            objc.immobilize_entity(unit, 1)
                        end
                    end
                    objc.set_local_value(unit, KOZUCHI_INIT_KEY, 1)
                end
            end

            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'R_SpiderBomb' then
                if objc.get_local_value(unit, TENTACLE_INIT_KEY) == 0 then
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, UNIT_LUA, 'BanezingMeteor_growTrigger')
                    objc.add_trigger(unit, TRIGGER_NAME_ON_DAMAGE_TRIGGER, UNIT_LUA, 'BanezingMeteor_invincibleTrigger')
                    objc.remove_trigger(unit, TRIGGER_NAME_ON_ATTACK_TRIGGER, 'R_SpiderBomb_onAttackTrigger')
                    objc.set_targetable(unit, false)
                    objc.set_local_value(unit, SIZE_KEY, 50)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
                    objc.set_local_value(unit, TENTACLE_INIT_KEY, 1)
                end
            end

            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'C_Ai' or objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'C_Duchess' then
                objc.stun_entity(unit, 999999)
                objc.set_local_value(entity, HAS_INIT, 1)
            end
        end
    end
end

RoxieTentacle_deathTrigger = function(entity)
    local roxie = objc.spawn_at_point('C_Duchess', 1, 1, 500, 1000, 1, 0)
    objc.spawn_at_point('R_Pyro', 1, 1, 500, 2000, 1, 0)
    --objc.immobilize_entity(roxie[1], 999999)
    local team2Entities = objc.list_entities(2)
    for _,unit in pairs(team2Entities) do
        if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'C_Duchess' then
            objc.sacrifice_entity(unit)
        end
    end
end

NashTentacle_deathTrigger = function(entity)
    local nash = objc.spawn_at_point('C_Ai', 1, 1, 3000, -1500, 1, 0)
    --objc.immobilize_entity(nash[1], 999999)
    local team2Entities = objc.list_entities(2)
    for _,unit in pairs(team2Entities) do
        if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'C_Ai' then
            objc.sacrifice_entity(unit)
        end
    end
end

local MIND_CONTROL_TIMER = 'mindControlTimer'
local MIND_CONTROL_DELAY = 100

MindControlTentacleAttack = function(entity)
    --local pos = objc.get_entity_position(entity)
    --objc.spawn_at_point('KrakenMindControl', 1, 2, pos[1] - 1500, pos[2], -1, 0)
    local oldMercenaryRegion = objc.get_mercenary_placement_region(1, PLACEMENT_REGION_KEY_INITIAL)
    local oldMercenaryPlacementLength = oldMercenaryRegion[PLACEMENT_REGION_X]
    objc.set_mercenary_placement_region(1, PLACEMENT_REGION_KEY_INITIAL, oldMercenaryPlacementLength, oldMercenaryRegion[PLACEMENT_REGION_Y], oldMercenaryRegion[PLACEMENT_REGION_LENGTH] + 1500, oldMercenaryRegion[PLACEMENT_REGION_WIDTH])
end

BanezingMeteor_growTrigger = function(entity)
    local growTimer = objc.tick_timer(entity, GROW_TIMER_KEY, GROW_TICK)
    if growTimer == 0 then
        local newSize = objc.get_local_value(entity, SIZE_KEY) + GROW_AMOUNT
        objc.set_entity_scale_percentage(entity, newSize)
        objc.set_local_value(entity, SIZE_KEY, newSize)
    end

    local deathTimer = objc.tick_timer(entity, DEATH_TIMER_KEY, DEATH_TIME)
    if deathTimer == 0 then
        objc.sacrifice_entity(entity)
    end
end

BanezingMeteor_invincibleTrigger = function(damage, targetEntity, sourceEntity)
    return 0
end

MeteorExplosion_explodeTrigger = function(entity)
    local timer = objc.tick_timer(entity, 'timer', 5)

    if timer == 0 then
        for _, enemy in pairs(objc.list_entities_in_radius(entity, 1100, 1)) do
            if objc.is_ground_unit(enemy) then
                objc.inflict_normal_damage(entity, enemy, 700)
                objc.flash_entity_for_damage(enemy, 250)
            end
        end
        for _, enemy in pairs(objc.list_entities_in_radius(entity, 1100, 2)) do
            if objc.is_ground_unit(enemy) then
                objc.inflict_normal_damage(entity, enemy, 700)
                objc.flash_entity_for_damage(enemy, 250)
            end
        end
        objc.sacrifice_entity(entity)
    end
end
