local HAS_INIT = 'hasInit'
local OUTER_RADIUS = 1000
local INNER_RADIUS = 300
local BLAST_EFFECT = 'blastEffectEntity'
local INNER_IMPACT_EFFECT_ENTITY = 'doubleDamageEffectEntity'

W_BlastCampaign_spawnTrigger = function(entity)
    objc.idle_entity(entity, 1000)
end

W_BlastCampaign_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        local teamNumber = objc.get_team_number(entity)
        local enemyNumber = objc.get_enemy_team_number(entity)
        local enemiesInInnerRadius = objc.list_entities_in_radius(entity, INNER_RADIUS, enemyNumber)
        for _, enemy in pairs(enemiesInInnerRadius) do
            if (objc.is_building_unit(enemy) or objc.is_normal_unit(enemy) or objc.is_commander(enemy) or objc.is_base(enemy) or objc.is_barricade(enemy) or (objc.is_boss_unit(enemy) == 1)) and (objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_IS_BEING_PROTECTED) == 0) then
                local attackDamage = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_DAMAGE) * 2
                objc.inflict_normal_damage(entity, enemy, attackDamage)
                objc.flash_entity_for_damage(enemy, 250)
                objc.spawn_at_entity(INNER_IMPACT_EFFECT_ENTITY, 1, enemy)
            end
        end

        local enemiesInOuterRadius = objc.list_entities_in_radius(entity, OUTER_RADIUS, enemyNumber)
        for _, enemy in pairs(enemiesInOuterRadius) do
            if W_Blast_tableContains(enemiesInInnerRadius, enemy) == false then
                if (objc.is_building_unit(enemy) or objc.is_normal_unit(enemy) or objc.is_commander(enemy) or objc.is_base(enemy) or objc.is_barricade(enemy) or (objc.is_boss_unit(enemy) == 1)) and (objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_IS_BEING_PROTECTED) == 0) then
                    local attackDamage = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_DAMAGE)
                    objc.inflict_normal_damage(entity, enemy, attackDamage)
                    objc.flash_entity_for_damage(enemy, 250)
                end
            end
        end

        local entityPos = objc.get_entity_position(entity)
        local playerNumber = objc.get_player_number(entity)
        objc.spawn_at_point_with_source_entity(BLAST_EFFECT, 1, playerNumber, entityPos[1], entityPos[2], 0, 0, entity)
        objc.set_local_value(entity, HAS_INIT, 1)
    end

    objc.sacrifice_entity(entity)
end

W_BlastCampaign_tableContains = function(table, element)
  for _, value in pairs(table) do
    if value == element then
      return true
    end
  end
  return false
end

