local CLONE_RADIUS = 800
local HOLOGRAM_SHADER_NAME = 'skinned_toon_hologram'

W_Clone_spawnTrigger = function(entity)
    local teamNumber = objc.get_team_number(entity)
    local playerNumber = objc.get_player_number(entity)
    local alliesInRadius = objc.list_entities_in_radius(entity, CLONE_RADIUS, teamNumber)
    for _, ally in pairs(alliesInRadius) do
        if objc.is_normal_unit(ally) then
          local identifier = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_IDENTIFIER)
          local spawned = objc.spawn_at_entity(identifier, 1, ally)
          objc.set_entity_value_for_key(spawned[1], ENTITY_VALUE_KEY_CURRENT_HEALTH, 1)
          objc.set_entity_value_for_key(spawned[1], ENTITY_VALUE_KEY_MAX_HEALTH, 1)
          objc.add_trigger(spawned[1], TRIGGER_NAME_TICK_TRIGGER, 'W_Clone.lua', 'W_Clone_addShaderTrigger')
        end
    end
    
    objc.set_solid(entity, false)
    objc.idle_entity(entity, 10000)
    objc.sacrifice_entity(entity)
end

W_Clone_addShaderTrigger = function(entity)
  objc.apply_shader(entity, HOLOGRAM_SHADER_NAME)
  objc.remove_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'W_Clone_addShaderTrigger')
end

