local NEGATOR_SHIELD_TRIGGER = 'W_DivineProtector_protectTrigger'
local SHIELD_VFX_NAME = 'idle_W_EternalWarrior_Shield_Melee.lvl'

W_DivineProtector_spawnTrigger = function(entity)
	local teamNumber = objc.get_team_number(entity)
	local allies = objc.list_entities(teamNumber)
	for _, ally in pairs(allies) do
		if objc.is_normal_unit(ally) then
			objc.play_vfx(ally, SHIELD_VFX_NAME, NODE_IMPACT)
			objc.add_trigger(ally, TRIGGER_NAME_ON_DAMAGE_TRIGGER, 'W_DivineProtector.lua', NEGATOR_SHIELD_TRIGGER)
		end
	end
end

W_DivineProtector_protectTrigger = function(damage, targetEntity, sourceEntity)
	objc.stop_vfx(targetEntity, SHIELD_VFX_NAME, NODE_IMPACT, false)
	objc.remove_trigger(targetEntity, TRIGGER_NAME_ON_DAMAGE_TRIGGER, NEGATOR_SHIELD_TRIGGER)
	return 0
end
