local SHIELD_NODE = 'VFX_Shield'
local NORMAL_SHIELD = 'idle_W_EternalWarrior_Shield_Melee.lvl'
local WAIT_TIMER_KEY = 'waitTimerKey'
local WAIT_TIME = 1
local SHIELD_VFX = 'imp_W_ShieldedShield.lvl'
local HAS_INIT = 'hasInitKey'

W_EternalWarrior_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        --It's unclear why I have to wait 2 rounds for this to work now, but trying to do it
        --the first round throws an error trying to attach VFX to an entity of class <null>
        local waitTime = objc.tick_timer(entity, WAIT_TIMER_KEY, WAIT_TIME)
        if waitTime == 0 then
            objc.play_vfx(entity, NORMAL_SHIELD, SHIELD_NODE)
            objc.set_local_value(entity, HAS_INIT, 1)
        end
    end
end

W_EternalWarrior_onDamageTrigger = function(damage, targetEntity, sourceEntity)
    local armorAmount = objc.get_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_ARMOR)
    local flashCutoff = objc.divide_with_floor(armorAmount * 10, 4)
    local originalDamage = damage + armorAmount
    if originalDamage <= flashCutoff then
        objc.play_vfx(targetEntity, SHIELD_VFX, NODE_IMPACT)
    end
    return damage
end