local CURRENT_TARGET_KEY = 'currentTargetKey'
local NUM_SHOTS_KEY = 'numShotsKey'
--The maximum number of stacks of bonus damage I can have. Maximum damage starts on the (MAX_DAMAGE_INCREMENTS + 1)-th shot.
local MAX_DAMAGE_INCREMENTS = 2
local BUFF_AMOUNT = 'buffAmountKey'

W_Fighter_spawnTrigger = function(entity)
    local buffToGive = objc.get_combat_entity_custom_stat(entity, CUSTOM_ENTITY_STAT_KEY_SHOT_DAMAGE_BONUS)
	objc.set_local_value(entity, BUFF_AMOUNT, buffToGive)
end

W_Fighter_onTargetTrigger = function(entity, entityToTarget)
	objc.set_local_value(entity, CURRENT_TARGET_KEY, entityToTarget)
	local id = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_DESCRIPTION)
	objc.set_local_value(entityToTarget, NUM_SHOTS_KEY .. id, 0)
end

W_Fighter_damageTrigger = function(damage, targetEntity, sourceEntity)
	local fighter = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_SOURCE_ENTITY)
    local id = objc.get_entity_value_for_key(fighter, ENTITY_VALUE_KEY_DESCRIPTION)
    local fighterTarget = objc.get_local_value(fighter, CURRENT_TARGET_KEY)
	local numShots = objc.get_local_value(fighterTarget, NUM_SHOTS_KEY .. id)
	if numShots > MAX_DAMAGE_INCREMENTS + 1 then
		numShots = MAX_DAMAGE_INCREMENTS + 1
	end
	local tierOfFighter = objc.get_entity_value_for_key(fighter, ENTITY_VALUE_KEY_TIER)
    local buffToGive = objc.get_local_value(fighter, BUFF_AMOUNT)
	local toDamage = damage + ((numShots - 1) * buffToGive)
	return toDamage
end