local VFX_1_NAME = 'proj_W_Fighter_01.lvl'
local VFX_2_NAME = 'proj_W_Fighter_02.lvl'
local VFX_3_NAME = 'proj_W_Fighter_03.lvl'
local NUM_SHOTS_KEY = 'numShotsKey'
local CURRENT_TARGET_KEY = 'currentTargetKey'
local MAX_SHOTS = 2
local HAS_INIT = 'hasInit'

W_Fighter_air_bullet_spawnTrigger = function(entity)
    local fighter = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_SOURCE_ENTITY)
    local id = objc.get_entity_value_for_key(fighter, ENTITY_VALUE_KEY_DESCRIPTION)
    local fighterTarget = objc.get_local_value(fighter, CURRENT_TARGET_KEY)
    local numShots = objc.get_local_value(fighterTarget, NUM_SHOTS_KEY .. id)

    objc.set_local_value(fighterTarget, NUM_SHOTS_KEY .. id, numShots + 1)
    
    if numShots > MAX_SHOTS then
        numShots = MAX_SHOTS
    end

    if numShots == 0 then
        objc.update_asset_name(entity, VFX_1_NAME)
    elseif numShots == 1 then
        objc.update_asset_name(entity, VFX_2_NAME)
    else
        objc.update_asset_name(entity, VFX_3_NAME)
    end

end