
local FOG_EFFECT_ENTITY = 'fogEffectEntity'

local CRASH_ANIM_NAME = 'W_Damage_Fog_Death_01'
local FRAMES_IN_CRASH_ANIM = 30

local COMBAT_IDLE_ANIM_NAME = 'combatIdleAnimation'
local FOG_DAMAGE_AMOUNT = 'fogDamageKey'

W_Fog_spawnTrigger = function(entity)
    local fog_radius = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_SPELL_RADIUS)
    local typeToSet = {'none'}
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_DAMAGE_TYPE, typeToSet)
    local numberOfSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_CRASH_ANIM)
    objc.play_override_animation(entity, CRASH_ANIM_NAME, objc.subrounds_to_milliseconds(numberOfSubrounds))

    local updatedAnimations = {}
    updatedAnimations[ANIMATION_STATE_IDLE] = COMBAT_IDLE_ANIM_NAME
    objc.update_animation_state(entity, updatedAnimations)

    local entityPos = objc.get_entity_position(entity)
    local playerNumber = objc.get_player_number(entity)
    local fogEntity = objc.spawn_at_point_with_source_entity(FOG_EFFECT_ENTITY, 1, playerNumber, entityPos[1], entityPos[2], 0, 0, entity)
    local attackDamage = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_DAMAGE)
    objc.set_local_value(fogEntity[1], FOG_DAMAGE_AMOUNT, attackDamage)
    objc.set_targetable(entity, false)
    objc.set_solid(entity, false)
end
