local CRASH_ANIM_NAME = 'W_AscensionFreeze__Death_01'
local FRAMES_IN_CRASH_ANIM = 10

local FREEZE_SHADER_NAME = 'skinned_toon_freeze2'
local DISSOLVE_SHADER_COLOR_DEFAULT = {red = 0, green = 200, blue = 255, alpha = 127}
local UNIFORM_NAME_DISSOLVE_COLOR = 'DissolveColor'
local SHADER_COUNT_DOWN_TIME = 'shaderCountDownTimeKey'
local SHADER_TIMER_COUNT = 'shaderTimerCountKey'
local FREEZE_DESCRIPTION = 'freezeDescriptionKey'

local freeze_duration = 0

local SPAWN_INVIS_ANIMATION_STATE = 'spawnStart'


W_Freeze_spawnTrigger = function(entity)
    freeze_duration = objc.get_combat_entity_custom_stat(entity, CUSTOM_ENTITY_STAT_KEY_DURATION)
    local freeze_radius = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_SPELL_RADIUS)
    local teamNumber = objc.get_team_number(entity)
    local enemyNumber = objc.get_enemy_team_number(entity)
    local enemiesInRadius = objc.list_entities_in_radius(entity, freeze_radius, enemyNumber)
    local tier = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_TIER)
    local description = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_DESCRIPTION)
    for _, enemy in pairs(enemiesInRadius) do
        if (objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_IS_BEING_PROTECTED) == 0) and (objc.is_normal_unit(enemy) or objc.is_commander(enemy)) then
            objc.play_vfx(enemy, 'imp_W_freezeSpell.lvl', NODE_IMPACT)
            
            local tickTrigger = objc.lua_functions_for_trigger(enemy, TRIGGER_NAME_TICK_TRIGGER)
            local hasCountdownTrigger = false
            for _,trigger in pairs(tickTrigger) do
                if trigger == 'W_Freeze_countDownShaderTrigger' then
                    hasCountdownTrigger = true
                    break
                end
            end

            if hasCountdownTrigger == false then
                objc.apply_shader(enemy, FREEZE_SHADER_NAME)
                objc.update_shader_uniform_color(enemy, UNIFORM_NAME_DISSOLVE_COLOR, DISSOLVE_SHADER_COLOR_DEFAULT)
                objc.add_trigger(enemy, TRIGGER_NAME_TICK_TRIGGER, 'W_Freeze.lua', 'W_Freeze_countDownShaderTrigger')
            end

            objc.set_local_value(enemy, SHADER_COUNT_DOWN_TIME, objc.divide_with_floor(freeze_duration, 100))
            objc.immobilize_entity(enemy, freeze_duration)
            objc.stun_entity(enemy, freeze_duration)
        end
    end

    objc.set_solid(entity, false)
    objc.idle_entity(entity, 10000)
end

W_Freeze_countDownShaderTrigger = function(entity)
    local shaderCountDown = objc.get_local_value(entity, SHADER_COUNT_DOWN_TIME)
    shaderCountDown = shaderCountDown - 1
    objc.set_local_value(entity, SHADER_COUNT_DOWN_TIME, shaderCountDown)
    if shaderCountDown <= 0 then
        objc.remove_shader(entity, FREEZE_SHADER_NAME)
        objc.remove_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'W_Freeze_countDownShaderTrigger')
    end
end
