local BUFF_AMOUNT = 10
local BUFF_SIZE = 800
local HAS_INIT = 'hasInitKey'
local STARTING_ATTACK = 'startingAttack'
local PULSE_INTERVAL = 10
local PULSE_TIMER = 'pulseTimer'

W_HiveDrone_spawnTrigger = function(entity)
    local originalAttackRate = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_RATE)
    objc.set_local_value(entity, STARTING_ATTACK, originalAttackRate)
    objc.set_local_value(entity, PULSE_TIMER, 0)
end

W_HiveDrone_tickTrigger = function(entity)
    local teamNumber = objc.get_team_number(entity)
    local nearbyAllies = objc.list_entities_in_radius(entity, BUFF_SIZE, teamNumber)
    local nearbyHiveDrones = 0

    for _,ally in pairs(nearbyAllies) do
        if objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_IDENTIFIER) == 'W_HiveDrone' then
            nearbyHiveDrones = nearbyHiveDrones + 1
        end

    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_RATE, nearbyHiveDrones * BUFF_AMOUNT + objc.get_local_value(entity, STARTING_ATTACK))

        if nearbyHiveDrones > 0 then
            objc.play_vfx(entity, 'Status_damagePlus.lvl', NODE_STATUS)
        end
    end

    if objc.get_local_value(entity, PULSE_TIMER) == 30 and nearbyHiveDrones > 0 then
        objc.play_vfx(entity, 'B_BattleBard_Pulse.lvl', NODE_ORIGIN)
        objc.set_local_value(entity, PULSE_TIMER, 0)
    else
        previousTimer = objc.get_local_value(entity, PULSE_TIMER)
        objc.set_local_value(entity, PULSE_TIMER, previousTimer + 1)
    end
end
