local PRIMARY_TARGET_KEY = 'primaryTargetKey'
local IMPACT_VFX = 'imp_W_IceAcolyte_Splash.lvl'
local AOE_VFX = 'imp_W_IceAcolyte.lvl'

local maxVelocityThreshold = 35
local slowMaxVelocity = 35
local attackSpeedSlowMultiplier = 2
local ATTACK_SPEED_SLOW_KEY = 'ATTACK_SPEED_SLOW_KEY'
local PRIMARY_TARGET_KEY = 'PRIMARY_TARGET_KEY'
local INIT_TARGET = 'initTargetKey'
local SLOW_ENTITY_KEY = 'iceAcolyteSlowEntityKey'
local TIMING_ENTITY_IDENTIFIER = 'iceAcolyteTimingEntity'
local ON_KILL_VFX_ENTITY = 'iceAcolyteKillEffectEntity'
local ON_KILL_VFX_AOE_ENTITY = 'iceAcolyteAoEKillEffectEntity'

--[[
This DamageTrigger gives W_IceAcolyte the Slow UnitAbility.
--]]
W_IceAcolyte_damageTrigger = function(damage, targetEntity, sourceEntity)
    if objc.is_normal_unit(targetEntity) or objc.is_commander(targetEntity) then
        local playerNumber = objc.get_player_number(sourceEntity)
        local spawned = objc.spawn(TIMING_ENTITY_IDENTIFIER, 1, playerNumber)
        local slowEntity = objc.get_local_value(targetEntity, SLOW_ENTITY_KEY)
        if slowEntity ~= 0 then
            objc.sacrifice_entity(slowEntity)
        end
        objc.set_local_value(targetEntity, SLOW_ENTITY_KEY,  spawned[1])
        objc.set_local_value(spawned[1], INIT_TARGET, targetEntity)
    end
    return damage
end
