local LATEST_INDICATOR = 'latestIndicatorKey'
local GROW_ANIMATION_NAME = 'W_Leveler_Battle_Range_01'
local INDICATOR_ARRAY = 'indicatorArrayKey'
local INDICATOR_OFFSET = 150
local KILL_COUNT_KEY = 'HowManyKills'
local INCREMENT_ANIMATION_TIME = 600
local SCALE_ANIMATION_LENGTH = 3900
local HEALTH_BUFF = 'healthBuffKey'
local DAMAGE_BUFF = 'damageBuffKey'

W_Leveler_spawnTrigger = function(entity)
   local healthBuff = objc.get_combat_entity_custom_stat(entity, CUSTOM_ENTITY_STAT_KEY_HEALTH_BONUS)
   local damageBuff = objc.get_combat_entity_custom_stat(entity, CUSTOM_ENTITY_STAT_KEY_DAMAGE_BONUS)
   objc.set_local_value(entity, HEALTH_BUFF, healthBuff)
   objc.set_local_value(entity, DAMAGE_BUFF, damageBuff)
end

W_Leveler_onKillTrigger = function(killedEntity, killerEntity)
   W_Leveler_Buff_Unit(killerEntity)
end

W_Leveler_Buff_Unit = function(entity)
   --find tier
   local tierOfLeveler = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_TIER)

   --Increase Health
   local healthIncrease = objc.get_local_value(entity,HEALTH_BUFF)
   local maxHealth = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_HEALTH)
   local currentHealth = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_CURRENT_HEALTH)
   local healthProp = objc.divide_with_ceiling(currentHealth, maxHealth)
   objc.set_entity_value(entity, 'healthDefenseComponent.maxHealth', maxHealth + healthIncrease)
   objc.set_entity_value(entity, 'healthDefenseComponent.health', currentHealth + math.ceil(healthIncrease * healthProp))

   --Increase Damage
   local damageIncrease = objc.get_local_value(entity,DAMAGE_BUFF)
   local damageBonus = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_DAMAGE_BUFF)
   objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_DAMAGE_BUFF, damageBonus + damageIncrease)

   --increment counter and display it
   killCounter = objc.get_local_value(entity, KILL_COUNT_KEY)
   objc.set_local_value(entity, KILL_COUNT_KEY, killCounter + 1)

   local animationEndPoint = (killCounter + 1) * INCREMENT_ANIMATION_TIME
   if animationEndPoint <= SCALE_ANIMATION_LENGTH then
      objc.play_passive_animation(entity, GROW_ANIMATION_NAME, 0, animationEndPoint)
   end
end