local HAS_INIT = 'hasInitKey'
local PROJECTILE_TARGET = 'projectileTargetEntityKey'
local IMPACT_EFFECT_ENTITY = 'lobberProjectileImpactEffect'
local LOB_TIME = 20

W_LobberProjectileDummy_spawnTrigger = function(entity)
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_ATTACK_RANGE, 10)
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
end

W_LobberProjectileDummy_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        local targetEntity = objc.get_local_value(entity, PROJECTILE_TARGET)
        if targetEntity ~= 0 then
            local distance = objc.unit_distance_with_offset(entity, 0, 0, targetEntity, 0, 0)
            local lobVelocity = objc.divide_with_floor(distance, LOB_TIME)
            objc.move_entity_to_entity_with_motion(entity, targetEntity, MOTION_STATE_LEAP, lobVelocity)
        end
        objc.set_local_value(entity, HAS_INIT, 1)
    end
end

W_LobberProjectileDummy_onOverrideTargetingCompletionTrigger = function(sourceEntity, targetEntity, targetingFailed)
    local playerNumber = objc.get_player_number(sourceEntity)
    local entityPos = objc.get_entity_position(sourceEntity)
    objc.spawn_at_point(IMPACT_EFFECT_ENTITY, 1, playerNumber, entityPos[1], entityPos[2], 0, 0)
    objc.sacrifice_entity(sourceEntity)
end