local HAS_SPAWNED_CABLE = 'hasSpawnedCable'
local HARVEST_ANIMATION_INTERVAL = 40
local HARVEST_ANIMATION_TIMER = 'harvestAnimationTimer'
local SPAWNED_CABLE = 'spawnedCableKey'
local SHOULD_START_PULSE_COUNTDOWN = 'shouldStartPulseCountdown'

local FIRST_PULSE_INTERVAL = 20
local FINISHED_FIRST_PULSE = 'finishedFirstPulse'

W_PowerPlant_Tutorial_spawnTrigger = function(entity)
    objc.load_lua_dependencies({'PowerPlant.lua'})
    PowerPlant_spawnTrigger(entity)
end

W_PowerPlant_Tutorial_tickTrigger = function(entity)
    local finishedFirstPulse = objc.get_local_value(entity, FINISHED_FIRST_PULSE)
    if finishedFirstPulse == 0 then
        local firstPulseTimer = objc.tick_timer(entity, 'FirstPulseTimer', FIRST_PULSE_INTERVAL)
        if firstPulseTimer == 0 then
            W_PowerPlant_Tutorial_playPulse(entity)
            objc.set_local_value(entity, FINISHED_FIRST_PULSE, 1)
        end
    else
        local harvestTimer = objc.tick_timer(entity, HARVEST_ANIMATION_TIMER, HARVEST_ANIMATION_INTERVAL)
        if harvestTimer == 0 then
            W_PowerPlant_Tutorial_playPulse(entity)
        end
    end
end

W_PowerPlant_Tutorial_playPulse = function(entity)
    objc.play_override_animation(entity, 'W_PowerPlant_Attack_01', objc.convert_frames_to_subrounds(30))
    local spawnedCable = objc.get_local_value(entity, SPAWNED_CABLE)
    if spawnedCable ~= 0 then
        objc.set_local_value(spawnedCable, SHOULD_START_PULSE_COUNTDOWN, 1)
    end
end

W_PowerPlant_Tutorial_deathTrigger = function(entity)
    PowerPlant_deathTrigger(entity)
end

W_PowerPlant_Tutorial_reachedOvertimeTrigger = function(entity)
    PowerPlant_reachedOvertimeTrigger(entity)
end
