local PRIMARY_TARGET_KEY = 'primaryTargetKey'
local AOE_VFX = 'imp_W_ScoutFlier.lvl'
local ON_KILL_ENTITY_GROUND = 'scoutFlierKillEntityGround'
local ON_KILL_ENTITY_AIR = 'scoutFlierKillEntityAir'
local AOE_RADIUS = 1100

W_ScoutFlier_spawnTrigger = function(entity)
    objc.set_local_value(entity, PRIMARY_TARGET_KEY, 0)
end

W_ScoutFlier_onAttackTrigger = function(sourceEntity, targetEntity)
    objc.set_local_value(sourceEntity, PRIMARY_TARGET_KEY, 0)
end

W_ScoutFlier_damageTrigger = function(damage, targetEntity, sourceEntity)
--[[ Removing AOE from this guy for now
    local teamNumber = objc.get_team_number(sourceEntity)
    local enemyNumber = objc.get_enemy_team_number(sourceEntity)
    local airship = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_SOURCE_ENTITY)

    local targetPlane = objc.get_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_PLANE_OF_EXISTENCE)
    local primaryTarget = objc.get_local_value(airship, PRIMARY_TARGET_KEY)

    if primaryTarget == 0 then
        objc.set_local_value(airship, PRIMARY_TARGET_KEY, targetEntity)
        
        if targetPlane == NUM_PLANE_OF_EXISTENCE_AIR then
            objc.play_vfx(targetEntity, AOE_VFX, NODE_IMPACT)
        else
            objc.play_vfx(targetEntity, AOE_VFX, NODE_ORIGIN)
        end

        local enemies = objc.list_entities_in_radius(targetEntity, AOE_RADIUS, enemyNumber)
        for _,enemy in pairs(enemies) do
            local enemyPlane = objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_PLANE_OF_EXISTENCE)
            if enemyPlane == targetPlane and enemy ~= targetEntity then
                objc.inflict_normal_damage(sourceEntity, enemy, damage)
            end
        end
    end]]
    return damage
end

W_ScoutFlier_onKillTrigger = function(killedEntity, killerEntity)
    local primaryTarget = objc.get_local_value(killerEntity, PRIMARY_TARGET_KEY)
    if primaryTarget == killedEntity then
        local enemyPosX = objc.get_entity_value_for_key(killedEntity, ENTITY_VALUE_KEY_POSITION_X)
        local enemyPosY = objc.get_entity_value_for_key(killedEntity, ENTITY_VALUE_KEY_POSITION_Y)
        local playerNumber = objc.get_player_number(killerEntity)
        local enemyPlane = objc.get_entity_value_for_key(killedEntity, ENTITY_VALUE_KEY_PLANE_OF_EXISTENCE)
        if enemyPlane == NUM_PLANE_OF_EXISTENCE_GROUND then
            objc.spawn_at_point(ON_KILL_ENTITY_GROUND, 1, playerNumber, enemyPosX, enemyPosY, 0, 0)
        else
            objc.spawn_at_point(ON_KILL_ENTITY_AIR, 1, playerNumber, enemyPosX, enemyPosY, 0, 0)
        end
    end
end
