local HAS_INIT = 'hasInitKey'
local SHOULD_CLONE = 'shouldCloneKey'
local CLONE_COUNT = 15
local CLONE_TIMER = 'cloneTimerKey'
local SHAPESHIFTER_IDENTIFIER = 'W_Shapeshifter'
local REFLECT_VFX = 'Commander_ReflecClone.lvl'

W_ShapeshifterSquad_tickTrigger = function(entity)
   local shouldClone = objc.get_local_value(entity, SHOULD_CLONE)

   if shouldClone == 0 then
      local teamNumber = objc.get_team_number(entity)
      local allies = objc.list_entities(teamNumber)
      local closestEntity = entity
      local closestDistance = 999999999999
      for _,ally in pairs(allies) do
         if objc.is_normal_unit(ally) and ally ~= entity then
            local thisID = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_IDENTIFIER)

            if not string.match(thisID, SHAPESHIFTER_IDENTIFIER) and not string.match(thisID, 'Spawner') then
               local thisDist = objc.quick_unit_distance_square(entity, ally)
               if thisDist < closestDistance then
                  closestEntity = ally
                  closestDistance = thisDist
               end
            end
         end
      end

      if closestEntity ~= entity then
         local spawnID = objc.get_entity_value_for_key(closestEntity, ENTITY_VALUE_KEY_IDENTIFIER)
         objc.play_vfx(entity, REFLECT_VFX, NODE_ORIGIN)
         objc.set_local_value(entity, SHOULD_CLONE, spawnID)
         objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
      end
      objc.set_local_value(entity, HAS_INIT, 1)
   else
      local cloneTimer = objc.tick_timer(entity, CLONE_TIMER, CLONE_COUNT)
      if cloneTimer == 0 then
         local spawned = objc.spawn_at_entity(shouldClone, 1, entity)
         objc.play_vfx(spawned[1], REFLECT_VFX, NODE_ORIGIN)
         objc.kill_entity(entity)
      end
   end
end
