local ATTACK_SPEED_MULTIPLIER = .75
local BUFF_DURATION = 10
local BUFF_SIZE = 800
local HAS_INIT = 'hasInitKey'
local HAS_BEEN_SPEAR_CAPTAINED = 'hasBeenSpearCaptained'

W_SpearCaptain_tickTrigger = function(entity)
    local buffTimer = objc.tick_timer(entity, 'buffTickKey', BUFF_DURATION)

    if buffTimer == 0 then
        local teamNumber = objc.get_team_number(entity)
        local nearbyAllies = objc.list_entities_in_radius(entity, BUFF_SIZE, teamNumber)
        objc.play_vfx(entity, 'B_BattleBard_Pulse.lvl', NODE_ORIGIN)

        for _,ally in pairs(nearbyAllies) do
            if objc.is_normal_unit(ally) then
                local hasBeenBuffed = objc.get_local_value(ally, HAS_BEEN_SPEAR_CAPTAINED)
                if hasBeenBuffed == 0 then
                    local previousAttackSpeed = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_ATTACK_RATE)
                    objc.set_entity_value_for_key(ally, ENTITY_VALUE_KEY_ATTACK_RATE, previousAttackSpeed * ATTACK_SPEED_MULTIPLIER)
                    objc.set_local_value(ally, HAS_BEEN_SPEAR_CAPTAINED, 1)
                end
                --this should play the VFX every time, but not stack the buff
                objc.play_vfx(ally, 'Status_damagePlus.lvl', NODE_STATUS)
            end
        end
    end
end
