local STEALTH_DURATION_ROUNDS = 50

local CRASH_ANIM_NAME = 'W_Damage_Fog_Attack_01'
local FRAMES_IN_CRASH_ANIM = 10

local COMBAT_IDLE_ANIM_NAME = 'combatIdleAnimation'

W_Stealth_spawnTrigger = function(entity)
    local numberOfSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_CRASH_ANIM)
    objc.play_override_animation(entity, CRASH_ANIM_NAME, objc.subrounds_to_milliseconds(numberOfSubrounds))

    local updatedAnimations = {}
    updatedAnimations[ANIMATION_STATE_IDLE] = COMBAT_IDLE_ANIM_NAME
    objc.update_animation_state(entity, updatedAnimations)

    local teamNumber = objc.get_team_number(entity)
    local alliesInRadius = objc.list_entities_in_radius(entity, STEALTH_RADIUS, teamNumber)
    local blinkParams = {} 
    blinkParams['red'] = 100
    blinkParams['green'] = 50
    blinkParams['blue'] = 255
    blinkParams['alpha'] = 60
    blinkParams['initialBlinkFrequency'] = 30
    blinkParams['finalBlinkFrequency'] = 30
    blinkParams['initialBlinkIntensity'] = 16
    blinkParams['finalBlinkIntensity'] = 16
    blinkParams['animationDurationInDeciseconds'] = 0
    blinkParams['animationAcceleration'] = 50
    blinkParams['easingType'] = EASE_OUT

    for _, ally in pairs(alliesInRadius) do
        if objc.is_normal_unit(ally) then
            objc.start_blinking(ally, blinkParams)
            objc.set_targetable(ally, false)
            objc.add_trigger(ally, TRIGGER_NAME_ON_ATTACK_TRIGGER, 'W_Stealth.lua', 'W_Stealth_revealOnAttackTrigger')
        end
    end
    objc.set_targetable(entity, false)
end

W_Stealth_revealOnAttackTrigger = function(sourceEntity, targetEntity)
    objc.stop_blinking(sourceEntity)
    objc.set_targetable(sourceEntity, true)
    objc.remove_trigger(sourceEntity, TRIGGER_NAME_ON_ATTACK_TRIGGER, 'W_Stealth_revealOnAttackTrigger')
end