local NUM_FRAMES_IN_ABILITY_ANIMATION = 120
local ANIMATION_START_OFFSET = 1000
local ABILITY_ANIMATION_NAME = 'W_SumoCommander_Battle_Ability_01'
local DEATH_TIMER_KEY = 'deathTimerKey'
local HAS_INIT_KEY = 'hasInitKey'
local SUMO_ABILITY_OUTRO_ANIMATION = 'W_SumoCommander_Battle_Ability_Outro_01'

W_SumoCommanderStandin_tickTrigger = function(entity)
	local hasInit = objc.get_local_value(entity, HAS_INIT_KEY)
	if hasInit == 0 then
		local numberOfSubrounds = objc.convert_frames_to_subrounds(NUM_FRAMES_IN_ABILITY_ANIMATION)
		local actualSubrounds = numberOfSubrounds - ANIMATION_START_OFFSET
	    objc.idle_entity(entity, actualSubrounds)
	    objc.play_passive_animation(entity, ABILITY_ANIMATION_NAME, ANIMATION_START_OFFSET, objc.subrounds_to_milliseconds(numberOfSubrounds))
	    objc.set_local_value(entity, HAS_INIT_KEY, 1)
	end
	
	local numRounds = objc.convert_frames_to_rounds(NUM_FRAMES_IN_ABILITY_ANIMATION)
	local offsetRounds = objc.divide_with_floor(ANIMATION_START_OFFSET, 100)
	local deathTick = objc.tick_timer(entity, DEATH_TIMER_KEY, numRounds - offsetRounds)
	if deathTick == 0 then
		objc.sacrifice_entity(entity)
	end
end


W_SumoCommanderStandin_deathTrigger = function(entity)
    local teamNumber = objc.get_team_number(entity)
    objc.play_commander_override_animation(teamNumber, SUMO_ABILITY_OUTRO_ANIMATION)
end