local TAUNT_TICK = 3
local TAUNT_RADIUS = 3500
local TAUNT_KEY = 'tauntTickKey'

local TAUNT_STATE = 'TauntState'
local END_MOVE_NAME = 'W_TauntUnit_endForceMoveTrigger'
local MOTION_STATE_DICT = 'MotionStateDictKey'

W_TauntUnit_tickTrigger = function(entity)
    local tauntTimer = objc.tick_timer(entity, TAUNT_KEY, TAUNT_TICK)
    if tauntTimer == 0 then
        local enemyNumber = objc.get_enemy_team_number(entity)
        local enemies = objc.list_entities_in_radius(entity, TAUNT_RADIUS, enemyNumber)
        for _,enemy in pairs(enemies) do
            if objc.is_normal_unit(enemy) then
                local tauntState = objc.get_local_value(enemy, TAUNT_STATE)
                if tauntState == 0 then
                    tauntState = objc.set_local_value(enemy, TAUNT_STATE, 1) 
                    local motionDict = objc.move_entity_to_entity_with_motion(enemy, entity, MOTION_STATE_WALK, 100)
                    objc.set_local_value(enemy, MOTION_STATE_DICT, motionDict)
                    objc.add_trigger(enemy, TRIGGER_NAME_ON_OVERRIDE_TARGETING_COMPLETION_TRIGGER, 'W_TauntUnit.lua', END_MOVE_NAME)
                end
            end
        end
    end
end

W_TauntUnit_endForceMoveTrigger = function(sourceEntity, targetEntity)
    local motionStateDict = objc.get_local_value(sourceEntity, MOTION_STATE_DICT)
    if motionStateDict ~= 0 then
        objc.swap_out_entity_motion_state_with_dictionary(sourceEntity, motionStateDict)
        objc.set_targeting(sourceEntity, targetEntity)
        objc.remove_trigger(sourceEntity, TRIGGER_NAME_ON_OVERRIDE_TARGETING_COMPLETION_TRIGGER, END_MOVE_NAME)
    end
end