local GAME_HAS_INIT = 'gameHasInit'
local UNIT_HAS_SPAWMED = 'unitHasSpawned'

local CHECK_TICK = 100
local CHECK_KEY = "checkKey"

local IDLE_TIME = 20000000
local LUA_ID = 'WnPyroWall.lua'



WnPyroWall_tickTrigger = function(entity)   
    local HasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if HasInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER) == 'R_Pyro9' then
                objc.immobilize_entity(unit, IDLE_TIME)
                objc.set_targetable(unit, false)
                objc.add_trigger(unit, TRIGGER_NAME_CAN_TARGET_TRIGGER, LUA_ID, 'Unit_TargetTrigger')
                objc.set_entity_scale_percentage(unit, 180)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_RANGE, 2500)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, -30)
                objc.set_entity_display_name(unit, 'Trigger')
                objc.set_entity_unit_description(unit, 'Watch out for the fire!')
            end
        end
        objc.set_local_value(entity, GAME_HAS_INIT, 1)
    end
end

Unit_TargetTrigger = function(entity, targetEntity)
    if objc.is_barricade(targetEntity) then
        return NO
    elseif objc.is_ground_unit(targetEntity) then
        return YES
    end
end