local HAS_INIT = 'hasMeteorInit'

local CHECK_TICK = 2
local CHECK_KEY = 'checkKey'

local GROW_TIMER_KEY = "growTimerKey"
local GROW_TICK = 1
local SIZE_KEY = "sizeKey"
local GROW_AMOUNT = 3

local DEATH_TIMER_KEY = "deathTimerKey"
local DEATH_TIME = 50

local UNIT_LUA = 'WxCampaignBanezingMeteor.lua'

WxCampaignBanezingMeteor_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'R_SpiderBomb' then
                if objc.get_local_value(unit, HAS_INIT) == 0 then
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, UNIT_LUA, 'BanezingMeteor_growTrigger')
                    objc.add_trigger(unit, TRIGGER_NAME_ON_DAMAGE_TRIGGER, UNIT_LUA, 'BanezingMeteor_invincibleTrigger')
                    objc.remove_trigger(unit, TRIGGER_NAME_ON_ATTACK_TRIGGER, 'R_SpiderBomb_onAttackTrigger')
                    objc.set_targetable(unit, false)
                    objc.set_local_value(unit, SIZE_KEY, 50)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)
                    objc.set_local_value(unit, HAS_INIT, 1)
                end
            end
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'R_SpiderBomb_ExplosionDelayScriptEntity' then
                if objc.get_local_value(unit, HAS_INIT) == 0 then
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, UNIT_LUA, 'MeteorExplosion_explodeTrigger')
                    objc.remove_trigger(unit, TRIGGER_NAME_ON_ATTACK_TRIGGER, 'R_SpiderBomb_ExplosionDelayScriptEntity_tickTrigger')
                    objc.set_local_value(unit, HAS_INIT, 1)
                end
            end
        end
    end
end

BanezingMeteor_growTrigger = function(entity)
    local growTimer = objc.tick_timer(entity, GROW_TIMER_KEY, GROW_TICK)
    if growTimer == 0 then
        local newSize = objc.get_local_value(entity, SIZE_KEY) + GROW_AMOUNT
        objc.set_entity_scale_percentage(entity, newSize)
        objc.set_local_value(entity, SIZE_KEY, newSize)
    end

    local deathTimer = objc.tick_timer(entity, DEATH_TIMER_KEY, DEATH_TIME)
    if deathTimer == 0 then
        objc.sacrifice_entity(entity)
    end
end

BanezingMeteor_invincibleTrigger = function(damage, targetEntity, sourceEntity)
    return 0
end

MeteorExplosion_explodeTrigger = function(entity)
    local timer = objc.tick_timer(entity, 'timer', 5)

    if timer == 0 then
        for _, enemy in pairs(objc.list_entities_in_radius(entity, 1100, 1)) do
            if objc.is_ground_unit(enemy) then
                objc.inflict_normal_damage(entity, enemy, 700)
            end
        end
        for _, enemy in pairs(objc.list_entities_in_radius(entity, 1100, 2)) do
            if objc.is_ground_unit(enemy) then
                objc.inflict_normal_damage(entity, enemy, 700)
            end
        end
        objc.sacrifice_entity(entity)
    end
end
