local HAS_INIT = 'hasInitKey'
local BARRICADE_NUMERATOR = 3
local BARRICADE_DENOMINATOR = 2

barricadeHealthIncrease_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        objc.set_local_value(entity, HAS_INIT, 1)
    elseif hasInit == 1 then
        objc.set_local_value(entity, HAS_INIT, 2)
    elseif hasInit == 2 then
        local player1Entities = objc.list_entities(1)
        for _, player1Entity in pairs(player1Entities) do
            if objc.is_barricade(player1Entity) or objc.is_base(player1Entity) then
                local barricadeHealth = objc.get_entity_value_for_key(player1Entity, ENTITY_VALUE_KEY_MAX_HEALTH)
                barricadeHealth = objc.divide_with_floor(barricadeHealth * BARRICADE_NUMERATOR, BARRICADE_DENOMINATOR)
                objc.set_entity_value_for_key(player1Entity, ENTITY_VALUE_KEY_MAX_HEALTH, barricadeHealth)
                objc.set_entity_value_for_key(player1Entity, ENTITY_VALUE_KEY_CURRENT_HEALTH, barricadeHealth)
            end
        end

        local player2Entities = objc.list_entities(2)
        for _, player2Entity in pairs(player2Entities) do
            if objc.is_barricade(player2Entity) or objc.is_base(player2Entity) then
                local barricadeHealth = objc.get_entity_value_for_key(player2Entity, ENTITY_VALUE_KEY_MAX_HEALTH)
                barricadeHealth = objc.divide_with_floor(barricadeHealth * BARRICADE_NUMERATOR, BARRICADE_DENOMINATOR)
                objc.set_entity_value_for_key(player2Entity, ENTITY_VALUE_KEY_MAX_HEALTH, barricadeHealth)
                objc.set_entity_value_for_key(player2Entity, ENTITY_VALUE_KEY_CURRENT_HEALTH, barricadeHealth)
            end
        end
        objc.set_local_value(entity, HAS_INIT, 3)        
    end
end
