VFX_COOLDOWN_KEY = 'VFX_COOLDOWN_KEY'

--[[
This DeathTrigger spawns a VFX effect when the Hallucination dies.
--]]
bigHallucinatedTitanUnit_deathTrigger = function(entity)
   objc.spawn_at_entity('kuroAbility2HallucinationDeathEffect', 1, entity)
   return 0
end


--[[
This onDamageTrigger plays a visual effect when the Hallucination gets hit
--]]

bigHallucinatedTitanUnit_onDamageTrigger = function(damage, targetEntity, sourceEntity)
	
	if objc.get_local_value(targetEntity, VFX_COOLDOWN_KEY) == 0 then
		objc.play_vfx(targetEntity, 'CommanderHallucinationImpact.lvl', 'vfx_attachpoint')
		objc.set_local_value(targetEntity, VFX_COOLDOWN_KEY, 1)
	end
	return damage
end

--[[
This tickTrigger handles the cooldown for playing the VFX
--]]

bigHallucinatedTitanUnit_tickTrigger = function(entity)
	
	
	if objc.get_local_value(entity, VFX_COOLDOWN_KEY) == 1 then
		local vfxCooldown = objc.tick_timer(entity, 'vfxCooldown', 10)

		if vfxCooldown == 0 then
			objc.set_local_value(entity, VFX_COOLDOWN_KEY, 0)
		end
	end

	return 0
end
