#define SUPPORT_GLSL300
#include "prefix_tow.sh"
//#ifdef GL_ES
//#extension GL_EXT_draw_instanced: enable
//#define INSTANCE_ID gl_InstanceIDEXT
//#else
//#extension GL_ARB_draw_instanced: enable
//#define INSTANCE_ID gl_InstanceIDARB
//#endif
#define INSTANCE_ID gl_InstanceID

#if defined(GL_ES)
    precision highp float;
#endif

//This needs to be kept in sync with BlobShadowRenderer.m
#define MAX_BLOB_SHADOWS 272 

//It is expected that this will always be in the form [±1, 0 ±1]
//This will be translated via the instanced shadow position and scaled
//by the instanced scale.
ATTRIBUTE vec3 a_cc3Position;
ATTRIBUTE vec2 a_cc3TexCoord;

// uniforms
//For this value, x and z are true positions, but y is actually the
//scale of the shadow.  the true y is always set using a uniform
uniform vec3 BlobShadow_shadowPositions[MAX_BLOB_SHADOWS];
uniform mat4 BlobShadow_viewProjMatrix;
uniform float BlobShadow_shadowYPosition;

// varyings
VARYING_OUT vec2 v_texCoord;

void main() {
    vec4 true_position = vec4(a_cc3Position, 1.0);
    true_position.xz = true_position.xz * BlobShadow_shadowPositions[INSTANCE_ID].y + BlobShadow_shadowPositions[INSTANCE_ID].xz;
    true_position.y = BlobShadow_shadowYPosition; // + (float)INSTANCE_ID * 0.1;  //Bias the shadows so they don't z-fight

    gl_Position = BlobShadow_viewProjMatrix * true_position;

    v_texCoord = a_cc3TexCoord;
}
