
#if defined(GL_ES)
    precision highp float;
#endif

#define N_BLEND_STAGES 4

uniform sampler2D s_cc3Texture2Ds[N_BLEND_STAGES+1];

varying vec2 v_texCoord;

void main() {
    vec4 fragColor = texture2D(s_cc3Texture2Ds[0], v_texCoord);
    vec4 bloomColor = vec4(0.0);
    for (int i = 1; i <= N_BLEND_STAGES; i++) {
        bloomColor += texture2D(s_cc3Texture2Ds[i], v_texCoord);
    }
    fragColor = fragColor * clamp(vec4(1.0) - bloomColor, 0.0, 1.0);
    gl_FragColor = fragColor + bloomColor;
}
