
#define SUPPORT_GLSL300

#include "prefix.sh"
#include "border.sh"

uniform BORDER_SAMPLER encodedDepthsSampler;

void main() {
    #if __VERSION__ < 300 || defined(BORDER_DIRECT_ZBUFFER)
        float border = borderEstimateFloat(encodedDepthsSampler, inputPixelCoord());
    #elif defined(BORDER_THICK)
        float border = borderEstimateIntThick(encodedDepthsSampler, inputPixelCoord());
    #else
        float border = borderEstimateInt(encodedDepthsSampler, inputPixelCoord());
    #endif
    gl_FragColor.rgb = getBorderColor().rgb;
    gl_FragColor.a = getBorderColor().a * border;
    
#if defined(BORDER_VISUALIZE_OUTLINE) && (__VERSION__ >= 300)
    // show the size of the bounding volumes using a chequerboard pattern
    if (((uint(gl_FragCoord.x/8.0) ^ uint(gl_FragCoord.y/8.0)) & uint(0x1)) != uint(0x0)) {
        float chequerAlpha = 0.25;
        gl_FragColor.rgb = (gl_FragColor.rgb * gl_FragColor.a + vec3(1.0, 0.0, 1.0) * chequerAlpha) / (gl_FragColor.a + chequerAlpha);
        gl_FragColor.a = max(gl_FragColor.a, chequerAlpha);
    }
#endif
}
