
#if defined(GL_ES)
    precision highp float;
#endif

uniform vec3 u_cc2ScreenDimension;

uniform vec4 u_overlayColor;

// x,y = position z = radius
uniform vec3 u_circle1;
uniform vec3 u_circle2;

// x,y = position z,w = width,height
uniform vec4 u_rectangle1;
uniform vec4 u_rectangle2;

varying vec2 v_texCoord;

void main() {
    vec2 fragPosition = v_texCoord * u_cc2ScreenDimension.xy;
    float delta1 = distance(fragPosition, u_circle1.xy);
    float delta2 = distance(fragPosition, u_circle2.xy);
    float b1 = 0.9 * u_circle1.z;
    float b2 = 0.9 * u_circle2.z;
    float c_gradient1 = min(max(delta1 - b1, 0.0) / (u_circle1.z - b1), 1.0);
    float c_gradient2 = min(max(delta2 - b2, 0.0) / (u_circle2.z - b2), 1.0);

    // Rectangle 1
    float dx1 = distance(fragPosition.x, u_rectangle1.x);
    float dy1 = distance(fragPosition.y, u_rectangle1.y);
    float borderx1 = 0.5 * 0.9 * u_rectangle1.z;
    float bordery1 = 0.5 * 0.9 * u_rectangle1.w;
    float xgrad1 = max(0.0, min((dx1 - borderx1) / (0.5 * u_rectangle1.z - borderx1), 1.0));
    float ygrad1 = max(0.0, min((dy1 - bordery1) / (0.5 * u_rectangle1.w - bordery1), 1.0));
    float r_gradient1 = max(xgrad1, ygrad1);

    // Rectangle 2
    float dx2 = distance(fragPosition.x, u_rectangle2.x);
    float dy2 = distance(fragPosition.y, u_rectangle2.y);
    float borderx2 = 0.5 * 0.9 * u_rectangle2.z;
    float bordery2 = 0.5 * 0.9 * u_rectangle2.w;
    float xgrad2 = max(0.0, min((dx2 - borderx2) / (0.5 * u_rectangle2.z - borderx2), 1.0));
    float ygrad2 = max(0.0, min((dy2 - bordery2) / (0.5 * u_rectangle2.w - bordery2), 1.0));
    float r_gradient2 = max(xgrad2, ygrad2);
    
    gl_FragColor = u_overlayColor * c_gradient1 * c_gradient2 * r_gradient1 * r_gradient2;
}
