local CHECK_RADIUS = 200
local CHECK_INTERVAL = 10
local CHECK_TIMER_KEY = 'checkTimerKey'
local DAMAGE_BUFF_FACTOR = 2 --this is 1/x, so 2 = 50% increase

damageGasCloudScriptEntity_tickTrigger = function(entity)
	local timer = objc.tick_timer(entity, CHECK_TIMER_KEY, CHECK_INTERVAL)

	if timer == 0 then
		local teamNumber = objc.get_team_number(entity)
		for _, ally in pairs(objc.list_entities_in_radius(entity, CHECK_RADIUS, teamNumber)) do
			if objc.is_ground_unit(ally) and objc.is_normal_unit(ally) then
				local thisDamage = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_ATTACK_DAMAGE)
				local toAdd = objc.divide_with_floor(thisDamage, DAMAGE_BUFF_FACTOR)
				local thisBuff = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_DAMAGE_BUFF)
				objc.set_entity_value_for_key(ally, ENTITY_VALUE_KEY_DAMAGE_BUFF, thisBuff + toAdd)

				local blinkParams = {} 
	            blinkParams['red'] = 255
	            blinkParams['green'] = 50
	            blinkParams['blue'] = 50
	            blinkParams['alpha'] = 128
	            blinkParams['initialBlinkFrequency'] = 30
	            blinkParams['finalBlinkFrequency'] = 30
	            blinkParams['initialBlinkIntensity'] = 16
	            blinkParams['finalBlinkIntensity'] = 16
	            blinkParams['animationDurationInDeciseconds'] = 0
	            blinkParams['animationAcceleration'] = 50
	            blinkParams['easingType'] = EASE_OUT
	            objc.start_blinking(ally, blinkParams)

				objc.kill_entity(entity)
			end
		end
	end
end
