local HAS_INIT = 'hasInitKey'
local CENTRAL_OBJECTIVE_MARKER_NAME = 'GroundCircle'
local MINER_WAYPOINT = 'MinerWaypoint'
local MINER_PLACEMENT_BUFFER = -100
local MINE_POINT_X = 'minePointXKey'
local MINE_POINT_Y = 'minePointYKey'
local MINER_LIST = 'minerListKey'
local IS_PRE_PLACED = 'isPrePlacedKey'
local MINE_INDEX_KEY = 'mineIndexKey'

defaultBattleField2vE_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        local is2vE = 0
        local playerNumbers = objc.get_player_numbers_for_team_number(1)
        for _, number in pairs(playerNumbers) do
            if number > 2 then
                is2vE = 1
            end
        end

        local p1Mines = objc.location_marker_node_names_with_prefix("P1_Mine")
        for k,v in pairs(p1Mines) do
            local x, y = objc.location_of_marker_node_named(v)
            spawnCrystalMineAtPosition(x, y, 1, v, true)
        end

        if is2vE == 1 then
            local p3Mines = objc.location_marker_node_names_with_prefix("P3_Mine")
            for k,v in pairs(p3Mines) do
                local x, y = objc.location_of_marker_node_named(v)
                spawnCrystalMineAtPosition(x, y, 1, v, false)
            end
        end

        local playerNumbers = objc.get_player_numbers_for_team_number(1) -- if this is a 2v2 or a 2ve, set base income to 75%
        for _, number in pairs(playerNumbers) do
            if number > 2 then
                objc.set_entity_value_for_key(objc.get_base_entity(1), ENTITY_VALUE_KEY_INCOME_TIER, 1)
                objc.set_entity_value_for_key(objc.get_base_entity(2), ENTITY_VALUE_KEY_INCOME_TIER, 1)
            end
        end

        objc.spawn('gameRulesEntity', 1, 1)
        objc.set_local_value(entity, HAS_INIT, 1)
    elseif hasInit == 1 then

        objc.set_local_value(entity, HAS_INIT, 2)
    end
end

spawnCrystalMineAtPosition = function(xPos, yPos, playerNumber, name, should_set_view)
    local spawnedMine = objc.spawn_skinned_entity_with_key_at_point(SKINNED_ENTITY_KEY_CRYSTAL_MINE, 1, playerNumber, xPos, yPos, 1, 0)
    objc.set_local_value(spawnedMine[1], MINE_INDEX_KEY, string.sub(name, -1))
    objc.set_placeable_objective_marker_node_name(spawnedMine[1], name)

    if should_set_view then
        objc.set_placeable_objective_view(spawnedMine[1], name)
    end
end

spawnCrystalObjectiveAtPosition = function(xPos, yPos, tag)
    local centerObjective = objc.spawn_skinned_entity_with_key_at_point(SKINNED_ENTITY_KEY_CENTRAL_OBJECTIVE, 1, 0, xPos, yPos, 0, 0)
    objc.set_local_value(centerObjective[1], LUA_KEY_TAG, tag)
    objc.set_entity_value_for_key(centerObjective[1], ENTITY_VALUE_KEY_INCOME_TIER, 0)
    return centerObjective[1]
end

spawnCrystalWorker = function(xPos, yPos, side, name)
    local faction = objc.get_commander_factions(side)
    local spawnedMiner
    if faction[1] == FACTION_BLUE then
        spawnedMiner = objc.spawn_at_point(ASCENSION_MINER, 1, side, xPos, yPos, 1, 0)
    elseif faction[1] == FACTION_GREEN then
        spawnedMiner = objc.spawn_at_point(LEGION_MINER, 1, side, xPos, yPos, 1, 0)
    elseif faction[1] == FACTION_RED then
        spawnedMiner = objc.spawn_at_point(ROGUE_MINER, 1, side, xPos, yPos, 1, 0)
    else
        spawnedMiner = objc.spawn_at_point(ROGUE_MINER, 1, side, xPos, yPos, 1, 0)
    end

    objc.set_local_value(spawnedMiner[1], IS_PRE_PLACED, 1)
    return spawnedMiner[1]
end
