local HAS_INIT = 'hasInitKey'
local MINER_WAYPOINT = "MinerWaypoint"
local MINE_INDEX_KEY = 'mineIndexKey'

defaultBattleFieldTutorial_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then

        local p1Mines = objc.location_marker_node_names_with_prefix("P1_Mine")
        for k,v in pairs(p1Mines) do
            local x, y = objc.location_of_marker_node_named(v)
            spawnCrystalMineAtPosition(x, y, 1, v, true)
        end

        local p2Mines = objc.location_marker_node_names_with_prefix("P2_Mine")
        for k,v in pairs(p2Mines) do
            local x, y = objc.location_of_marker_node_named(v)
            spawnCrystalMineAtPosition(x, y, 2, v, false)
        end

        local x, y = objc.location_of_marker_node_named("P1_DropOff")
        spawnMinerWaypointAtPosition(x,y,1)

        local x, y = objc.location_of_marker_node_named("P2_DropOff")
        spawnMinerWaypointAtPosition(x,y,2)

        objc.spawn('gameRulesEntity', 1, 1)
        objc.set_local_value(entity, HAS_INIT, 1)
    end

end

spawnCrystalMineAtPosition = function(xPos, yPos, playerNumber, name, should_set_view)
    local spawnedMine = objc.spawn_skinned_entity_with_key_at_point(SKINNED_ENTITY_KEY_CRYSTAL_MINE, 1, playerNumber, xPos, yPos, 1, 0)
    objc.set_local_value(spawnedMine[1], MINE_INDEX_KEY, string.sub(name, -1))
    objc.set_placeable_objective_marker_node_name(spawnedMine[1], name)

    if should_set_view then
        objc.set_placeable_objective_view(spawnedMine[1], name)
    end
end

spawnMinerWaypointAtPosition = function(xPos, yPos, playerNumber)
    objc.spawn_at_point(MINER_WAYPOINT, 1, playerNumber, xPos, yPos, 1, 0)
end

spawnCrystalWorker = function(xPos, yPos, side)
    local faction = objc.get_commander_factions(side)
    if faction[1] == FACTION_BLUE then
        objc.spawn_at_point(ASCENSION_MINER, 1, side, xPos, yPos, 1, 0)
    elseif faction[1] == FACTION_GREEN then
        objc.spawn_at_point(LEGION_MINER, 1, side, xPos, yPos, 1, 0)
    elseif faction[1] == FACTION_RED then
        objc.spawn_at_point(ROGUE_MINER, 1, side, xPos, yPos, 1, 0)
    else
        objc.spawn_at_point(ROGUE_MINER, 1, side, xPos, yPos, 1, 0)
    end
end
