local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'

local BOSS_UNIT_BASE_IDENTIFIER = 'W_LongRangeTank'
local HAS_TRIGGER = 'hasEnragingTrigger'
local BUFF_AMOUNT = 10
local BUFF_VFX = 'C_Ai_Buff.lvl'
local HAS_BEEN_BUFFED = 'hasBeenEnrageBuffedKey'

local MAX_SCALE = 200

enragingModifier_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            local hasEnragingTrigger = objc.get_local_value(unit, HAS_TRIGGER)
            if objc.is_normal_unit(unit) and objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) ~= BOSS_UNIT_BASE_IDENTIFIER and hasEnragingTrigger == 0 then
                objc.add_trigger(unit, TRIGGER_NAME_ON_DAMAGE_TRIGGER, 'enragingModifier.lua', 'enragingModifier_boostOnDamage')
                objc.set_local_value(unit, HAS_TRIGGER, 1)
            end
        end
    end
end

enragingModifier_boostOnDamage = function(damage, targetEntity, sourceEntity)
    local damageBoost = objc.get_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_DAMAGE_BUFF)
    objc.set_entity_value_for_key(targetEntity, ENTITY_VALUE_KEY_DAMAGE_BUFF, damageBoost + BUFF_AMOUNT)

    local scale = objc.get_entity_scale_percentage(targetEntity)
    local scaleToSet = scale + 5
    if scaleToSet > MAX_SCALE then
        scaleToSet = MAX_SCALE
    end
    objc.set_entity_scale_percentage(targetEntity, scaleToSet)

    local hasBeenBuffed = objc.get_local_value(targetEntity, HAS_BEEN_BUFFED)
    if hasBeenBuffed == 0 then
        objc.play_vfx(targetEntity, BUFF_VFX, NODE_STATUS)
        objc.set_local_value(targetEntity, HAS_BEEN_BUFFED, 1)
    end

    return damage
end
