local UNIT_BUFF_ARRAY = objc.get_object_info('Event', 'dungeon', 'eventUnitIdentifiers')
local BUFF_PERCENTAGE_NUMERATOR = 3
local BUFF_PERCENTAGE_DENOMINATOR = 2

local ENTITY_CHECK_TIMER = 'entityCheckTimer'
local ENTITY_CHECK_INTERVAL = 3

local HAS_BEEN_BUFFED = 'hasBeenEventBuffedKey'

eventEntity_tickTrigger = function(entity)
    local entityCheckTimer = objc.tick_timer(entity, ENTITY_CHECK_TIMER, ENTITY_CHECK_INTERVAL)
    if entityCheckTimer == 0 then
        local team1Entites = objc.list_entities(1)
        for _,team1Unit in pairs(team1Entites) do
            if objc.is_normal_unit(team1Unit) then
                local thisID = objc.get_entity_value_for_key(team1Unit, ENTITY_VALUE_KEY_IDENTIFIER)
                local shouldBuff = false
                for _, buffID in pairs(UNIT_BUFF_ARRAY) do
                    if buffID == thisID or buffID == string.sub(thisID, 1, -2) then
                        shouldBuff = true
                    end
                end
                local hasBeenEventBuffed = objc.get_local_value(team1Unit, HAS_BEEN_BUFFED)

                if shouldBuff == true and hasBeenEventBuffed == 0 then
                    local currentMaxHealth = objc.get_entity_value_for_key(team1Unit, ENTITY_VALUE_KEY_MAX_HEALTH)
                    local currentDamage = objc.get_entity_value_for_key(team1Unit, ENTITY_VALUE_KEY_ATTACK_DAMAGE)
                    local healthToSet = objc.divide_with_ceiling(currentMaxHealth * BUFF_PERCENTAGE_NUMERATOR, BUFF_PERCENTAGE_DENOMINATOR)
                    local damageToSet = objc.divide_with_ceiling(currentDamage * BUFF_PERCENTAGE_NUMERATOR, BUFF_PERCENTAGE_DENOMINATOR) - currentDamage

                    objc.set_entity_value_for_key(team1Unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, damageToSet)
                    objc.set_entity_value_for_key(team1Unit, ENTITY_VALUE_KEY_MAX_HEALTH, healthToSet)
                    objc.set_entity_value_for_key(team1Unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, healthToSet)

                    objc.play_vfx(team1Unit, 'buff_symbol.lvl', NODE_STATUS)
                    objc.set_local_value(team1Unit, HAS_BEEN_BUFFED, 1)
                end
            end
        end

        local team2Entites = objc.list_entities(2)
        for _,team2Unit in pairs(team2Entites) do
            if objc.is_normal_unit(team2Unit) then
                local thisID = objc.get_entity_value_for_key(team2Unit, ENTITY_VALUE_KEY_IDENTIFIER)
                local shouldBuff = false
                for _, buffID in pairs(UNIT_BUFF_ARRAY) do
                    if buffID == thisID or buffID == string.sub(thisID, 1, -2) then
                        shouldBuff = true
                    end
                end
                local hasBeenEventBuffed = objc.get_local_value(team2Unit, HAS_BEEN_BUFFED)
                
                if shouldBuff == true and hasBeenEventBuffed == 0 then
                    local currentMaxHealth = objc.get_entity_value_for_key(team2Unit, ENTITY_VALUE_KEY_MAX_HEALTH)
                    local currentDamage = objc.get_entity_value_for_key(team2Unit, ENTITY_VALUE_KEY_ATTACK_DAMAGE)
                    local healthToSet = objc.divide_with_ceiling(currentMaxHealth * BUFF_PERCENTAGE_NUMERATOR, BUFF_PERCENTAGE_DENOMINATOR)
                    local damageToSet = objc.divide_with_ceiling(currentDamage * BUFF_PERCENTAGE_NUMERATOR, BUFF_PERCENTAGE_DENOMINATOR) - currentDamage
                    objc.set_entity_value_for_key(team2Unit, ENTITY_VALUE_KEY_MAX_HEALTH, healthToSet)
                    objc.set_entity_value_for_key(team2Unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, damageToSet)
                    objc.set_entity_value_for_key(team2Unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, healthToSet)

                    objc.play_vfx(team2Unit, 'buff_symbol.lvl', NODE_STATUS)
                    objc.set_local_value(team2Unit, HAS_BEEN_BUFFED, 1)
                end
            end
        end
    end
end
