local DAMAGE_TICK_SPEED = 10
local DAMAGE_PER_TICK = 2
local TIMER_KEY = 'damageTickTimerKey'
local OWNER_ENTITY = 'ownerEntityKey'

flameScriptEntity_tickTrigger = function(entity)
	local damageTimer = objc.tick_timer(entity, TIMER_KEY, DAMAGE_TICK_SPEED)
	if damageTimer == 0 then
		local ownerEntity = objc.get_local_value(entity, OWNER_ENTITY)
		if ownerEntity ~= 0 then
			local ownerHealth = objc.get_entity_value_for_key(ownerEntity, ENTITY_VALUE_KEY_CURRENT_HEALTH)
			if ownerHealth <= 0 then
				objc.kill_entity(entity)
			else
				objc.inflict_normal_damage(entity, ownerEntity, DAMAGE_PER_TICK)
				objc.flash_entity_for_damage(ownerEntity, 250)
			end
		else
			objc.kill_entity(entity)
		end
	end
end
