#ifndef FOG_DISABLED
varying vec3 aV;
varying float showFog;

#define MAX_DISTANCE 65.0

// Include in fragment shaders and call fog_receive to enable
void fog_receive() {
    float fogFactor = showFog * 0.7 * clamp(length(aV) / MAX_DISTANCE, 0.5, 1.0);
    gl_FragColor.rgb = fogFactor * vec3(fogFactor, fogFactor, fogFactor) + (1.0 - fogFactor) * gl_FragColor.rgb;
}
#endif