local FOG_RADIUS = 1000
local FOG_DAMAGE_AMOUNT = 'fogDamageKey'
local TICK_INTERVAL = 1
local RAIN_VFX = 'imp_Raindrop.lvl'
local TICK_COUNT_KEY = 'tickCountKey'
local VFX_TICK_COUNT = 5

fogEffectEntity_tickTrigger = function(entity)
	local tickTimer = objc.tick_timer(entity, 'tickTimer', TICK_INTERVAL)
	   if tickTimer == 0 then
	    local enemyNumber = objc.get_enemy_team_number(entity)
	    local enemies = objc.list_entities_in_radius(entity, FOG_RADIUS, enemyNumber)
	    local damageAmount = objc.get_local_value(entity, FOG_DAMAGE_AMOUNT)
	    for _, enemy in pairs(enemies) do
	        if (objc.is_building_unit(enemy) or objc.is_normal_unit(enemy) or objc.is_commander(enemy) or objc.is_base(enemy) or objc.is_barricade(enemy) or (objc.is_boss_unit(enemy) == 1)) and (objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_IS_BEING_PROTECTED) == 0) then
	            objc.inflict_normal_damage(entity, enemy, damageAmount)
	            objc.flash_entity_for_damage(enemy, 250)
	            local tickCount = objc.tick_timer(enemy, TICK_COUNT_KEY, VFX_TICK_COUNT)
	            if tickCount == 100 then
	            	objc.play_vfx(enemy, RAIN_VFX, NODE_STATUS)
	            end
	        end
	    end
	end
end