#if defined(GL_ES)
    precision highp float;
#endif

uniform sampler2D s_cc3Texture2Ds[1];
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

void main()
{
    float width = 0.01;
    float scale = 1.3;
    vec4 gacha_color = vec4(1.0, 0.6, 0.3, 1.0);
    vec2 uv = (v_texCoord - 0.5) * scale + 0.5;
    float alpha_x = min(1.0, (1.0 - clamp(abs(uv.x - 0.5) * 2.0, 0.0, 1.0)) * 100.0);
    float alpha_y = min(1.0, (1.0 - clamp(abs(uv.y - 0.5) * 2.0, 0.0, 1.0)) * 100.0);
    vec4 tex = texture2D(s_cc3Texture2Ds[0], uv);
    tex.a *= (alpha_x * alpha_y);

    float border = 0.0;
    for (float y=-1.0; y<2.0; y+=1.0)
    {
        for (float x=-1.0; x<2.0; x+=1.0)
        {
            vec2 offset = vec2(x, y) * width;
            alpha_x = min(1.0, (1.0 - clamp(abs(uv.x + offset.x - 0.5) * 2.0, 0.0, 1.0)) * 100.0);
            alpha_y = min(1.0, (1.0 - clamp(abs(uv.y + offset.y - 0.5) * 2.0, 0.0, 1.0)) * 100.0);
            float v = texture2D(s_cc3Texture2Ds[0], uv + offset).a;
            v *= (alpha_x * alpha_y);
            border += v;
        }
    }

    border = max(0.0, min(1.0, border) - tex.a);
    gl_FragColor = mix(tex * gacha_color, gacha_color, border);
}