local GAME_HAS_INIT = 'gameRulesHasInit'
local STARTING_SPEED_MULTIPLIER = 1.5
local MAX_SPEED_MULTIPLIER = 2
local START_OF_ESCALATION_IN_SECONDS = 120
local MAX_GAME_LENGTH_IN_SECONDS = 180
local INITIAL_MERCENARY_REGION_TEAM_ONE = objc.get_mercenary_placement_region(1, PLACEMENT_REGION_KEY_INITIAL)
local INITIAL_MERCENARY_REGION_TEAM_TWO = objc.get_mercenary_placement_region(2, PLACEMENT_REGION_KEY_INITIAL)
local INITIAL_PLACEMENT_X_TEAM_ONE = INITIAL_MERCENARY_REGION_TEAM_ONE[PLACEMENT_REGION_X]
local INITIAL_PLACEMENT_X_TEAM_TWO = INITIAL_MERCENARY_REGION_TEAM_TWO[PLACEMENT_REGION_X]
local ONE_CONDITION_MET_PLACEMENT_BONUS = 1800
local BOTH_CONDITIONS_MET_PLACEMENT_BONUS = 2400
local TACTICS_PLACEMENT_BONUS = 6000

gameRulesEntity_tickTrigger = function(entity)
    local gameRulesHasInit = objc.get_local_value(entity, GAME_HAS_INIT)
    if gameRulesHasInit == 0 then
        --putting more stuff in here will make it run only once at the beginning of the game.
        objc.set_local_value(entity, GAME_HAS_INIT, 1)
    end

    if objc.get_global_value("placementHasChanged") == 1 then
        --print("UPDATE PLACEMENT AREA")
        local placementXTeam1 = INITIAL_PLACEMENT_X_TEAM_ONE
        --local placementLengthTeam1
        local placementXTeam2 = INITIAL_PLACEMENT_X_TEAM_TWO
        --local placementLengthTeam2

        if objc.get_global_value("CenterObjective1CapturedByTeam") == 1 then
            --print("team 1 controls center")
            if objc.get_global_value("BarricadeTeamTwoDestroyed") == 1 then
                placementXTeam1 = placementXTeam1 + ONE_CONDITION_MET_PLACEMENT_BONUS + BOTH_CONDITIONS_MET_PLACEMENT_BONUS
                --print("team 1 has destroyed barrier") 

                local oldTacticRegion = objc.get_tactic_placement_region(1, PLACEMENT_REGION_KEY_INITIAL)
                objc.set_tactic_placement_region(1, PLACEMENT_REGION_KEY_INITIAL, oldTacticRegion[PLACEMENT_REGION_X],
                                                                                  oldTacticRegion[PLACEMENT_REGION_Y],
                                                                                  oldTacticRegion[PLACEMENT_REGION_LENGTH] + TACTICS_PLACEMENT_BONUS,
                                                                                  oldTacticRegion[PLACEMENT_REGION_WIDTH])  
            else
                placementXTeam1 = placementXTeam1 + ONE_CONDITION_MET_PLACEMENT_BONUS
                --print("team 1 has NOT destroyed barrier")    
            end
        else
            --print("team 1 does NOT controls center")
            if objc.get_global_value("BarricadeTeamTwoDestroyed") == 1 then
                placementXTeam1 = placementXTeam1 + ONE_CONDITION_MET_PLACEMENT_BONUS
                --print("team 1 has destroyed barrier")  
            --else
                --print("team 1 has NOT destroyed barrier") 
            end
        end 

        if objc.get_global_value("CenterObjective1CapturedByTeam") == 2 then
            --print("team 2 controls center")
            if objc.get_global_value("BarricadeTeamOneDestroyed") == 1 then
                placementXTeam2 = placementXTeam2 - ONE_CONDITION_MET_PLACEMENT_BONUS - BOTH_CONDITIONS_MET_PLACEMENT_BONUS
                --print("team 2 has destroyed barrier")   

                local oldTacticRegion = objc.get_tactic_placement_region(2, PLACEMENT_REGION_KEY_INITIAL)
                objc.set_tactic_placement_region(2, PLACEMENT_REGION_KEY_INITIAL, oldTacticRegion[PLACEMENT_REGION_X] - TACTICS_PLACEMENT_BONUS,
                                                                                  oldTacticRegion[PLACEMENT_REGION_Y],
                                                                                  oldTacticRegion[PLACEMENT_REGION_LENGTH] + TACTICS_PLACEMENT_BONUS,
                                                                                  oldTacticRegion[PLACEMENT_REGION_WIDTH])
            else
                placementXTeam2 = placementXTeam2 - ONE_CONDITION_MET_PLACEMENT_BONUS
                --print("team 2 has NOT destroyed barrier")   
            end
        else
            --print("team 2 does NOT controls center")
            if objc.get_global_value("BarricadeTeamOneDestroyed") == 1 then
                placementXTeam2 = placementXTeam2 - ONE_CONDITION_MET_PLACEMENT_BONUS
                --print("team 2 has destroyed barrier") 
            -- else
                --print("team 2 has NOT destroyed barrier")
            end
        end 

        --print("team 1 placement:" .. placementXTeam1)
        --print("team 2 placement:" .. placementXTeam2)
        objc.set_mercenary_placement_region(1, PLACEMENT_REGION_KEY_INITIAL, placementXTeam1, INITIAL_MERCENARY_REGION_TEAM_ONE[PLACEMENT_REGION_Y], INITIAL_MERCENARY_REGION_TEAM_ONE[PLACEMENT_REGION_LENGTH], INITIAL_MERCENARY_REGION_TEAM_ONE[PLACEMENT_REGION_WIDTH])
        objc.set_mercenary_placement_region(2, PLACEMENT_REGION_KEY_INITIAL, placementXTeam2, INITIAL_MERCENARY_REGION_TEAM_TWO[PLACEMENT_REGION_Y], INITIAL_MERCENARY_REGION_TEAM_TWO[PLACEMENT_REGION_LENGTH], INITIAL_MERCENARY_REGION_TEAM_TWO[PLACEMENT_REGION_WIDTH])
        objc.set_global_value("placementHasChanged", 0)
    end

end

--do objc.spawn(gameRulesEntity, 1, 1) in map lua to spawn this thing.
