local GETTING_PULLED_IN_KEY = 'GETTING_PULLED_IN_KEY'
local PULL_RADIUS = 9500
local KILL_RADIUS = 300
local TIER_THRESHOLD = 3

gravityCommanderAbility3EffectEntity_tickTrigger = function(entity)
   local checkForTargetsTimer = objc.tick_timer(entity, 'checkForTargetsTimer', 3)

   if checkForTargetsTimer == 0 then
      local enemyNumber = objc.get_enemy_team_number(entity)
      local entityPosition = objc.get_entity_position(entity)
      local enemiesToPull = objc.list_entities_in_radius(entity, PULL_RADIUS, enemyNumber)

      for _, enemy in pairs(enemiesToPull) do
         if gravityCommanderAbility3EffectEntity_validTargetCheck(enemy) then
            objc.move_entity_to_location_with_velocity(enemy, entityPosition[1], entityPosition[2], 400, 200)
         end
      end

      local enemiesToKill = objc.list_entities_in_radius(entity, KILL_RADIUS, enemyNumber)

      for _, enemy in pairs(enemiesToKill) do
         if gravityCommanderAbility3EffectEntity_validTargetCheck(enemy) then
            objc.kill_entity(enemy)
         end
      end
   end   
end


gravityCommanderAbility3EffectEntity_validTargetCheck = function(enemy)
   if objc.is_normal_unit(enemy) then
      return true
   end

   return false
end
