local EXPLOSION_DELAY_TIME = 10
local DELAY_TIMER_KEY = 'explosionDelayTimerKey'
local EXPLOSION_RADIUS = 600

gunshipBombScriptEntity_tickTrigger = function(entity)
	local delayTimer = objc.tick_timer(entity, DELAY_TIMER_KEY, EXPLOSION_DELAY_TIME)
	if delayTimer == 0 then
		local myPos = objc.get_entity_position(entity)
	    local playerNumber = objc.get_player_number(entity)
		objc.spawn_at_point('legionCommanderMechazorLandingEffect', 1, playerNumber, myPos[1], myPos[2], 0, 0)

		local enemyNumber = objc.get_enemy_team_number(entity)
		local enemiesInRange = objc.list_entities_in_radius(entity, EXPLOSION_RADIUS, enemyNumber)
		for _,enemy in pairs(enemiesInRange) do
			objc.inflict_normal_damage(entity, enemy, 1000)
			objc.flash_entity_for_damage(enemy, 250)
		end

		objc.kill_entity(entity)
	end
end
