local HALLUCINATIONT_DUMMY_UNIT = 'hallucinationDummyUnitKey'
local IDLE_ANIMATION_NAME = 'idleAnimationName'
local FRAMES_IN_SPAWN_ANIMATION = 30
local SPAWN_ANIMATION_NAME = 'W_Kuro_Hologram_Spawn_01'

local ANIMATION_SWITCH_TIMER = 'animationSwitchTimerKey'
local ANIMATION_SWITCH_DELAY = 9

hallucinationTauntUnit_spawnTrigger = function(entity)
    local numberOfSubrounds = objc.convert_frames_to_subrounds(FRAMES_IN_SPAWN_ANIMATION)
    objc.idle_entity(entity, numberOfSubrounds)
    objc.play_override_animation(entity, SPAWN_ANIMATION_NAME, numberOfSubrounds)
    objc.add_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'hallucinationTauntUnit.lua', 'hallucinationTauntUnit_switchIdleAnimationAfterDelay')
    
    objc.set_targetable(entity, false)
    objc.set_solid(entity, false)
end

hallucinationTauntUnit_tickTrigger = function(entity)
    local dummyUnit = objc.get_local_value(entity, HALLUCINATIONT_DUMMY_UNIT)
    local maxHealth = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_MAX_HEALTH)
    local currentDummyHealth = objc.get_entity_value_for_key(dummyUnit, ENTITY_VALUE_KEY_CURRENT_HEALTH)
    local maxDummyHealth = objc.get_entity_value_for_key(dummyUnit, ENTITY_VALUE_KEY_MAX_HEALTH)
    local currentDummyHealthPropTimes100 = objc.divide_with_floor(currentDummyHealth * 100, maxDummyHealth)
    local currentHealthTimes100 = maxHealth * currentDummyHealthPropTimes100
    local currentHealth = objc.divide_with_floor(currentHealthTimes100, 100)
    objc.set_entity_value_for_key(entity, ENTITY_VALUE_KEY_CURRENT_HEALTH, currentHealth)
end

hallucinationTauntUnit_switchIdleAnimationAfterDelay = function(entity)
    local animationSwitchTimer = objc.tick_timer(entity, ANIMATION_SWITCH_TIMER, ANIMATION_SWITCH_DELAY)
    if animationSwitchTimer == 0 then
        local idleAnimations = {}
        idleAnimations[ANIMATION_STATE_IDLE] = IDLE_ANIMATION_NAME
        objc.update_animation_state(entity, idleAnimations)
        objc.remove_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'hallucinationTauntUnit_switchIdleAnimationAfterDelay')
    end
end

hallucinationTauntUnit_canTargetTrigger = function(entity, targetEntity)
    return NO
end