local AFFECTED_ENTITIES_ARRAY_KEY = 'affectedEntitiesList'
local HAS_INIT_KEY = 'hasInitKey'
local GIVE_CRYSTAL_TRIGGER_NAME = 'giveCrystalOnDeath_deathTrigger'
local CRYSTAL_AMOUNT = 1

harvestScriptEntity_tickTrigger = function(entity)
    --We have to use this pattern as spawn triggers can't be applied to effectEntities
    local hasInit = objc.get_local_value(entity, HAS_INIT_KEY)

    if hasInit == 0 then
        local enemyNumber = objc.get_enemy_team_number(entity)
        local enemyEntities = objc.list_entities(enemyNumber)
        local affectedEntitiesArray = {}

        for _, enemy in pairs(enemyEntities) do
            if objc.is_normal_unit(enemy) then
                table.insert(affectedEntitiesArray, enemy)

                --Start blinking blue
                local blinkParams = {} 
                blinkParams['red'] = 100
                blinkParams['green'] = 50
                blinkParams['blue'] = 255
                blinkParams['alpha'] = 60
                blinkParams['initialBlinkFrequency'] = 30
                blinkParams['finalBlinkFrequency'] = 30
                blinkParams['initialBlinkIntensity'] = 16
                blinkParams['finalBlinkIntensity'] = 16
                blinkParams['animationDurationInDeciseconds'] = 0
                blinkParams['animationAcceleration'] = 50
                blinkParams['easingType'] = EASE_OUT
                objc.start_blinking(enemy, blinkParams)

                objc.play_vfx(enemy, 'Commander_ReflecStorm.lvl', 'node_origin')
                objc.play_vfx(enemy, 'Commander_ReflecClone.lvl', 'node_origin')

                --add death trigger to enemy units
                objc.add_trigger(enemy, TRIGGER_NAME_DEATH_TRIGGER, 'harvestScriptEntity.lua', GIVE_CRYSTAL_TRIGGER_NAME)
            end
        end

        objc.set_local_value(entity, AFFECTED_ENTITIES_ARRAY_KEY, affectedEntitiesArray)
        objc.set_local_value(entity, HAS_INIT_KEY, 1)
    end
end

harvestScriptEntity_deathTrigger = function(entity)
    local affectedEntitiesArray = objc.get_local_value(entity, AFFECTED_ENTITIES_ARRAY_KEY)

    if affectedEntitiesArray ~= 0 then
        for _, enemy in pairs(affectedEntitiesArray) do
            objc.remove_trigger(enemy, TRIGGER_NAME_DEATH_TRIGGER, GIVE_CRYSTAL_TRIGGER_NAME)
            objc.stop_blinking(enemy)
        end
    end
end

giveCrystalOnDeath_deathTrigger = function(entity)
    local enemyNumber = objc.get_enemy_team_number(entity)
    objc.add_crystal(enemyNumber, CRYSTAL_AMOUNT)
end
