local HAS_INIT = 'hasInitKey'
local INIT_TARGET = 'initTargetKey'
local MOVEMENT_SLOW_FACTOR = 50
local ATTACK_SPEED_DIVISOR = 0.5
local OLD_MOVE_SPEED = 'oldMoveSpeedKey'
local OLD_ATTACK_RATE = 'oldAttackRateKey'
local SLOW_SHADER_NAME = 'skinned_toon_freeze'

iceAcolyteTimingEntity_tickTrigger = function(entity)
	local hasInit = objc.get_local_value(entity, HAS_INIT)
	if hasInit == 0 then
		local initTarget = objc.get_local_value(entity, INIT_TARGET)
		if initTarget ~= 0 then
			local thisSpeed = objc.get_entity_value_for_key(initTarget, ENTITY_VALUE_KEY_MAX_VELOCITY)
    		local debuffSpeed = objc.divide_with_floor(MOVEMENT_SLOW_FACTOR * thisSpeed, 100)
			objc.set_entity_value_for_key(initTarget, ENTITY_VALUE_KEY_MAX_VELOCITY, thisSpeed - debuffSpeed)
			--print('INITIAL MOVE SPEED: '..thisSpeed)
			--print('DEBUFFED MOVE SPEED: '..thisSpeed - debuffSpeed)

			local attackSpeed = objc.get_entity_value_for_key(initTarget, ENTITY_VALUE_KEY_ATTACK_RATE)
    		local newAttackRate = objc.divide_with_floor(attackSpeed * 100, ATTACK_SPEED_DIVISOR * 100)
    		objc.set_entity_value_for_key(initTarget, ENTITY_VALUE_KEY_ATTACK_RATE, newAttackRate)
    		--print('INITIAL ATK SPEED: '..attackSpeed)
			--print('DEBUFFED ATK SPEED: '..newAttackRate)

			objc.set_local_value(entity, HAS_INIT, 1)
			objc.apply_shader(initTarget, SLOW_SHADER_NAME)
		end
	end
end

iceAcolyteTimingEntity_deathTrigger = function(entity)
	local initTarget = objc.get_local_value(entity, INIT_TARGET)
	if initTarget ~= 0 then
		local initTargetHealth = objc.get_entity_value_for_key(initTarget, ENTITY_VALUE_KEY_CURRENT_HEALTH)
		if initTargetHealth > 0 then
			local thisSpeed = objc.get_entity_value_for_key(initTarget, ENTITY_VALUE_KEY_MAX_VELOCITY)
    		local debuffSpeed = objc.divide_with_floor(thisSpeed * 100, MOVEMENT_SLOW_FACTOR)
			objc.set_entity_value_for_key(initTarget, ENTITY_VALUE_KEY_MAX_VELOCITY, debuffSpeed)
			--print('DEBUFFED MOVE SPEED: '..thisSpeed)
			--print('RESTORED MOVE SPEED: '..debuffSpeed)			

			local attackSpeed = objc.get_entity_value_for_key(initTarget, ENTITY_VALUE_KEY_ATTACK_RATE)
    		local newAttackRate = objc.divide_with_floor(attackSpeed * ATTACK_SPEED_DIVISOR * 100,100)
    		objc.set_entity_value_for_key(initTarget, ENTITY_VALUE_KEY_ATTACK_RATE, newAttackRate)
			--print('DEBUFFED ATK SPEED: '..attackSpeed)
			--print('RESTORED ATK SPEED: '..newAttackRate)	

			objc.remove_shader(initTarget, SLOW_SHADER_NAME)
		end
	end
end