local HAS_INIT = 'hasInitKey'
local SPAWN_TIME = 600
local SPAWN_TICK_TIMER = 'spawnTickTimerKey'
local BIG_HALLUCINATED_TITAN_UNIT_NAME = 'W_Hallucination'
local INITIAL_HALLUCINATION_POSITION = 3000
local ADDITIONAL_HALLUCINATION_OFFSET = 1000

illusionistPassiveScriptEntity_tickTrigger = function(entity)
	local spawnTimer = objc.tick_timer(entity, SPAWN_TICK_TIMER, SPAWN_TIME)
	local hasInit = objc.get_local_value(entity, HAS_INIT)
	if hasInit == 0 then
		spawnTimer = 0
		objc.set_local_value(entity, HAS_INIT, 1)
	end
	if spawnTimer == 0 then
		local teamNumber = objc.get_team_number(entity)
		local positionX = 0
		local facingX = 0

		if teamNumber == 1 then
			positionX = -INITIAL_HALLUCINATION_POSITION
			facingX = 1
		elseif teamNumber == 2 then
			positionX = INITIAL_HALLUCINATION_POSITION
			facingX = -1
		else
			objc.scripting_error('Encountered unknown player number ' .. teamNumber)
		end

		local allies = objc.list_entities(teamNumber)
		local hallucinationCount = 0

		for _, ally in pairs(allies) do
			if objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_IDENTIFIER) == BIG_HALLUCINATED_TITAN_UNIT_NAME then
				hallucinationCount = hallucinationCount + 1
			end
		end


	    local playerNumber = objc.get_player_number(entity)
		local hallucinationUnitArray = objc.spawn_at_point(BIG_HALLUCINATED_TITAN_UNIT_NAME, 1, playerNumber, positionX + (hallucinationCount * ADDITIONAL_HALLUCINATION_OFFSET * facingX), 0, facingX, 0)
		objc.play_vfx(hallucinationUnitArray[1], 'CommanderHallucination.lvl', 'root')
		objc.play_vfx(hallucinationUnitArray[1], 'CommanderHallucinationEnd.lvl', 'root')
		objc.play_vfx(hallucinationUnitArray[1], 'CommanderHallucinationDust.lvl', 'root')
		objc.play_vfx(hallucinationUnitArray[1], 'ComHalluArmStar.lvl', 'LeftFX')
		objc.play_vfx(hallucinationUnitArray[1], 'ComHalluArmStar.lvl', 'RightFX')
	end
end
