local FREEZE_RADIUS = 1000
local FREEZE_DURATION = 4000
local HAS_INIT = 'hasInit'

krakenMindControlAttackEntity_tickTrigger = function(entity)
    if objc.get_local_value(entity, HAS_INIT) == 0 then
        local teamNumber = objc.get_team_number(entity)
        local enemyNumber = objc.get_enemy_team_number(entity)
        local enemiesInRadius = objc.list_entities_in_radius(entity, FREEZE_RADIUS, enemyNumber)
        for _, enemy in pairs(enemiesInRadius) do
            if objc.is_normal_unit(enemy) then
                local thisId = objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_IDENTIFIER)
                local thisPosition = objc.get_entity_position(enemy)
                local currentHealth = objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_CURRENT_HEALTH)
                local maxHealth = objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_MAX_HEALTH)
                local damageToDo = maxHealth - currentHealth

                objc.teleport_entity(enemy, -10000, 0)
                objc.sacrifice_entity(enemy)

                local spawned = objc.spawn_at_point(thisId, 1, 2, thisPosition[1], thisPosition[2], -1, 0)
                objc.inflict_normal_damage(spawned[1], spawned[1], damageToDo)

                objc.play_vfx(spawned[1], 'imp_W_IceAcolyte.lvl', NODE_ORIGIN)
                objc.immobilize_entity(spawned[1], FREEZE_DURATION)
                objc.stun_entity(spawned[1], FREEZE_DURATION)
            end
        end
        objc.set_local_value(entity, HAS_INIT, 1)
    end
end
