local HAS_SPAWNED_KEY = 'hasSpawned'

--[[
This TickTrigger spawns instances of the most powerful factory unit identifier,
which is found by the kuroAbility3ScriptEntity.
--]]
kuroAbility3SpawnEffect_tickTrigger = function(entity)
   local teamNumber = objc.get_team_number(entity)
   local playerNumber = objc.get_player_number(entity)
   local duration = objc.tick_timer(entity, 'duration', 27)
   local spawnDelayTimer = objc.tick_timer(entity, 'spawnDelayTimer', 10)
   local hasSpawned = objc.get_local_value(entity, HAS_SPAWNED_KEY)
   local unitIdentifier = objc.get_global_value('mostPowerfulFactoryUnitIdentifier' .. teamNumber)

   if spawnDelayTimer == 0 and hasSpawned == 0 then
   		local entityPosition = objc.get_entity_position(entity)
   		local directionX = 0

   		if teamNumber == 1 then
	      	directionX = 1
	   	elseif teamNumber == 2 then
	      	directionX = -1
	   	else
      		objc.scripting_error('Encountered unknown player number ' .. teamNumber)
	   	end

		local spawnedEntityArray = objc.spawn_at_point(unitIdentifier, 1, playerNumber, entityPosition[1], entityPosition[2], directionX, 0)
		objc.set_entity_value(spawnedEntityArray[1], 'spawnComponent.holdPositionCountForSpawning', 0)

		objc.set_local_value(entity, HAS_SPAWNED_KEY, 1)
   end

   if duration == 0 then
      objc.kill_entity(entity)
   end

   return 0
end
