local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'

local LARGE_UNIT_STAT_MODIFIER = 2
local LARGE_UNIT_MOVEMENT_MODIFIER = 35
local NUM_SPLIT = 2
local BOSS_UNIT_BASE_IDENTIFIER = 'W_LongRangeTank'
local IS_ENLARGED = 'isEnlargedKey'
local LAST_ENLARGE_COUNTER = 'lastEnlargeCounterKey'
local ENLARGE_COUNT = 1

largeUnitsModifier_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            local isEnlarged = objc.get_local_value(unit, IS_ENLARGED)
            if objc.is_normal_unit(unit) and objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) ~= BOSS_UNIT_BASE_IDENTIFIER and isEnlarged == 0 then
                local lastEnlargeCounter = objc.get_local_value(entity, LAST_ENLARGE_COUNTER)
                if lastEnlargeCounter == ENLARGE_COUNT then
                    local currentHealth = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH)
                    local maxHealth = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH)
                    local attackDamage = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_DAMAGE)
                    local currentBuff = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF)
                    local buffToSet = math.ceil(attackDamage * LARGE_UNIT_STAT_MODIFIER) - attackDamage

                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, math.ceil(currentHealth * LARGE_UNIT_STAT_MODIFIER))
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, math.ceil(maxHealth * LARGE_UNIT_STAT_MODIFIER))
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, currentBuff + buffToSet)

                    local movementSpeed = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, movementSpeed - LARGE_UNIT_MOVEMENT_MODIFIER)

                    objc.set_entity_scale_percentage(unit, 150)
                    objc.set_local_value(entity, LAST_ENLARGE_COUNTER, 0)
                    objc.set_local_value(unit, IS_ENLARGED, 1)
                else
                    objc.set_local_value(entity, LAST_ENLARGE_COUNTER, lastEnlargeCounter + 1)
                    objc.set_local_value(unit, IS_ENLARGED, 1)
                end
            end
        end
    end
end