local CHECK_TICK = 5
local CHECK_KEY = 'checkKey'
local HAS_BEEN_SCALED = 'hasBeenScaledKey'
local SCALE_AMOUNT_NUMERATOR = 8
local SCALE_AMOUNT_DENOMINATOR = 7
local MAX_FUNCTION_VALUE = 32767

levelUpUnitsEntity_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            local description = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_DESCRIPTION)
            local hasBeenScaled = objc.get_local_value(unit, HAS_BEEN_SCALED .. description)
            local identifier = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER)
            if hasBeenScaled == 0 and (objc.is_normal_unit(unit) or (objc.is_boss_unit(unit) == 1)) then
                local currentHealth = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH)
                local maxHealth = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH)
                local attackDamage = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_DAMAGE)
                local attackBuff = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF)

                if currentHealth > MAX_FUNCTION_VALUE then
                    currentHealth = MAX_FUNCTION_VALUE
                end

                if maxHealth > MAX_FUNCTION_VALUE then
                    maxHealth = MAX_FUNCTION_VALUE
                end

                if attackDamage > MAX_FUNCTION_VALUE then
                    attackDamage = MAX_FUNCTION_VALUE
                end

                local damageToSet = (objc.divide_with_ceiling(attackDamage, SCALE_AMOUNT_DENOMINATOR) * SCALE_AMOUNT_NUMERATOR) - attackDamage

                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, objc.divide_with_ceiling(currentHealth, SCALE_AMOUNT_DENOMINATOR) * SCALE_AMOUNT_NUMERATOR)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, objc.divide_with_ceiling(maxHealth, SCALE_AMOUNT_DENOMINATOR) * SCALE_AMOUNT_NUMERATOR)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, attackBuff + damageToSet)

                objc.set_local_value(unit, HAS_BEEN_SCALED .. description, 1)
            end
        end
    end
end