local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'

local HAS_TRIGGER = 'hasTrigger'
local DAMAGE_ARRAY = {50, 55, 60, 65, 70, 75, 80, 85, 90, 95}

martyrModifier_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            local hasTrigger = objc.get_local_value(unit, HAS_TRIGGER)
            if objc.is_normal_unit(unit) and hasTrigger == 0 then
                objc.add_trigger(unit, TRIGGER_NAME_DEATH_TRIGGER, 'martyrModifier.lua', 'martyrModifier_explosionTrigger')
                objc.set_local_value(unit, HAS_TRIGGER, 1)
            end
        end
    end
end

martyrModifier_explosionTrigger = function(entity)
    local playerNumber = objc.get_player_number(entity)
    local tierOfMine = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_TIER)
    for _, ally in pairs(objc.list_entities_in_radius(entity, 1100, playerNumber)) do
        if objc.is_normal_unit(ally) then
            local healAmount = DAMAGE_ARRAY[tierOfMine+1]
            local currentHealth = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_CURRENT_HEALTH)
            local maxHealth = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_MAX_HEALTH)
            local healthToSet = currentHealth + healAmount
            if healthToSet > maxHealth then
                healthToSet = maxHealth
            end
            objc.set_entity_value_for_key(ally, ENTITY_VALUE_KEY_CURRENT_HEALTH, healthToSet)
        end
    end
    local entityPos = objc.get_entity_position(entity)
    objc.spawn_at_point('scoutFlierKillEntityGround', 1, 2, entityPos[1], entityPos[2], 0, 0)
    objc.play_vfx(entity, 'banezing_death_explosion.lvl', NODE_ORIGIN)
end
