local MINE_IDENTIFIER = 'R_Minefield'
local MAX_MINES = 2
local CURRENT_NUM_MINES = 'currentNumMinesKey'
local IS_SPAWNED_MINE = 'isSpawnedMine'
local MINE_SPACING = 6
local HAS_INIT = 'hasInit'
local OFFSET_X = -500
local OFFSET_Y = 250

minefieldEffectEntity_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        minefieldEffectEntity_spawnMine(entity)
        objc.set_local_value(entity, HAS_INIT, 1)
    end

    local spawnTimer = objc.tick_timer(entity, 'idleTimerKey', MINE_SPACING)
    if spawnTimer == 0 then
        local numMines = objc.get_local_value(entity, CURRENT_NUM_MINES)
        if numMines < MAX_MINES then
            minefieldEffectEntity_spawnMine(entity)
        end
    end
end

minefieldEffectEntity_spawnMine = function(entity)
    local playerNumber = objc.get_player_number(entity)
    local entityPos = objc.get_entity_position(entity)
    local numMines = objc.get_local_value(entity, CURRENT_NUM_MINES)

    local tier = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_TIER)
    if tier == 0 then
        tier = ''
    end
    local xDir = numMines % 2
    if xDir == 0 then
        xDir = -1
    end
    local spawnedMine = objc.spawn_at_point(MINE_IDENTIFIER .. tier, 1, playerNumber, entityPos[1] + OFFSET_X, entityPos[2] + (OFFSET_Y * xDir), 1, 0)
    objc.set_local_value(spawnedMine[1], IS_SPAWNED_MINE, 1)

    objc.set_local_value(entity, CURRENT_NUM_MINES, numMines + 1)
end
