local MISSILE_CHECK_INTERVAL = 10
local FIRE_MISSILES_TIMER_KEY = 'fireMissileTimerKey'
local HAS_FIRED_MISSILE = 'hasFiredMissile'
local MISSILE_TARGET = 'missileTargetKey'

local ANTI_AIR_IDENTIFIER = 'R_AliciaAntiAirSeekerMissile'

mod_AliciaAntiAir_tickTrigger = function(entity)
    local activateTimer = objc.tick_timer(entity, FIRE_MISSILES_TIMER_KEY, MISSILE_CHECK_INTERVAL)
    if activateTimer == 0 then
        local team1Entities = objc.list_entities(1)
        for _,unit in pairs(team1Entities) do
            local hasFired = objc.get_local_value(unit, HAS_FIRED_MISSILE)
            if objc.is_air_unit(unit) and hasFired == 0 then
                local spawned = objc.spawn_at_point(ANTI_AIR_IDENTIFIER, 1, 2, 5500, 0, -1, 0)
                objc.set_local_value(spawned[1], MISSILE_TARGET, unit)
                objc.set_local_value(unit, HAS_FIRED_MISSILE, 1)
            end
        end
    end
end