local LIFESTEAL_INIT = 'lifestealInit'

local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'

local UNIT_LUA = 'mod_BossLeveler.lua'
local HEALTH_GAIN_AMOUNT_PROP = 20

mod_BossLeveler_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            local hasInit = objc.get_local_value(unit, LIFESTEAL_INIT)
            local isBoss = objc.is_boss_unit(unit)
            if objc.is_boss_unit(unit) and hasInit == 0 then
                objc.add_trigger(unit, TRIGGER_NAME_ON_KILL_TRIGGER, UNIT_LUA, 'level_trigger')
                local unitApplied = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER)
                objc.set_local_value(unit, LIFESTEAL_INIT, 1)
            end
        end
    end
end

level_trigger = function(killedEntity, killerEntity)
    local maxHealth = objc.get_entity_value_for_key(killerEntity, ENTITY_VALUE_KEY_MAX_HEALTH)
    local currentHealth = objc.get_entity_value_for_key(killerEntity, ENTITY_VALUE_KEY_CURRENT_HEALTH)
    local healthGain = objc.divide_with_ceiling(maxHealth, HEALTH_GAIN_AMOUNT_PROP)

    currentHealth = currentHealth + healthGain
    if currentHealth > maxHealth then
        currentHealth = maxHealth
    end
    
    objc.set_entity_value_for_key(killerEntity, ENTITY_VALUE_KEY_CURRENT_HEALTH, currentHealth)
end