local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'

local HAS_TRIGGER = 'hasTrigger'
local ENTITY_TO_SPAWN = 'W_KyrieCultling'
local SHOULD_NOT_SPAWN_CULTLING = 'shouldSpawnCultling'

mod_KyrieCultling_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            local hasTrigger = objc.get_local_value(unit, HAS_TRIGGER)
            if objc.is_normal_unit(unit) and hasTrigger == 0 then
                -- Don't put this on other cultists
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) ~= 'W_KyrieCultist' and objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) ~= 'W_KyrieCultling' then
                    objc.add_trigger(unit, TRIGGER_NAME_DEATH_TRIGGER, 'mod_KyrieCultling.lua', 'mod_KyrieCultling_summonTrigger')
                    objc.set_local_value(unit, HAS_TRIGGER, 1)
                end
            end
        end
    end
end

mod_KyrieCultling_summonTrigger = function(entity)
    local playerNumber = objc.get_enemy_team_number(entity)
    local identifier = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_IDENTIFIER)
    local shouldNotSpawn = objc.get_local_value(entity, SHOULD_NOT_SPAWN_CULTLING)
    if identifier ~= ENTITY_TO_SPAWN and shouldNotSpawn == 0 then
        local entityPos = objc.get_entity_position(entity)
        objc.spawn_at_point(ENTITY_TO_SPAWN, 1, 2, entityPos[1], entityPos[2], 0, 0)
    end
end