local LIFESTEAL_INIT = 'lifestealInit'

local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'

local UNIT_LUA = 'mod_Lifesteal.lua'
local LIFESTEAL_PROP = 4 --lifesteals 1/x * damage, where x is this number

mod_Lifesteal_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            local hasInit = objc.get_local_value(unit, LIFESTEAL_INIT)
            if objc.is_normal_unit(unit) and hasInit == 0 then
                objc.add_trigger(unit, TRIGGER_NAME_ON_ATTACK_TRIGGER, UNIT_LUA, 'lifesteal_trigger')
                local unitApplied = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER)
                objc.set_local_value(unit, LIFESTEAL_INIT, 1)
            end
        end
    end
end

lifesteal_trigger = function(sourceEntity, targetEntity)
    local damage = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_ATTACK_DAMAGE) + objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_DAMAGE_BUFF)
    local lifeStolen = objc.divide_with_ceiling(damage, LIFESTEAL_PROP)
    local newHP = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_CURRENT_HEALTH) + lifeStolen
    local maxHP = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_MAX_HEALTH)
    if newHP > maxHP then
        newHP = maxHP
    end
    objc.set_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_CURRENT_HEALTH, newHP)
end