local SHRINK_TECH_3_INIT = 'shrinkTech3Init'

local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'

local VISUALIZATION_ENTITY = 'mod_ShrinkTech3Visualization'

mod_ShrinkTech3_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team1Entities = objc.list_entities(1)
        for _,unit in pairs(team1Entities) do
            local hasInit = objc.get_local_value(unit, SHRINK_TECH_3_INIT)
            if objc.is_normal_unit(unit) and hasInit == 0 then
                local baseIdentifier = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER)
                -- This is for prototyping, we absolutely need a way to get the tech tier of a unit in lua
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_REQUIRED_RESEARCH) > 1 then
                    objc.spawn_at_entity(VISUALIZATION_ENTITY, 1, unit)

                    objc.set_entity_scale_percentage(unit, 50)

                    local newMaxHP = objc.divide_with_ceiling(objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH), 2)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, newMaxHP)
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, newMaxHP)

                    objc.set_local_value(unit, SHRINK_TECH_3_INIT, 1)
                end
            end
        end
    end
end