local FAST_UNIT_INIT = 'fastUnitInit'

local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'

local UNIT_LUA = 'mod_BossLeveler.lua'
local SPEED_INCREASE = 37

local ATTACK_SPEED_INCREASE_DEN = 2
local ATTACK_SPEED_INCREASE_NUM = 1

mod_fastUnits_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            local hasInit = objc.get_local_value(unit, FAST_UNIT_INIT)
            if objc.is_normal_unit(unit) and hasInit == 0 then
                local currentSpeed = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, currentSpeed + SPEED_INCREASE)

                local identifier = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER)
                if identifier == 'W_KyrieCultist' or identifier == 'W_KyrieCultling' then
                    local currentAttackRate = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_RATE)
                    local newRate = objc.divide_with_ceiling(currentAttackRate, ATTACK_SPEED_INCREASE_DEN) * ATTACK_SPEED_INCREASE_NUM
                    objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_RATE, newRate)
                end

                objc.set_local_value(unit, FAST_UNIT_INIT, 1)
            end
        end
    end
end