local FREEZE_LONG_RANGE_INIT = 'freezeLongRangeInit'

local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'

local FREEZE_DURATION = 4000
local RANGE_CUTOFF = 2500 --This captures range 4 and 5
local FREEZE_SHADER_NAME = 'skinned_toon_freeze'
local SHADER_COUNT_DOWN_TIME = 'shaderCountDownTimeKey'
local SHADER_TIMER_COUNT = 'shaderTimerCountKey'

mod_freezeLongRange_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team1Entities = objc.list_entities(1)
        for _,unit in pairs(team1Entities) do
            local hasInit = objc.get_local_value(unit, FREEZE_LONG_RANGE_INIT)
            if objc.is_normal_unit(unit) and hasInit == 0 then
                local attackRange = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_RANGE)
                if attackRange > RANGE_CUTOFF then
                    objc.play_vfx(unit, 'imp_W_IceAcolyte.lvl', NODE_ORIGIN)
                    objc.set_local_value(unit, SHADER_COUNT_DOWN_TIME, objc.divide_with_floor(freeze_duration, 100))
                    objc.apply_shader(unit, FREEZE_SHADER_NAME)
                    objc.add_trigger(unit, TRIGGER_NAME_TICK_TRIGGER, 'mod_freezeLongRange.lua', 'mod_freezeLongRange_countDownShaderTrigger')
                    objc.immobilize_entity(unit, FREEZE_DURATION)
                    objc.stun_entity(unit, FREEZE_DURATION)
                    objc.set_local_value(unit, FREEZE_LONG_RANGE_INIT, 1)
                end
            end
        end
    end
end

mod_freezeLongRange_countDownShaderTrigger = function(entity)
   local shaderCountDown = objc.get_local_value(entity, SHADER_COUNT_DOWN_TIME)
   local shaderCount = objc.tick_timer(entity, SHADER_TIMER_COUNT, shaderCountDown)
    objc.play_vfx(entity, 'imp_W_IceAcolyte.lvl', NODE_ORIGIN)
   if shaderCount == 0 then
      objc.remove_shader(entity, FREEZE_SHADER_NAME)
      objc.remove_trigger(entity, TRIGGER_NAME_TICK_TRIGGER, 'mod_freezeLongRange_countDownShaderTrigger')
   end
end