local SPELL_IMMUNE_INIT = 'spellImmuneInit'
local SPELL_IMMUNE_EFFECT = 'W_Kyrie_SpellImmunity.lvl'

local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'

local UNIT_LUA = 'mod_BossLeveler.lua'
local SPEED_INCREASE = 37

local ATTACK_SPEED_INCREASE_DEN = 2
local ATTACK_SPEED_INCREASE_NUM = 1

mod_spellImmuneCultist_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            local hasInit = objc.get_local_value(unit, SPELL_IMMUNE_INIT)
            local identifier = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER)
            if (identifier == 'W_KyrieCultist' or identifier == 'W_KyrieCultling') and hasInit == 0 then
                objc.add_trigger(unit, TRIGGER_NAME_ON_DAMAGE_TRIGGER, 'mode_spellImmuneCultist.lua', 'mod_immuneSpellDamageTrigger')
                objc.play_vfx(unit, SPELL_IMMUNE_EFFECT, NODE_ORIGIN)
                objc.set_local_value(unit, SPELL_IMMUNE_INIT, 1)
            end
        end
    end
end

mod_immuneSpellDamageTrigger = function(damage, targetEntity, sourceEntity)
    local sourceIdentifier = objc.get_entity_value_for_key(sourceEntity, ENTITY_VALUE_KEY_IDENTIFIER)
    if sourceIdentifier == 'fogEffectEntity' or sourceIdentifier == 'B_Shock' or sourceIdentifier == 'R_SingleSeekerMissile' then
        return 0
    end

    return damage
end