local HAS_INIT = 'hasInitKey'
local LARGE_ROCK_ENTITY = 'rockEntityLargeVisual'

local OBJECTIVE_SPAWN_TIME_ACTUAL = 'objectiveSpawnTimeActualKey'
local INITIAL_OBJECTIVE_SPAWN_TIME = 10
local OBJECTIVE_SPAWN_TIME_RANDOMNESS = 0
local HAS_SPAWNED_OBEJCTIVE = 'hasSpawnedObjectiveKey'
local OBJECTIVE_BOSS_ID = 'N_ObjectiveBoss'

objectiveMap_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        local objectiveSpawnRandomness = objc.roll_number(-OBJECTIVE_SPAWN_TIME_RANDOMNESS, OBJECTIVE_SPAWN_TIME_RANDOMNESS)
        objc.set_local_value(entity, OBJECTIVE_SPAWN_TIME_ACTUAL, objectiveSpawnRandomness + INITIAL_OBJECTIVE_SPAWN_TIME)
        objc.spawn('gameRulesEntity', 1, 1)
        objc.spawn_at_point(LARGE_ROCK_ENTITY, 1, 0, 0, 2250, 0, 0)
        objc.spawn_at_point(LARGE_ROCK_ENTITY, 1, 0, 0, -2250, 0, 0)
        objc.spawn_at_point(LARGE_ROCK_ENTITY, 1, 0, 1000, 2250, 0, 0)
        objc.spawn_at_point(LARGE_ROCK_ENTITY, 1, 0, 1000, -2250, 0, 0)
        objc.spawn_at_point(LARGE_ROCK_ENTITY, 1, 0, -1000, 2250, 0, 0)
        objc.spawn_at_point(LARGE_ROCK_ENTITY, 1, 0, -1000, -2250, 0, 0)
        objc.set_local_value(entity, HAS_INIT, 1)
    end

    local hasSpawnedObjective = objc.get_local_value(entity, HAS_SPAWNED_OBEJCTIVE)
    if hasSpawnedObjective == 0 then
        local objectiveSpawnRounds = objc.get_local_value(entity, OBJECTIVE_SPAWN_TIME_ACTUAL)
        local objectiveSpawnTime = objc.tick_timer(entity, 'initialObjectiveSpawnTimerKey', objectiveSpawnRounds)
        if objectiveSpawnTime == 0 then
            objc.spawn_at_point(OBJECTIVE_BOSS_ID, 1, 1, -1000, -3450, 0, 1)
            objc.spawn_at_point(OBJECTIVE_BOSS_ID, 1, 2, 1000, 3250, 0, -1)
            objc.set_local_value(entity, HAS_SPAWNED_OBEJCTIVE, 1)
        end
    end
end