#define SUPPORT_GLSL300
#include "prefix.sh"

#include "framework/framework.sh"
#include "framework/transforms.sh"
#include "framework/skinning.sh"

uniform vec3 u_cc3CameraPositionGlobal;

uniform struct
{
    vec4 TeamColor;
    float OutlineScale;
} perentity;

////////////////////////////////////////////////////////////////////////////////////////////////////

vec3 doVertPushBorders(vec3 position, vec3 normal, float object_scale, vec3 cameraPosition) {
    float border_width = 0.005;
    float dist = distance(cameraPosition, position.xyz);     // DavidJ -- precalculate this once per object!
    position.xyz += normal * (border_width * dist * object_scale);
    return position;
}

void vsMain(out VSOUT vsout, VSIN vsin) {
    vec3 modelSpaceP;
    RawTangentFrame modelSpaceTF;
    getModelSpace(modelSpaceP, modelSpaceTF, vsin);
    float scale = perentity.OutlineScale;
    modelSpaceP = doVertPushBorders(modelSpaceP, getNormal(vsin), scale, u_cc3CameraPositionGlobal);
    vsout._position = transformPoint(getModelToProj(), modelSpaceP);
}

#include "framework/glsles/framework_glsles.vert"
