#define SUPPORT_GLSL300
#include "prefix.sh"

#if VS_OUT_S_COLOR > 0
    VARYING_IN vec4 v_color[VS_OUT_S_COLOR];
#endif

#if VS_OUT_S_TEXCOORD > 0
    VARYING_IN vec2 v_texCoord[VS_OUT_S_TEXCOORD];
#endif

#if defined(TEXT_RENDER)
    uniform sampler2D s_cc3Texture2Ds[1];
#endif

void main() {
    vec4 baseColor = vec4(1,1,1,1);
    #if VS_OUT_S_COLOR > 0
        baseColor = v_color[0];
    #endif
    
    #if defined(TEXT_RENDER)
        float a = texture2D(s_cc3Texture2Ds[0], v_texCoord[0]).a;
        if (a < 1.0 / 255.0) discard;
        gl_FragColor = baseColor * vec4(1, 1, 1, a);
    #else
        gl_FragColor = baseColor;
    #endif
}


