
uniform vec2 ParticleGrayDistortion_scrollDirection;
uniform float ParticleGrayDistortion_distortionIntensity;
uniform float ParticleGrayDistortion_distortionFrequency;
uniform float ParticleGrayDistortion_maskDistortion;
uniform vec2 ParticleGrayDistortion_noTileDiffuse;

vec4 ComputePixelColor() {
    vec2 scrolling_uv = v_texCoord * ParticleGrayDistortion_distortionFrequency + ParticleGrayDistortion_scrollDirection * v_time.y;
    vec4 scrolling_texel = texture2D(un_diffuseMap, scrolling_uv);
    if (ParticleGrayDistortion_maskDistortion > 0.5) {
        scrolling_texel.rgb = mix(vec3(0.5), scrolling_texel.rgb, scrolling_texel.a);
    }

    vec2 offset = 2.0 * scrolling_texel.yz - 1.0;
    vec2 distorted_uv = v_texCoord + offset * ParticleGrayDistortion_distortionIntensity;
    distorted_uv = mix(distorted_uv, clamp(distorted_uv, 0.0, 1.0), ParticleGrayDistortion_noTileDiffuse);
    vec4 distorted_texel = texture2D(un_diffuseMap, distorted_uv);

    return vec4(vec3(distorted_texel.r), distorted_texel.a);
}
