
#define SUPPORT_GLSL300
#include "prefix_tow.sh"

#if defined(GL_ES)
    precision highp float;
#endif

#if __VERSION__ >= 300
    out vec4 primaryOutput;
    #define gl_FragColor primaryOutput
#endif

uniform sampler2D s_refractionNoiseMap;
uniform vec2 u_cc3SceneTime;

VARYING_IN vec2 v_texCoord;
VARYING_IN vec3 v_N;

void main() {
    vec4 texelVector = texture2D(s_refractionNoiseMap, v_texCoord + u_cc3SceneTime.xx * vec2(0.0, 0.04));
    vec4 texelMask = texture2D(s_refractionNoiseMap, v_texCoord);
    gl_FragColor = vec4(texelVector.xy, texelMask.w, 1);
}
