//#define PROGRAMMABLE_BLENDING

#if 0
    #undef GEO_HAS_24afdad79e720a67
    #undef GEO_HAS_24afdad79e720a66
    #undef GEO_HAS_daaaccb00ad39ac3
    #undef GEO_HAS_daaaccb00ad39ac2
    #undef MANTIS_PBR
    #undef SHADOWS_DYNAMIC_ENABLE
#endif

#if !defined(PREFIX_SHADER)
#define PREFIX_SHADER


#if !defined(METAL_INSTEAD_OF_OPENGL)

// Supporting GLSL
#define packed_float3 float3
#define inout_VSOUT     inout VSOUT
#define out_float       out float
#define out_float2      out float2
#define out_float3      out float3
#define out_float4      out float4
#define inout_float     inout float
#define inout_float2    inout float2
#define inout_float3    inout float3
#define inout_float4    inout float4
#define FRAGMENT_FUNCTION_BEGIN
#define FRAGMENT_FUNCTION_END       return;


#if defined(GL_EXT_shader_texture_lod)
    #extension GL_EXT_shader_texture_lod : enable
#endif

#if defined(PROGRAMMABLE_BLENDING) && defined(GL_EXT_shader_framebuffer_fetch)
    #extension GL_EXT_shader_framebuffer_fetch : require
#endif

#if !defined(GL_ES)
    // hack for compiling using older glsl specs, and non-ES versions
    #define precision
    #define highp
    #define lowp
    #define mediump
#endif

precision highp float;

#if __VERSION__ >= 300
    #define ATTRIBUTE in
    #define VARYING_IN in
    #define VARYING_OUT out
    #define texture2D texture

    #if defined(FRAGMENT_SHADER)
        // This is blocked by PROGRAMMABLE_BLENDING so that we do not unnecessarily read framebuffer data
        #if defined(PROGRAMMABLE_BLENDING) && defined(GL_EXT_shader_framebuffer_fetch)
            layout(location = 0) inout vec4 destColor; // declared inout, the variable will contain framebuffer data
        #else
            layout(location = 0) out vec4 destColor;
        #endif
        #define gl_FragColor destColor
    #endif
#else
    #define ATTRIBUTE attribute
    #define VARYING_IN varying
    #define VARYING_OUT varying
#endif

#endif

// a_cc3Position =      ff39bb3d0f0e27f6
// a_cc3Color =         24afdad79e720a66
// a_cc3TexCoord =      daaaccb00ad39ac2
// a_cc3Radius =        ae116fad022c18d4
// a_cc3Tangent =       c0688456dc4a419e
// a_cc3Bitangent =     104be7c4fa9c3a1b
// a_cc3Normal =        4ef36e9357d0dde4

#if defined(GEO_HAS_ff39bb3d0f0e27f6)
    #define VS_IN_S_POSITION 1
#else
    #define VS_IN_S_POSITION 0
#endif

#if defined(GEO_HAS_24afdad79e720a67)
    #define VS_IN_S_COLOR 2
    #define VS_OUT_S_COLOR 2
#elif defined(GEO_HAS_24afdad79e720a66)
    #define VS_IN_S_COLOR 1
    #define VS_OUT_S_COLOR 1
#else
    #define VS_IN_S_COLOR 0
    #define VS_OUT_S_COLOR 0
#endif

#if defined(GEO_HAS_daaaccb00ad39ac3)
    #define VS_IN_S_TEXCOORD 2
    #define VS_OUT_S_TEXCOORD 2
#elif defined(GEO_HAS_daaaccb00ad39ac2)
    #define VS_IN_S_TEXCOORD 1
    #define VS_OUT_S_TEXCOORD 1
#else
    #define VS_IN_S_TEXCOORD 0
    #define VS_OUT_S_TEXCOORD 0
#endif

#define TANGENT_FRAME_NORMAL    1       // (just normal, no tangent or bitangent)
#define TANGENT_FRAME_FULL      2       // (3d vectors for normal, tangent, bitangent)
#define TANGENT_FRAME_NT        3       // (normal & tangent, with handiness flag for bitangent)
#define TANGENT_FRAME_TB        4       // (tangent & bitangent, with handiness flag for normal)

#if defined(GEO_HAS_c0688456dc4a419e)
    #define VS_IN_S_TANGENT_FRAME TANGENT_FRAME_NT
    #define VS_OUT_S_TANGENT_FRAME TANGENT_FRAME_FULL
#elif defined(GEO_HAS_4ef36e9357d0dde4)
    #define VS_IN_S_TANGENT_FRAME TANGENT_FRAME_NORMAL
    #define VS_OUT_S_TANGENT_FRAME TANGENT_FRAME_NORMAL
#else
    #define VS_IN_S_TANGENT_FRAME 0
    #define VS_OUT_S_TANGENT_FRAME 0
#endif

#endif
