local RAGE_RADIUS = 800
local ATTACK_SPEED_INCREASE_FACTOR = 2
local ALLY_CHECK_INTERVAL = 3
local ALLY_CHECK_TIMER_KEY = 'rageAllyCheckTimerKey'
local BUFFED_ALLIES_ARRAY = 'buffedAlliesArrayKey'
local HAS_BEEN_RAGED = 'hasBeenRageBuffed'

rageEffectEntity_tickTrigger = function(entity)
    local allyCheckTimer = objc.tick_timer(entity, ALLY_CHECK_TIMER_KEY, ALLY_CHECK_INTERVAL)
    if allyCheckTimer == 0 then
        local teamNumber = objc.get_team_number(entity)
        local buffedUnits = objc.get_local_value(entity, BUFFED_ALLIES_ARRAY)
        if buffedUnits == 0 then
            buffedUnits = {}
        end

        local allies = objc.list_entities_in_radius(entity, RAGE_RADIUS, teamNumber)
        for _, ally in pairs(allies) do
            local hasBeenRageBuffed = objc.get_local_value(ally, HAS_BEEN_RAGED)
            if hasBeenRageBuffed == 0 then
                local allyAttackSpeed = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_ATTACK_RATE)
                local attackSpeedToSet = objc.divide_with_floor(allyAttackSpeed, ATTACK_SPEED_INCREASE_FACTOR)
                objc.set_entity_value_for_key(ally, ENTITY_VALUE_KEY_ATTACK_RATE, attackSpeedToSet)
                table.insert(buffedUnits, ally)
                objc.set_local_value(ally, HAS_BEEN_RAGED, 1)
            end
        end
        objc.set_local_value(entity, BUFFED_ALLIES_ARRAY, buffedUnits)
    end
end

rageEffectEntity_deathTrigger = function(entity)
    local buffedUnits = objc.get_local_value(entity, BUFFED_ALLIES_ARRAY)
    if buffedUnits ~= 0 then
        for _,buffed in pairs(buffedUnits) do
            local hasBeenRageBuffed = objc.get_local_value(buffed, HAS_BEEN_RAGED)
            if hasBeenRageBuffed == 1 then
                local allyAttackSpeed = objc.get_entity_value_for_key(buffed, ENTITY_VALUE_KEY_ATTACK_RATE)
                local attackSpeedToSet = allyAttackSpeed * ATTACK_SPEED_INCREASE_FACTOR
                objc.set_entity_value_for_key(buffed, ENTITY_VALUE_KEY_ATTACK_RATE, attackSpeedToSet)
                objc.set_local_value(buffed, HAS_BEEN_RAGED, 0)
            end
        end
    end
end