
#if !defined(SHADOW_VERT_SHADER)
#define SHADOW_VERT_SHADER

// Note --
//      SHADOWS_ENABLED tends to get set on a global basis
//      but SHADOWS_DISABLED is defined per-material
#if defined(SHADOWS_ENABLED) && !defined(SHADOWS_DISABLED) && !defined(SHADOW_GEN)
    #define VSOUT_SHADOW_COORD
#endif

#if defined(VSOUT_SHADOW_COORD)
    #include "shadow_uniforms.sh"
    VARYING_OUT vec4 v_shadow;
#endif

void shadow_receive(vec4 position_world)
{
    #if defined(VSOUT_SHADOW_COORD)
        const mat4 biasMatrix = mat4(
            0.5, 0.0, 0.0, 0.0,
            0.0, 0.5, 0.0, 0.0,
            0.0, 0.0, 0.5, 0.0,
            0.5, 0.5, 0.5, 1.0
        );
        v_shadow = biasMatrix * GetShadowLightVP() * vec4(position_world.xyz, 1.0);
        v_shadow.z -= GetShadowZThreshold();
    #endif
}

#endif // SHADOW_VERT_SHADER
