#if !defined(REPEAT_H)
#define REPEAT_H

// Some android devices don't compile for loops correctly, so
// this workarounds that bug by using a switch statement instead
#if CC3_PLATFORM_ANDROID
    #define BAD_FOR_LOOPS 1
#else // CC3_PLATFORM_ANDROID
    #define BAD_FOR_LOOPS 0
#endif // CC3_PLATFORM_ANDROID

#if BAD_FOR_LOOPS

#define FOR(VAR, START, END, BODY) { VAR = START; switch (END) { \
    case 9: \
        BODY; \
        ++ VAR; \
    case 8: \
        BODY; \
        ++ VAR; \
    case 7: \
        BODY; \
        ++ VAR; \
    case 6: \
        BODY; \
        ++ VAR; \
    case 5: \
        BODY; \
        ++ VAR; \
    case 4: \
        BODY; \
        ++ VAR; \
    case 3: \
        BODY; \
        ++ VAR; \
    case 2: \
        BODY; \
        ++ VAR; \
    case 1: \
        BODY; \
        ++ VAR; \
    default: \
        break; \
}}

#else // BAD_FOR_LOOPS

#define FOR(VAR, START, END, BODY) for (VAR = START; VAR < END; ++ VAR) { BODY; }

#endif // BAD_FOR_LOOPS

#endif // REPEAT_H
