local HAS_INIT = 'hasInitKey'
local HAS_FIRED_KEY = 'hasFired'
local DUMMY_ENTITY_ID = 'RoxieAbilityDummyEntity'
local DAMAGE_AMOUNT = {1000, 1130, 1277, 1443, 1630, 1842}
local DAMAGE_TARGET = 'damageTargetKey'
local SOURCE_SPELL_TIER = 'sourceSpellTierKey'
local DAMAGE_DELAY = 12

--[[
This TickTrigger waits a given amount of time, and then damages all ground
units within a given radius of it.
--]]
seekerMissileEffectEntity_tickTrigger = function(entity)
   local hasInit = objc.get_local_value(entity, HAS_INIT)
   if hasInit == 0 then
      local damageTarget = objc.get_local_value(entity, DAMAGE_TARGET)
      if damageTarget ~= 0 then
         objc.play_vfx(damageTarget, 'commanderArrowRainDown4.lvl', NODE_ORIGIN)
      end

      local sourceSpellTier = objc.get_local_value(entity, SOURCE_SPELL_TIER)
      objc.set_local_value(entity, HAS_INIT, 1)
   end

   local playerNumber = objc.get_player_number(entity)
   local sourceSpellTier = objc.get_local_value(entity, SOURCE_SPELL_TIER)
   local fireArrowDamage = DAMAGE_AMOUNT[1]

   local hasFired = objc.get_local_value(entity, HAS_FIRED_KEY)
   local damageDelay = objc.tick_timer(entity, 'damageDelay', DAMAGE_DELAY)
   -- duration is long enough so that the effect can play out before being killed
   local duration = objc.tick_timer(entity, 'duration', 100)

   if hasFired == 0 and damageDelay == 0 then
      local dummyEntity = objc.spawn(DUMMY_ENTITY_ID, 1, playerNumber)
      local damageTarget = objc.get_local_value(entity, DAMAGE_TARGET)
      if damageTarget ~= 0 then
         objc.inflict_normal_damage(dummyEntity[1], damageTarget, fireArrowDamage)
      end

      objc.sacrifice_entity(dummyEntity[1])
      objc.set_local_value(entity, HAS_FIRED_KEY, 1)
   end

   if duration == 0 then
      objc.sacrifice_entity(entity)
   end
end
