#if !defined(SHADER_FEATURES)
    //===================================================================================================================//
    // SHADER FEATURES //
    //===================================================================================================================//

    //skinning
    #if defined(USE_SKINNING)
        #define A_SKINNING 1
        #define C_SKINNING 1
        #define U_SKINNING 1
    #endif

    #if !defined(SHADOW_GEN)
        //instancing
        #if defined(INSTANCING_ENABLED)
            #define VS_DIFFUSE_COLOR 1
        #endif

        //vertex colors
        #if defined(USE_VERTEX_COLOR)
            #define A_VERTEX_COLOR 1
            #define VS_VERTEX_COLOR 1
        #endif

        //normal maps
        #if defined(USE_NORMAL_MAP)
            #define A_TANGENTS 1
            #define VS_TANGENTS 1
            #define S_NORMAL_MAP 1
        #endif

        //world directional lighting
        #if defined(USE_WORLD_LIGHTING)
            #define U_WORLD_LIGHT_DIR 1
            #define U_WORLD_LIGHT_COLOR 1
            #define VS_WORLD_LIGHTING 1
        #endif

        //fixed world directional lighting
        #if defined(USE_FIXEDWORLD_LIGHTING)
            #define VS_FIXEDWORLD_LIGHTING 1
        #endif


        //legacy world normalmap lighting - to mimic ocean lighting
        #if defined(USE_LEGACY_WORLD_LIGHTING)
            #undef USE_WORLD_LIGHTING
        #endif

        //default directional lighting 
        #if defined(USE_DEFAULT_LIGHTING)
            #define U_DEFAULT_LIGHT_DIR 1
            #define U_WORLD_LIGHT_COLOR 1
        #endif

        //second uv set
        #if defined(USE_UV1)
            #define A_UV1 1
            #define VS_UV1 1
        #endif

        //sphere coords
        #if defined(USE_SPHERE_COORD)
            #define U_REFL_VALUE 1
        #endif

        //reflection vector for spec/reflections
        #if defined(USE_REFLECT)
            #define VS_WORLD_POSITION 1
            #define VS_WORLD_NORMAL 1
        #endif

        //spec 
        #if defined(USE_SPEC)
            #define U_SPEC 1
        #endif

        //default spec
        #if defined(USE_DEFAULT_SPEC)
            #define U_DEFAULT_SPEC_LIGHT 1
            #define U_SPEC_SETTINGS 1
        #endif

        //use default env map reflection 
        #if defined(USE_DEFAULT_ENV_MAP)
            #define U_REFL_COLOR 1
        #endif

        //texture fresnel 
        #if defined(USE_FRESNEL)

        #endif

        //fresnel lighting
        #if defined(USE_MATERIAL_FRESNEL)
            #define U_FRESNEL_LIGHT_COLOR 1
        #endif

        //material alpha - red channel (0) by default
        #if defined(USE_MATERIAL_ALPHA)
            #if !defined(M_ALPHA_CHANNEL)
                #define M_ALPHA_CHANNEL 0
            #endif
            #define U_ALPHA_MULTIPLY 1
        #endif

        //full material alpha fade - post fog
        #if defined(USE_ALPHAFADE)
            #define U_ALPHAFADE 1
        #endif

        //loading fade
        #if defined(USE_LOADING_FADE)
            #define U_LOADING_FADE 1
        #endif

        //fade color
        #if defined(USE_FADE_COLOR)
            #define U_FADE_COLOR 1
        #endif

        //time value
        #if defined(USE_TIME_VALUE)
            #define VS_TIME 1
        #endif

        //fog
        #if defined(USE_FOG)
            #define U_FOG 1
        #endif

        //multi0 mask
        #if defined(USE_MULTI0_MASK)
            #define S_MULTI0_MASK 1
        #endif
    #endif

    #define SHADER_FEATURES 1
#endif
