#if !defined(SHADER_SETUP_FSH)

    //reference prefix_tow.sh until this file is standard
    #include "prefix_tow.sh"
    
    #if defined(GL_ES)
        precision highp float;
    #endif

    //===================================================================================================================//
    // INSTANCING //
    //===================================================================================================================//

    #if __VERSION__ >= 300
        layout(location = 0) out vec4 primaryOutput;
        #if defined(BORDER) && (BORDER_METHOD == BORDER_METHOD_PIXEL_BASED_MRT)
            layout(location = 1) out int secondaryDepth;
        #endif
        #define gl_FragColor primaryOutput

        #define textureCube texture
    #endif

    #if CC3_PLATFORM_WINDOWS // win32
        #undef INSTANCING_ENABLED
    #else
        #if !defined(INSTANCING_HARD_DISABLE)
            #define INSTANCING_ENABLED
        #else
            #undef INSTANCING_ENABLED
        #endif
    #endif

    //===================================================================================================================//
    // CONSTANTS //
    //===================================================================================================================//

    #define M_PI 3.1415926535897932384626433832795

    #if defined(INSTANCING_ENABLED)
        #define MAX_SKINNED_INSTANCES 10
    #else
        #define MAX_SKINNED_INSTANCES 1
    #endif
    #define M_GRAYSCALE vec3(0.2126, 0.7152, 0.0722)

    #define SHADER_SETUP_FSH 1
#endif