#if !defined(SHADER_SETUP_VSH)
    #define SUPPORT_GLSL300
    //reference prefix_tow.sh until this file is standard
    #include "prefix_tow.sh"
    
    #if defined(GL_ES)
        precision highp float;
    #endif

    //===================================================================================================================//
    // INSTANCING //
    //===================================================================================================================//


    #if CC3_PLATFORM_WINDOWS // win32

        #if !defined(INSTANCING_HARD_DISABLE)
            #if !defined(UNIFORM_BASED_INSTANCING)
                #define INSTANCE_ID 0
            #else
                #define INSTANCE_ID (int(a_cc3InstanceId))
            #endif
            #define INSTANCING_ENABLED
        #else
            #define INSTANCE_ID 0
            #undef INSTANCING_ENABLED
        #endif

    #elif defined(GL_ES) // ios

        #if !defined(INSTANCING_HARD_DISABLE)
            #extension GL_EXT_draw_instanced: enable
            #define INSTANCE_ID gl_InstanceIDEXT
            #define INSTANCING_ENABLED
        #else
            #define INSTANCE_ID 0
            #undef INSTANCING_ENABLED
        #endif

    #else // osx

        #if !defined(INSTANCING_HARD_DISABLE)
            #extension GL_ARB_draw_instanced: enable
            #define INSTANCE_ID gl_InstanceIDARB
            #define INSTANCING_ENABLED
        #else
            #define INSTANCE_ID 0
            #undef INSTANCING_ENABLED
        #endif

    #endif


    //===================================================================================================================//
    // CONSTANTS //
    //===================================================================================================================//

    #define M_PI 3.1415926535897932384626433832795

    #define SHADER_SETUP_VSH 1
#endif