#include "rc_shadow.fsh"

// Defined in rc_shadow.fsh:
// void shadow_receive();

void world_shadow_receive()
{
    #if defined(VSOUT_SHADOW_COORD)
        vec2 sampleUV = v_shadow.xy * 0.999 + 0.5 * 0.001;

        #if SHADOW_USE_COMPARISON_SAMPLER != 0
            float visibility = ShadowVisibilitySingleTap(sampleUV, v_shadow.z);
        #else
            float shadowMapDepth = sampleLevelZero(u_shadowMap, sampleUV).x;
            float shadowCoverage = clamp((v_shadow.z - shadowMapDepth) * 30.0 , 0.0, 1.0);
            float visibility = 1.0 - shadowCoverage;
        #endif

        gl_FragColor.rgb *= mix(vec3(0.75), vec3(1.0), visibility);
    #endif
}
