
#ifndef SHADOW_UNIFORMS_SHADER
#define SHADOW_UNIFORMS_SHADER

#include "system_utility.sh"        // for "transpose" definition

uniform mat4 ShadowUniforms_shadowLightVP;
uniform vec3 ShadowUniforms_shadowColor;
uniform float ShadowUniforms_shadowZThreshold;
uniform vec2 ShadowUniforms_shadowMapSize;
uniform float ShadowUniforms_shadowIntensity;
uniform float ShadowUniforms_shadowLightSize;

#if defined(METAL_INSTEAD_OF_OPENGL)
    #define GetShadowLightVP()              ( transpose(ShadowUniforms_shadowLightVP) )
    #define GetShadowZThreshold()           ( ShadowUniforms_shadowZThreshold )
    #define GetShadowColor()                ( ShadowUniforms_shadowColor )
    #define GetShadowMapSize()              ( ShadowUniforms_shadowMapSize )
    #define GetShadowIntensity()            ( ShadowUniforms_shadowIntensity )
    #define GetShadowLightSize()            ( ShadowUniforms_shadowLightSize )
#else
    mat4 GetShadowLightVP()     { return transpose(ShadowUniforms_shadowLightVP); }
    float GetShadowZThreshold() { return ShadowUniforms_shadowZThreshold; }
    vec3 GetShadowColor()       { return ShadowUniforms_shadowColor; }
    vec2 GetShadowMapSize()     { return ShadowUniforms_shadowMapSize; }
    float GetShadowIntensity()  { return ShadowUniforms_shadowIntensity; }
    float GetShadowLightSize()  { return ShadowUniforms_shadowLightSize; }
#endif

uniform sampler2D u_shadowMap;
uniform sampler2D u_shadowRotateTable; // for SHADOW_FILTERING_STOCHASTIC

#if defined(SHADOW_USE_COMPARISON_SAMPLER) && (SHADOW_USE_COMPARISON_SAMPLER != 0) && (__VERSION__ >= 300)
    uniform mediump sampler2DShadow u_shadowComparisonTexture;
#endif

#endif // SHADOW_UNIFORMS_SHADER

