local HAS_INIT = 'hasInitKey'

shortyMap_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        local player1Entities = objc.list_entities(1)
        local player2Entities = objc.list_entities(2)
        local barricadeHealth = 0
        for _, unit in pairs(player1Entities) do
            if objc.is_barricade(unit) then
                barricadeHealth = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH)
                objc.sacrifice_entity(unit)
            end
        end

        for _, unit in pairs(player2Entities) do
            if objc.is_barricade(unit) then
                objc.sacrifice_entity(unit)
            end
        end

        local player1Base = objc.get_base_entity(1)
        local player2Base = objc.get_base_entity(2)

        local baseHealth = objc.get_entity_value_for_key(player1Base, ENTITY_VALUE_KEY_MAX_HEALTH)
        objc.set_entity_value_for_key(player1Base, ENTITY_VALUE_KEY_MAX_HEALTH, baseHealth + barricadeHealth)
        objc.set_entity_value_for_key(player2Base, ENTITY_VALUE_KEY_MAX_HEALTH, baseHealth + barricadeHealth)
        objc.set_entity_value_for_key(player1Base, ENTITY_VALUE_KEY_CURRENT_HEALTH, baseHealth + barricadeHealth)
        objc.set_entity_value_for_key(player2Base, ENTITY_VALUE_KEY_CURRENT_HEALTH, baseHealth + barricadeHealth)

        objc.set_local_value(entity, HAS_INIT, 1)
    end
end
