local SLOW_AMOUNT = 36
local RANGE_DIFFERENCE_PROP = 0.5
local SLOW_CHECK_TICK = 10
local SLOW_CHECK_KEY = 'slowedCheckKey'
local SLOW_RADIUS = 1000
local HAS_BEEN_SLOWED_KEY = 'hasBeenSlowEntitySlowed'
local HAS_INIT = 'hasInit'
local DESC_ID = 'descIdKey'

slowNearbyUnitsEntity_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        local desc = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_DESCRIPTION)
        objc.set_local_value(entity, DESC_ID, desc)
        objc.set_local_value(entity, HAS_INIT, 1)
    end

    local slowCheck = objc.tick_timer(entity, SLOW_CHECK_KEY, SLOW_CHECK_TICK)
    if slowCheck == 0 then
        local teamNumber = objc.get_team_number(entity)
        local enemyNumber = objc.get_enemy_team_number(entity)

        local allies = objc.list_entities_in_radius(entity, SLOW_RADIUS, teamNumber)
        for _,ally in pairs(allies) do
            local hasBeenSlowedKey = objc.get_local_value(ally, HAS_BEEN_SLOWED_KEY)
            if hasBeenSlowedKey == 0 then
                local currentSpeed = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_MAX_VELOCITY)
                local originalRange = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_ATTACK_RANGE)
                objc.set_entity_value_for_key(ally, ENTITY_VALUE_KEY_MAX_VELOCITY, currentSpeed - SLOW_AMOUNT)
                objc.set_entity_value_for_key(ally, ENTITY_VALUE_KEY_ATTACK_RANGE, math.floor(originalRange * RANGE_DIFFERENCE_PROP))
                objc.set_local_value(ally, HAS_BEEN_SLOWED_KEY, 1)
            end
        end

        local enemies = objc.list_entities_in_radius(entity, SLOW_RADIUS, enemyNumber)
        for _,enemy in pairs(enemies) do
            local hasBeenSlowedKey = objc.get_local_value(enemy, HAS_BEEN_SLOWED_KEY)
            if hasBeenSlowedKey == 1 then
                local currentSpeed = objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_MAX_VELOCITY)
                local originalRange = objc.get_entity_value_for_key(enemy, ENTITY_VALUE_KEY_ATTACK_RANGE)
                objc.set_entity_value_for_key(enemy, ENTITY_VALUE_KEY_MAX_VELOCITY, currentSpeed + SLOW_AMOUNT)
                objc.set_entity_value_for_key(enemy, ENTITY_VALUE_KEY_ATTACK_RANGE, objc.divide_with_floor(originalRange, RANGE_DIFFERENCE_PROP))
                objc.set_local_value(enemy, HAS_BEEN_SLOWED_KEY, 0)
            end
        end
    end
end
