local CHECK_TICK = 3
local CHECK_KEY = 'checkKey'

local SMALL_UNIT_STAT_NUMERATOR = 1
local SMALL_UNIT_STAT_DENOMINATOR = 3
local NUM_SPLIT = 3
local BOSS_UNIT_BASE_IDENTIFIER = 'W_LongRangeTank'
local IS_SPLIT = 'isSplitKey'
local LAST_SPLIT_COUNTER = 'lastSplitCounterKey'
local SPLIT_COUNT = 1
local SHOULD_NOT_SPAWN_CULTLING = 'shouldSpawnCultling'

smallUnitsModifier_tickTrigger = function(entity)
    local checkTimer = objc.tick_timer(entity, CHECK_KEY, CHECK_TICK)
    if checkTimer == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            local isSplit = objc.get_local_value(unit, IS_SPLIT)
            local baseId = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER)
            if objc.is_normal_unit(unit) and baseId ~= BOSS_UNIT_BASE_IDENTIFIER and baseId ~= 'W_KyrieCultist' and baseId ~= 'W_KyrieCultling' and isSplit == 0 then
                local lastSplitCounter = objc.get_local_value(entity, LAST_SPLIT_COUNTER)
                if lastSplitCounter == SPLIT_COUNT then
                    local identifier = objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_IDENTIFIER)
                    local spawned = objc.spawn_at_entity(identifier, NUM_SPLIT, unit)
                    for _, spawnedUnit in pairs(spawned) do
                        local currentHealth = objc.get_entity_value_for_key(spawnedUnit, ENTITY_VALUE_KEY_CURRENT_HEALTH)
                        local maxHealth = objc.get_entity_value_for_key(spawnedUnit, ENTITY_VALUE_KEY_MAX_HEALTH)

                        objc.set_entity_value_for_key(spawnedUnit, ENTITY_VALUE_KEY_CURRENT_HEALTH, objc.divide_with_ceiling(currentHealth, SMALL_UNIT_STAT_DENOMINATOR) * SMALL_UNIT_STAT_NUMERATOR)
                        objc.set_entity_value_for_key(spawnedUnit, ENTITY_VALUE_KEY_MAX_HEALTH, objc.divide_with_ceiling(maxHealth, SMALL_UNIT_STAT_DENOMINATOR) * SMALL_UNIT_STAT_NUMERATOR)
                        objc.add_trigger(spawnedUnit, TRIGGER_NAME_DAMAGE_TRIGGER, 'smallUnitsModifier.lua', 'smallUnitsModifier_smallDamageTrigger')

                        objc.set_entity_scale_percentage(spawnedUnit, 65)
                        objc.set_local_value(spawnedUnit, IS_SPLIT, 1)
                    end
                    objc.set_local_value(entity, LAST_SPLIT_COUNTER, 0)
                    objc.set_local_value(unit, SHOULD_NOT_SPAWN_CULTLING, 1)
                    objc.sacrifice_entity(unit)
                else
                    objc.set_local_value(entity, LAST_SPLIT_COUNTER, lastSplitCounter + 1)
                    objc.set_local_value(unit, IS_SPLIT, 1)
                end
            end
        end
    end
end

smallUnitsModifier_smallDamageTrigger = function(damage, targetEntity, sourceEntity)
    local newDamage = objc.divide_with_ceiling(damage, SMALL_UNIT_STAT_DENOMINATOR) * SMALL_UNIT_STAT_NUMERATOR
    return newDamage
end
