local AFFECTED_ENTITIES_ARRAY_KEY = 'affectedEntitiesList'
local BEING_SNIPED_KEY = 'isBeingSniped'
local RETICULE_PARTICLE = 'test_rangerCommander.lvl'
local HAS_INIT = 'hasInit'
local NUM_SNIPES = 4

snipeScriptEntity_tickTrigger = function(entity)
   local hasInit = objc.get_local_value(entity, HAS_INIT)
   if hasInit == 0 then
      local highestCostArray = {}
      local teamNumber = objc.get_team_number(entity)
      local enemyNumber = objc.get_enemy_team_number(entity)
      local enemies = objc.list_entities(enemyNumber)
      for i = 1,NUM_SNIPES do
         local mostExpensiveEntity = 0
         local mostExpensiveCost = 0

         for _, enemy in pairs(enemies) do
            local hasBeenSniped = objc.get_local_value(enemy, BEING_SNIPED_KEY)
            if hasBeenSniped == 0 then
               if objc.is_normal_unit(enemy) then
                  local thisCost = objc.get_entity_value(enemy, 'aiComponent.cost')
                  if thisCost > mostExpensiveCost then
                     mostExpensiveCost = thisCost
                     mostExpensiveEntity = enemy
                  end
               end
            end
         end

         if mostExpensiveEntity ~= 0 then
            table.insert(highestCostArray, mostExpensiveEntity)
            objc.set_local_value(mostExpensiveEntity, BEING_SNIPED_KEY, 1)
            objc.play_vfx(mostExpensiveEntity, RETICULE_PARTICLE, NODE_STATUS)
         end
      end

      objc.set_local_value(entity, AFFECTED_ENTITIES_ARRAY_KEY, highestCostArray)
      objc.set_local_value(entity, HAS_INIT, 1)
   end

   return 0
end


snipeScriptEntity_deathTrigger = function(entity)
   local affectedEntitiesArray = objc.get_local_value(entity, AFFECTED_ENTITIES_ARRAY_KEY)
   if affectedEntitiesArray ~= 0 then
      for _, enemy in pairs(affectedEntitiesArray) do
         objc.kill_entity(enemy)
      end
   end
end

