#define SUPPORT_GLSL300
//hardware and platform support
#include "shader_setup.vsh"

//===================================================================================================================//
// SHADER DEFINES //
//===================================================================================================================//

//define features here - move to a separate .vsh file later if it gets cluttered here

#if !defined(SHADOW_GEN)

    //world directional lighting with normal map - single uv set - no vert color - multi map usage for spec mask (multi1)
    #if defined(WORLD_NORMAL_MULTI0_LEGACY)
        #define USE_NORMAL_MAP 1
        #define USE_WORLD_LIGHTING 1
        #define USE_REFLECT 1
    #endif

    //world directional lighting with normal map - single uv set - no vert color - multi map usage for spec mask (multi1) - alpha fade - loading shader lerp
    #if defined(WORLD_NORMAL_MULTI0_LEGACY_ALPHAFADE_LOADING)
        #define USE_NORMAL_MAP 1
        #define USE_WORLD_LIGHTING 1
        #define USE_REFLECT 1
        #define USE_TIME_VALUE 1
    #endif

#endif

//shader features
#include "shader_features.sh"

//attributes, vertex streams in/out, and uniforms
#include "shader_vertex.vsh"

//===================================================================================================================//
// SHADER //
//===================================================================================================================//

void main() {
    // utility functions in shader_vertex.vsh
    setup_positions();
    setup_texcoords();
    setup_material_diffuse_color();
    setup_vertex_color();
    setup_world_lighting();
    setup_normals();
    setup_instancing();
    setup_shadows();

}
