local AFFECTED_ENTITIES_ARRAY_KEY = 'affectedEntitiesList'

staticShockScriptEntity_tickTrigger = function(entity)
   local hasInit = objc.get_local_value(entity, 'hasInit')

   if hasInit == 0 then
      objc.set_local_value(entity, 'hasInit', 1)

      local teamNumber = objc.get_team_number(entity)
      local alliedEntities = objc.list_entities(teamNumber)
      local affectedEntitiesArray = {}

      for _, ally in pairs(alliedEntities) do
         if objc.is_normal_unit(ally) then
            table.insert(affectedEntitiesArray, ally)
            objc.set_entity_value_for_key(ally, ENTITY_VALUE_KEY_MAX_VELOCITY, 0)

            --Start blinking blue
            local blinkParams = {} 
            blinkParams['red'] = 50
            blinkParams['green'] = 50
            blinkParams['blue'] = 255
            blinkParams['alpha'] = 60
            blinkParams['initialBlinkFrequency'] = 30
            blinkParams['finalBlinkFrequency'] = 30
            blinkParams['initialBlinkIntensity'] = 16
            blinkParams['finalBlinkIntensity'] = 16
            blinkParams['animationDurationInDeciseconds'] = 0
            blinkParams['animationAcceleration'] = 50
            blinkParams['easingType'] = EASE_OUT
            objc.start_blinking(ally, blinkParams)

            objc.play_vfx(ally, 'temp_rangerCommander.lvl', 'node_origin')
         end
      end

      objc.set_local_value(entity, AFFECTED_ENTITIES_ARRAY_KEY, affectedEntitiesArray)
   end

   return 0
end




staticShockScriptEntity_deathTrigger = function(entity)
   local affectedEntitiesArray = objc.get_local_value(entity, AFFECTED_ENTITIES_ARRAY_KEY)

   if affectedEntitiesArray ~= 0 then
      for _, ally in pairs(affectedEntitiesArray) do
         objc.set_entity_value_for_key(ally, ENTITY_VALUE_KEY_MAX_VELOCITY, 60)
         objc.stop_blinking(ally)
      end
   end
end

