
#if !defined(SURFACE_SH)
#define SURFACE_SH

struct TangentFrame {
    vec3    _normal;
    vec3    _tangent;
    vec3    _bitangent;
};

struct RawTangentFrame {
    vec3    _axesA, _axesB;
    float   _handiness;
    int     _type;
};

float getTangentFrameHandiness(TangentFrame tf) {
    return dot(cross(tf._normal, tf._tangent), tf._bitangent) >= 0.0 ? 1.0 : -1.0;
}

TangentFrame asFullTangentFrame(RawTangentFrame tf) {
    TangentFrame result;
    if (tf._type == TANGENT_FRAME_NORMAL) {
        result._normal = tf._axesA;
        result._tangent = vec3(0,0,0);
        result._bitangent = vec3(0,0,0);
    } else if (tf._type == TANGENT_FRAME_NT) {
        result._normal = tf._axesA;
        result._tangent = tf._axesB;
        result._bitangent = cross(tf._axesA, tf._axesB) * tf._handiness;
    } else if (tf._type == TANGENT_FRAME_TB) {
        result._tangent = tf._axesA;
        result._bitangent = tf._axesB;
        result._normal = cross(tf._axesA, tf._axesB) * tf._handiness;
    } else {
        result._normal = result._tangent = result._bitangent = vec3(0,0,0);
    }
    return result;
}

#endif

