
#if !defined(SYSTEM_UNIFORMS_SH)
#define SYSTEM_UNIFORMS_SH

#include "system_utility.sh"        // for "transpose" definition

// Note -- no support for instancing as of now
uniform mat4 u_cc3MatrixModel;

/*row_major*/ uniform mat4 CocosUniforms_worldToClip;
/*row_major*/ uniform mat4 CocosUniforms_worldToCamera;
uniform vec3 CocosUniforms_cameraPositionWorld;
uniform vec2 CocosUniforms_sceneTime;
uniform vec4 CocosUniforms_cameraFrustumDepth;
uniform vec4 CocosUniforms_viewport;

mat4 getWorldToProj()               { return transpose(CocosUniforms_worldToClip); }
mat4 getWorldToCamera()             { return transpose(CocosUniforms_worldToCamera); }
float getSceneTime()                { return CocosUniforms_sceneTime.x; }
float getSceneTimeFract()           { return CocosUniforms_sceneTime.y; }
vec3 getCameraPositionWorld()       { return CocosUniforms_cameraPositionWorld; }
vec4 getCameraFrustumDepth()        { return CocosUniforms_cameraFrustumDepth; }
vec4 getViewport()                  { return CocosUniforms_viewport; }

/*row_major*/ uniform mat4 CocosNodeBasedUniforms_localToWorld;
/*row_major*/ uniform mat4 CocosNodeBasedUniforms_localToClip;

mat4 getModelToWorld()              { return transpose(CocosNodeBasedUniforms_localToWorld); }
mat4 getModelToWorldNoScale()       { return transpose(CocosNodeBasedUniforms_localToWorld); }
bool modelToWorldNoScaleIsGood()    { return false; }
mat4 getModelToProj()               { return transpose(CocosNodeBasedUniforms_localToClip); }

#endif // SYSTEM_UNIFORMS_SH

