local DELAY_KEY = 'targetedBuffScriptDelayKey'
local SCRIPT_DELAY = 15
local DAMAGE_BOOST_RADIUS = 2000
local DAMAGE_BOOST_KEY = 'damageBoostedByAbility'
local BUFF_AMOUNT = 4
local BUFF_DURATION = 50
local BUFF_SIZE = 2000

--[[
This TickTrigger initially spawns the beamVFXAlreadySpawned, and then spawns
two rows of 4 B_Rifleman.
--]]
targetedBuffScriptEntity_tickTrigger = function(entity)
   objc.set_targetable(entity, false)
   local delayTimer = objc.tick_timer(entity, DELAY_KEY, SCRIPT_DELAY)
   if delayTimer == 0 then
      local enemyNumber = objc.get_enemy_team_number(entity)
      local positionX = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_POSITION_X)
      local positionY = objc.get_entity_value_for_key(entity, ENTITY_VALUE_KEY_POSITION_Y)
      local nearbyAllies = objc.list_enemies_in_radius_of_point(positionX, positionY, BUFF_SIZE, enemyNumber)

      for _,ally in pairs(nearbyAllies) do
         if objc.is_normal_unit(ally) then
            local hasBeenBuffed = objc.get_local_value(ally, DAMAGE_BOOST_KEY)
            local thisID = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_IDENTIFIER)
            if hasBeenBuffed == 0 then
               local damageBonus = objc.get_entity_value_for_key(ally, ENTITY_VALUE_KEY_DAMAGE_BUFF)
               objc.set_entity_value_for_key(ally, ENTITY_VALUE_KEY_DAMAGE_BUFF, damageBonus + BUFF_AMOUNT)
               objc.play_vfx(ally, 'Status_damagePlus.lvl', NODE_STATUS)
               objc.set_local_value(ally, DAMAGE_BOOST_KEY, 1)
            end
         end
      end

      objc.kill_entity(entity)
   end
end
