
#if defined(GL_ES)
    precision highp float;
#endif

// uniforms
uniform sampler2D s_cc3Texture2Ds[2];
uniform vec3 u_cc3CameraPositionGlobal;
uniform vec2 u_cc3SceneTime;
uniform float pulsePhase;

// varyings
varying vec3 v_N;
varying vec3 v_position_world;
varying vec2 v_texCoord;

// code
void main() {
    vec4 texel1 = texture2D(s_cc3Texture2Ds[0], v_texCoord);
    vec4 texel2 = texture2D(s_cc3Texture2Ds[1], v_texCoord);

    float time = mod(u_cc3SceneTime.x, pulsePhase);
#if 0
    float glowIntensity = float(time < pulsePhase * 0.5) * (time * 0.5) + float(time >= pulsePhase * 0.5) * (1.0 - (time - pulsePhase * 0.5) * 0.5);
#else
    const float PI = 3.1415926535;
    float glowIntensity = sin(PI * time / pulsePhase);
    glowIntensity *= glowIntensity;
#endif

    vec3 N = normalize(v_N);
    vec3 V = normalize(u_cc3CameraPositionGlobal - v_position_world);
    float nDotVInv = max(0.0, dot(N, V));
    nDotVInv = nDotVInv * nDotVInv;
    gl_FragColor = vec4(mix(texel1.rgb, texel2.rgb, nDotVInv * glowIntensity), texel1.a);
}
