
#if defined(GL_ES)
    precision highp float;
#endif

uniform sampler2D s_cc3Texture2Ds[2];

varying vec2 v_texCoord;
varying float v_shadowDepth;
varying vec2 v_shadowCoord1;
varying vec2 v_shadowCoord2;
varying vec2 v_shadowCoord3;
varying vec2 v_shadowCoord4;

void main() {
    vec4 texel = texture2D(s_cc3Texture2Ds[0], v_texCoord);
    vec4 fragColor = texel;
    
    //shadow
    float visibility = 1.0;
    
    visibility -= 0.15 * float( texture2D(s_cc3Texture2Ds[1], v_shadowCoord1).z < v_shadowDepth - 0.02);
    visibility -= 0.15 * float( texture2D(s_cc3Texture2Ds[1], v_shadowCoord2).z < v_shadowDepth - 0.02);
    visibility -= 0.15 * float( texture2D(s_cc3Texture2Ds[1], v_shadowCoord3).z < v_shadowDepth - 0.02);
    visibility -= 0.15 * float( texture2D(s_cc3Texture2Ds[1], v_shadowCoord4).z < v_shadowDepth - 0.02);
    
    gl_FragColor = vec4(fragColor.rgb * visibility, fragColor.a);
}
