

#if !defined(TEXTURE_UTILITY_SHADER)
#define TEXTURE_UTILITY_SHADER

////////////////////////////////////////////////////////////////////////////////////////////////////
    //      T E X T U R E   U T I L I T I E S      //
////////////////////////////////////////////////////////////////////////////////////////////////////

#if __VERSION__ >= 300
    #define sampleLevelZero(sampler, coords) textureLod((sampler), (coords), 0.0)
#elif defined(GL_EXT_shader_texture_lod)
    #define sampleLevelZero(sampler, coords) texture2DLodEXT((sampler), (coords), 0.0)
#else
    #define sampleLevelZero(sampler, coords) texture2D((sampler), (coords))
#endif

vec3 powSmear(vec3 value, float exp)    { return vec3(pow(value.x, exp), pow(value.y, exp), pow(value.z, exp)); }
vec3 LinearToSRGB(vec3 color)		    { return powSmear(color, 1.0/2.2); }
vec3 SRGBToLinear(vec3 color)		    { return powSmear(color, 2.2); }

vec3 LinearToSRGB_Fast(vec3 color)		    { return vec3(sqrt(color.r), sqrt(color.g), sqrt(color.b)); }
vec3 SRGBToLinear_Fast(vec3 color)		    { return vec3(color.r*color.r, color.g*color.g, color.b*color.b); }

#endif
