#define SUPPORT_GLSL300
#include "prefix.sh"

precision highp sampler2D;

uniform sampler2D s_cc3Texture2Ds[1];

uniform float TrailUniforms_applyTexture;
uniform float TrailUniforms_opacity;

VARYING_IN vec2 v_texCoord[1];
VARYING_IN vec4 v_color[1];

void main()
{
    vec4 textureColor = texture2D(s_cc3Texture2Ds[0], v_texCoord[0].xy);
    vec4 color = mix(vec4(1.0), textureColor, TrailUniforms_applyTexture);

    vec4 diffuseColor = color * v_color[0];
    diffuseColor.a *= TrailUniforms_opacity;

    gl_FragColor = diffuseColor;
}
