
#if !defined(TRANSFORMS_SH)
#define TRANSFORMS_SH

#include "framework/framework.sh"
#include "framework/system_uniforms.sh"

vec4 transformPoint(mat4 transform, vec3 position)              { return transform * vec4(position, 1); }
vec3 transformDirection(mat4 transform, vec3 directionVector)   { return (transform * vec4(directionVector, 0)).xyz; }

RawTangentFrame transformTangentFrame(mat4 transform, RawTangentFrame tf) {
    RawTangentFrame result;
    result._axesA = transformDirection(transform, tf._axesA);
    result._axesB = transformDirection(transform, tf._axesB);
    result._handiness = tf._handiness;
    result._type = tf._type;
    return result;
}

RawTangentFrame normalizeTangentFrame(RawTangentFrame tf) {
    RawTangentFrame result;
    result._axesA = normalize(tf._axesA);
    result._axesB = normalize(tf._axesB);
    result._handiness = tf._handiness;
    result._type = tf._type;
    return result;
}

#endif

