local HAS_INIT = 'hasInit'
local SPAWN_INIT = 'spawnInit'
local BARRICADE_INIT = 'barricadeInit'

local UNIT_LUA = 'tutorial2.lua'

local REPLACE_ARCHER = "replaceArcher"
local MOVE_SPOTLIGHT = "moveSpotlight"
local INVISIBLE_ARCHER = "invisibleArcher"

tutorial2_tickTrigger = function(entity)
    local barricadeInit = objc.get_local_value(entity, BARRICADE_INIT)
    if barricadeInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'R_Barricade' then
                objc.set_local_value(entity, BARRICADE_INIT, 1)
            end
        end
    elseif barricadeInit == 1 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'R_Barricade' then
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, 2000)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, 2000)
            end
        end
        objc.set_local_value(entity, BARRICADE_INIT, 2)
    end

    -- Initialize the invisible archer that controls the spotlight
    local invisibleArcher = objc.get_global_value(INVISIBLE_ARCHER)
    if invisibleArcher == 1 then
        local team1Entities = objc.list_entities(1)
        for _,unit in pairs(team1Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'W_PowerPlant' then
                local archerX = objc.get_entity_position(unit)[1]
                local archerY = objc.get_entity_position(unit)[2]
                if archerY > 0 then
                    if archerX < -4500 then
                        archerX = -4200
                        archerY = 1700
                    else
                        archerX = -3500
                        archerY = 2000
                    end
                else
                    archerX = archerX + 1200
                end
                local theArcher = objc.spawn_at_point("Dummy_Ground", 1, 1, archerX, archerY, 1, 1)
                objc.set_solid(theArcher[1], false)
                objc.set_entity_visibility(theArcher[1], false)
                objc.idle_entity_indefinitely(theArcher[1])
                objc.set_global_value(INVISIBLE_ARCHER, 0)
            end
        end
    end

    -- Move the invisible archer that controls the spotlight
    local moveSpotlight = objc.get_global_value(MOVE_SPOTLIGHT)
    if moveSpotlight == 1 then
        local team1Entities = objc.list_entities(1)
        for _,unit in pairs(team1Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'W_PowerPlant' then
                local archerX = objc.get_entity_position(unit)[1]
                local archerY = objc.get_entity_position(unit)[2]
                if archerY > 0 then
                    if archerX < -4500 then
                        local powerplant = objc.spawn_at_point("PowerPlantCable_02_TutorialSpark", 1, 1, 0, 0, 1, 1)
                    else
                        local theArcher = objc.spawn_at_point("PowerPlantCable_03_TutorialSpark", 1, 1, 0, 0, 1, 1)
                    end
                else
                    local theArcher = objc.spawn_at_point("PowerPlantCable_01_TutorialSpark", 1, 1, 0, 0, 1, 1)
                end
                objc.set_global_value(MOVE_SPOTLIGHT, 2)
            end
        end
    elseif moveSpotlight == 2 then
        local team1Entities = objc.list_entities(1)
        for _,unit in pairs(team1Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'Dummy_Ground' then
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_VELOCITY, 10)
                objc.unidle_entity(unit)
                objc.move_entity_to_location_with_velocity(unit, -4000, 0, 120, 10)
                if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_POSITION_X) < -3950
                    and objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_POSITION_X) > -4050
                    and objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_POSITION_Y) > -50
                    and objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_POSITION_Y) < 50 then
                    objc.idle_entity_indefinitely(unit)
                    objc.set_global_value(MOVE_SPOTLIGHT, 0)
                end
            end
        end
    end

end
