local HAS_INIT = 'hasInit'
local BARRICADE_INIT = 'barricadeInit'
local NASH_INIT = 'nashInit'
local KURO_INIT = 'kuroInit'

local UNIT_LUA = 'tutorial3.lua'

tutorial3_tickTrigger = function(entity)
    local barricadeInit = objc.get_local_value(entity, BARRICADE_INIT)
    if barricadeInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_Barricade' then
                objc.set_local_value(entity, BARRICADE_INIT, 1)
                break
            end
        end
    elseif barricadeInit == 1 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_Barricade' then
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, 2000)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, 2000)
                break
            end
        end

        local team1Entities = objc.list_entities(1)
        for _,unit in pairs(team1Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'W_Barricade' then
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_MAX_HEALTH, 6000)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_CURRENT_HEALTH, 6000)
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ARMOR, 20)
                break
            end
        end
        objc.set_local_value(entity, BARRICADE_INIT, 2)
    end

    local nashInit = objc.get_local_value(entity, NASH_INIT)
    if nashInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'C_Ai' then
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ARMOR, 100)
                objc.set_local_value(entity, NASH_INIT, 1)
                break
            end
        end
    end

    local kuroInit = objc.get_local_value(entity, KURO_INIT)
    if kuroInit == 0 then
        local team1Entities = objc.list_entities(1)
        for _,unit in pairs(team1Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'C_Ascension2' then
                objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ARMOR, 100)

                local team2Entities = objc.list_entities(2)
                for _,unit in pairs(team2Entities) do
                    if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'C_Ai' then
                        objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_ARMOR, 0)
                        local damageDebuff = objc.divide_with_ceiling(objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_ATTACK_DAMAGE), 2)
                        objc.set_entity_value_for_key(unit, ENTITY_VALUE_KEY_DAMAGE_BUFF, -1 * damageDebuff)
                        break
                    end
                end

                objc.set_local_value(entity, KURO_INIT, 1)
                break
            end
        end
    end
end
