local LUA_FILE = 'tutorialShipHealthVisible.lua'

local DAMAGE_INIT = 'damageInit'

tutorialShipHealthVisible_tickTrigger = function(entity)
    local damageInit = objc.get_local_value(entity, DAMAGE_INIT)
    if damageInit == 0 then
        local team2Entities = objc.list_entities(2)
        for _,unit in pairs(team2Entities) do
            if objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'R_Barricade_Ship'
                or objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'B_Barricade_Ship'
                or objc.get_entity_value_for_key(unit, ENTITY_VALUE_KEY_BASE_TIER_IDENTIFIER) == 'W_Barricade_Ship' then
                objc.remove_trigger(unit, TRIGGER_NAME_ON_DAMAGE_TRIGGER, 'spawnShipBarricade_transferDamageToShip')
                objc.add_trigger(unit, TRIGGER_NAME_ON_DAMAGE_TRIGGER, LUA_FILE, 'tutorialShipHealthVisible_transferTripleDamageToShip')
                objc.set_local_value(entity, DAMAGE_INIT, 1)
            end
        end

    end
end

tutorialShipHealthVisible_transferTripleDamageToShip = function(damage, targetEntity, sourceEntity)
    local base = objc.get_base_entity(objc.get_team_number(targetEntity))
    objc.inflict_direct_damage(targetEntity, base, damage * 3)
    return 0
end