local HAS_INIT = 'hasInitKey'
local CENTRAL_OBJECTIVE_MARKER_NAME = 'GroundCircle'
local MINE_MAX_MINERS_KEY = 'maxMinersKey'
local MINE_MINERS_PER_MINE = 1
local MINE_CURRENT_CRYSTALS_KEY = 'currentCrystalsKey'
local MINER_WAYPOINT = 'MinerWaypoint'
local MINE_INDEX_KEY = 'mineIndexKey'

local IS_TWO_LANE_MAP_GLOBAL_KEY = "isTwoLaneMapGlobalKey"

twoLanesMap1v1_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        objc.set_global_value(IS_TWO_LANE_MAP_GLOBAL_KEY, 1)

        local p1Mines = objc.location_marker_node_names_with_prefix("P1_Mine")
        for k,v in pairs(p1Mines) do
            local x, y = objc.location_of_marker_node_named(v)
            spawnCrystalMineAtPosition(x, y, 1, v, true)
        end

        local p2Mines = objc.location_marker_node_names_with_prefix("P2_Mine")
        for k,v in pairs(p2Mines) do
            local x, y = objc.location_of_marker_node_named(v)
            spawnCrystalMineAtPosition(x, y, 2, v, false)
        end

        local centerObjective = objc.location_marker_node_names_with_prefix(CENTRAL_OBJECTIVE_MARKER_NAME)
        local index = 1
        for k,v in pairs(centerObjective) do
            local x, y = objc.location_of_marker_node_named(v)
            spawnCrystalObjectiveAtPosition(x, y, "CenterObjective" .. index)
            index = index + 1
        end

        objc.spawn('gameRulesEntityTwoLane', 1, 1)
        objc.set_local_value(entity, HAS_INIT, 1)

    elseif hasInit == 1 then
        --[[spawnCrystalWorker(-10600, -2000, 1)
        spawnCrystalWorker(-10000, -1500, 1)

        local is2vE = 0
        local playerNumbers = objc.get_player_numbers_for_team_number(1)
        for _, number in pairs(playerNumbers) do
            if number > 2 then
                is2vE = 1
            end
        end

        if is2vE == 1 then
            spawnCrystalWorker(-10800, 2300, 3)
            spawnCrystalWorker(-10000, 1800, 3)
        else
            spawnCrystalWorker(-10800, 2300, 1)
            spawnCrystalWorker(-10000, 1800, 1)
        end

        spawnCrystalWorker(9500, -2000, 2)
        spawnCrystalWorker(10000, -2200, 2)

        spawnCrystalWorker(9500, 2000, 2)
        spawnCrystalWorker(10000, 2200, 2)]]

        objc.set_local_value(entity, HAS_INIT, 2)
    end
end

spawnCrystalMineAtPosition = function(xPos, yPos, playerNumber, name, should_set_view)
    local spawnedMine = objc.spawn_skinned_entity_with_key_at_point(SKINNED_ENTITY_KEY_CRYSTAL_MINE, 1, playerNumber, xPos, yPos, 1, 0)
    objc.set_local_value(spawnedMine[1], MINE_INDEX_KEY, string.sub(name, -1))
    objc.set_placeable_objective_marker_node_name(spawnedMine[1], name)

    if should_set_view then
        objc.set_placeable_objective_view(spawnedMine[1], name)
    end
end

spawnCrystalObjectiveAtPosition = function(xPos, yPos, tag)
    local centerObjective
    if yPos < 0 then
        centerObjective = objc.spawn_skinned_entity_with_key_at_point(SKINNED_ENTITY_KEY_CENTRAL_OBJECTIVE_TOP, 1, 0, xPos, yPos, 0, 0)
    else
        centerObjective = objc.spawn_skinned_entity_with_key_at_point(SKINNED_ENTITY_KEY_CENTRAL_OBJECTIVE_BOTTOM, 1, 0, xPos, yPos, 0, 0)
    end
    
    objc.set_local_value(centerObjective[1], LUA_KEY_TAG, tag)
    objc.set_global_value(tag .. "Y", yPos)
    objc.set_entity_value_for_key(centerObjective[1], ENTITY_VALUE_KEY_INCOME_TIER, 1)
    return centerObjective[1]
end

spawnCrystalWorker = function(xPos, yPos, side)
    local faction = objc.get_commander_factions(side)
    if faction[1] == FACTION_BLUE then
        objc.spawn_at_point(ASCENSION_MINER, 1, side, xPos, yPos, 1, 0)
    elseif faction[1] == FACTION_GREEN then
        objc.spawn_at_point(LEGION_MINER, 1, side, xPos, yPos, 1, 0)
    elseif faction[1] == FACTION_RED then
        objc.spawn_at_point(ROGUE_MINER, 1, side, xPos, yPos, 1, 0)
    else
        objc.spawn_at_point(ROGUE_MINER, 1, side, xPos, yPos, 1, 0)
    end
end
