local HAS_INIT = 'hasInitKey'
local CENTRAL_OBJECTIVE_MARKER_NAME = 'GroundCircle'
local MINE_MAX_MINERS_KEY = 'maxMinersKey'
local MINE_MINERS_PER_MINE = 1
local MINE_CURRENT_CRYSTALS_KEY = 'currentCrystalsKey'
local MINER_WAYPOINT = 'MinerWaypoint'

twoLanesMap1v1NoObjective_tickTrigger = function(entity)
    local hasInit = objc.get_local_value(entity, HAS_INIT)
    if hasInit == 0 then
        objc.set_global_value(IS_TWO_LANE_MAP_GLOBAL_KEY, 1)

        spawnCrystalMineAtPosition(-10600, -2000, 1)
        spawnCrystalMineAtPosition(-10000, -1500, 1)

        spawnCrystalMineAtPosition(-10800, 2300, 1)
        spawnCrystalMineAtPosition(-10000, 1800, 1)

        spawnCrystalMineAtPosition(-4500, -3000, 1)
        spawnCrystalMineAtPosition(-3200, -3500, 1)

        spawnCrystalMineAtPosition(-4200, 3000, 1)

        spawnCrystalMineAtPosition(9500, -2000, 2)
        spawnCrystalMineAtPosition(10000, -2200, 2)

        spawnCrystalMineAtPosition(9500, 2000, 2)
        spawnCrystalMineAtPosition(10000, 2200, 2)

        spawnCrystalMineAtPosition(4500, 3000, 2)
        spawnCrystalMineAtPosition(3200, 3500, 2)

        spawnCrystalMineAtPosition(4200, -3000, 2)


        local x, y = objc.location_of_marker_node_named("P1_DropOff")
        spawnMinerWaypointAtPosition(x, y, 1)

        local x, y = objc.location_of_marker_node_named("P2_DropOff")
        spawnMinerWaypointAtPosition(x, y, 2)

        objc.spawn('gameRulesEntity', 1, 1)
        objc.set_local_value(entity, HAS_INIT, 1)

    elseif hasInit == 1 then
        spawnCrystalWorker(-10600, -2000, 1)
        spawnCrystalWorker(-10000, -1500, 1)

        spawnCrystalWorker(-10800, 2300, 1)
        spawnCrystalWorker(-10000, 1800, 1)

        spawnCrystalWorker(9500, -2000, 2)
        spawnCrystalWorker(10000, -2200, 2)

        spawnCrystalWorker(9500, 2000, 2)
        spawnCrystalWorker(10000, 2200, 2)

        objc.set_local_value(entity, HAS_INIT, 2)
    end
end

spawnCrystalMineAtPosition = function(xPos, yPos, playerNumber)
    objc.spawn_skinned_entity_with_key_at_point(SKINNED_ENTITY_KEY_CRYSTAL_MINE, 1, playerNumber, xPos, yPos, 1, 0)
end

spawnMinerWaypointAtPosition = function(xPos, yPos, playerNumber)
    objc.spawn_at_point(MINER_WAYPOINT, 1, playerNumber, xPos, yPos, 1, 0)
    objc.set_entity_value_for_key(centerObjective[1], ENTITY_VALUE_KEY_INCOME_TIER, 1)
end

spawnCrystalWorker = function(xPos, yPos, side)
    local faction = objc.get_commander_factions(side)
    if faction[1] == FACTION_BLUE then
        objc.spawn_at_point(ASCENSION_MINER, 1, side, xPos, yPos, 1, 0)
    elseif faction[1] == FACTION_GREEN then
        objc.spawn_at_point(LEGION_MINER, 1, side, xPos, yPos, 1, 0)
    elseif faction[1] == FACTION_RED then
        objc.spawn_at_point(ROGUE_MINER, 1, side, xPos, yPos, 1, 0)
    else
        objc.spawn_at_point(ROGUE_MINER, 1, side, xPos, yPos, 1, 0)
    end
end
