local CRYSTAL_VALUE_PER_MINUTE = 1.2

unitSpawnObjectiveEntity_tickTrigger = function(entity)
    local playerNumber = objc.get_player_number(entity)
    local teamNumber = objc.get_team_number(entity)
    local mercenaryRegion = objc.get_mercenary_placement_region(teamNumber, PLACEMENT_REGION_KEY_INITIAL)

    local spawnX = mercenaryRegion[PLACEMENT_REGION_X]
    local entityPos = objc.get_entity_position(entity)
    local gameTime = objc.get_elapsed_game_time_in_seconds()
    local gameTimeInMinutesTimeTen = objc.divide_with_floor(gameTime * 10, 60)
    local totalCrystalValue = math.floor(gameTimeInMinutesTimeTen * CRYSTAL_VALUE_PER_MINUTE)

    --pick a random unit value, and spawn it. Do this until we're at 1 or 0 (no unit to spawn)
    while totalCrystalValue >= 2 do
        local thisValue = objc.roll_number(2, totalCrystalValue)
        local toSpawnId = ''

        if thisValue == 2 then
            toSpawnId = 'N_Weenie'
        elseif thisValue == 3 then
            local randomValue = objc.roll_number(0, 2)
            if randomValue == 0 then
                toSpawnId = 'N_Slowhitter'
            elseif randomValue == 1 then
                toSpawnId = 'N_FrontLine'
            elseif randomValue == 2 then
                toSpawnId = 'N_Splasher'
            end
        elseif thisValue == 4 then
            local randomValue = objc.roll_number(0, 1)
            if randomValue == 0 then
                toSpawnId = 'N_AntiAir'
            elseif randomValue == 1 then
                toSpawnId = 'N_Bomber'
            end
        elseif thisValue == 5 then
            toSpawnId = 'N_Dogfighter'
        elseif thisValue == 6 then
            toSpawnId = 'N_Tank'
        elseif thisValue >= 7 then
            toSpawnId = 'N_Slicer'
        end

        if toSpawnId == 'N_Weenie' then
            objc.spawn_at_point(toSpawnId, 3, playerNumber, spawnX, entityPos[2], 1, 0)
        else
            objc.spawn_at_point(toSpawnId, 1, playerNumber, spawnX, entityPos[2], 1, 0)
        end
        totalCrystalValue = totalCrystalValue - thisValue
    end

    objc.sacrifice_entity(entity)
    local spawned1 = objc.spawn_at_point('IncomeLineEntityNeutral', 1, 1, 0, 2000, 1, 0)
end
