//#define NO_DIFFUSE_TEXTURE
//#define LIGHTMAP_ENABLED
//#define ALPHA_TEST
//#define USE_NORMAL_MAP
//#define BYPASS_NORMAL_MAP
//#define USE_LIGHT
//#define USE_VERTEX_COLOR
//#define FRESNEL_ENABLED
//#define ENVIRONMENT
//#define INSTANCING_HARD_DISABLE
//#define MANTIS_PBR

#define SUPPORT_GLSL300
#include "prefix_tow.sh"

#if defined(GL_ES)
    precision highp float;
#endif

#if __VERSION__ >= 300
    layout(location = 0) out vec4 primaryOutput;
    #if defined(BORDER) && (BORDER_METHOD == BORDER_METHOD_PIXEL_BASED_MRT)
        layout(location = 1) out int secondaryDepth;
    #endif
    #define gl_FragColor primaryOutput

    #define textureCube texture
#endif

#if CC3_PLATFORM_WINDOWS // win32
#undef INSTANCING_ENABLED
#else
#if !defined(INSTANCING_HARD_DISABLE)
#define INSTANCING_ENABLED
#else
#undef INSTANCING_ENABLED
#endif
#endif

#include "shadow.fsh"
#define M_PI 3.1415926535897932384626433832795
#if defined(INSTANCING_ENABLED)
#define MAX_SKINNED_INSTANCES 10
#else
#define MAX_SKINNED_INSTANCES 1
#endif
#define M_GRAYSCALE vec3(0.2126, 0.7152, 0.0722)

uniform vec4 HighlightColor;

void main() {
    gl_FragColor.rgb = mix(gl_FragColor.rgb, HighlightColor.rgb, HighlightColor.a);
}
