#define SUPPORT_GLSL300
#extension GL_EXT_gpu_shader4 : enable
#include "prefix.sh"

#undef VS_OUT_S_TEXCOORD
#define VS_OUT_S_TEXCOORD 1

#include "framework/framework.sh"
#include "framework/transforms.sh"
#include "framework/skinning.sh"
#include "framework/system_uniforms.sh"

////////////////////////////////////////////////////////////////////////////////////////////////////

void vsMain(out VSOUT vsout, VSIN vsin)
{
    int vId = gl_VertexID;
    vec2 pt = vec2(float(vId & 1), float(vId >> 1));
    vec2 p = vec2(2.0 * pt.x - 1.0, 2.0 * pt.y - 1.0);
    vsout._position = vec4(p, 0.0, 1.0);

    int c;
    for (c=0; c<VS_OUT_S_TEXCOORD; ++c) {
        setTexCoord(vsout, c, pt);
    }
}

#include "framework/glsles/framework_glsles.vert"
